//draws the output graph
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
              

class BatchDrawGraph extends JPanel{
	ArrayList input;
	int graphHieght = 300;
	int graphWidth = 400;
	int hieghest = 0;
	int barWidth;
	int[] freqs1;
	int[] hieghts1;
	//the constructor
	public BatchDrawGraph(ArrayList data){
		createGraphData(data);
		findHieghestValue();
		//find the width of each bar
		barWidth = graphWidth / freqs1.length;
		//find the hieght of the bars, so that they all fit in the window
		hieghts1 = new int[freqs1.length];
		float h = hieghest;
		for(int k = 0; k < hieghts1.length; k++){
			float num = freqs1[k];
			float adjusted = num / h;
			adjusted = graphHieght * adjusted;
			int value = Math.round(adjusted);
			hieghts1[k] = value;
		}
	}
	public void paint(Graphics g){
		Graphics2D g2 = (Graphics2D) g;
		
		int border = 40;
		g2.setColor(Color.white);
		g2.fillRect(0, 0, 480, 380);
		int x = border;
		g2.setColor(Color.black);
		g2.drawLine(40, 20, 40, graphHieght + border + 11);
		//draw the y axis label
		g2.drawString(""+ hieghest, 3, border);
		g2.drawString("0", 3, graphHieght+border);
		g2.drawString("F", 15, (graphHieght/2) -20);
		g2.drawString("r", 15, (graphHieght/2) -10);
		g2.drawString("e", 15, graphHieght/2);
		g2.drawString("q", 15, (graphHieght/2) +10);
		//draw the x axis
		g2.drawLine(35, graphHieght + border, graphWidth+45, graphHieght + border);
		//add its label
		g2.drawString("Class No.", ((graphWidth +border)/2) - 24, graphHieght+border + 30);
		for(int i = 0; i < hieghts1.length; i++){
			//don't forget that the coord system has an inverted y axis
			int y = graphHieght + border - (hieghts1[i]);
			g2.setColor(Color.red);
			//draw a bar
			//add some fancy shading
			g2.setPaint(new GradientPaint(border, border, Color.red, border, graphHieght+border, Color.yellow, false));
			
			g2.fill(new Rectangle2D.Double(x, y, barWidth, hieghts1[i]));
			//draw the outline
			g2.setColor(Color.darkGray);
			g2.draw(new Rectangle2D.Double(x, y, barWidth, hieghts1[i]));
			//g2.fill3DRect( x, y, barWidth, hieghts[i], true);
			g2.setColor(Color.black);
			//add a label on top
			g2.drawString(""+freqs1[i], x+1, y-1);
			g2.drawString(""+ i, x +3, graphHieght +border + 13); 
			x = x + barWidth;
		}
	}
	public void createGraphData(ArrayList results){
		ArrayList aResult = (ArrayList) results.get(0);
		freqs1 = new int[aResult.size()-2];
		for(int i = 0; i< results.size(); i++){
			aResult = (ArrayList) results.get(i);
			int hieghestValue1 = 0;
			int hieghestClass = 0;
			for(int j = 0; j < (aResult.size()-2); j++){
				String s = (String) aResult.get(j);
				Integer I = new Integer(s);
				int value = I.intValue();
				if(value > hieghestValue1){
					hieghestValue1 = value;
					hieghestClass = j;
				
				}
			}
			freqs1[hieghestClass]++;
		}
		
	}
	private void findHieghestValue(){
		int hieghest1 = 0;
		for(int i = 0; i < freqs1.length; i++){
			int temp = freqs1[i];
			if(temp > hieghest1){
				hieghest1 = temp;
			}
		}
		hieghest = hieghest1;
		
	}	
}		
	