import java.util.*;
import java.io.*;
public class Group implements Serializable{
	LinkedList layerList = new LinkedList();
	ArrayList InputPattern = new ArrayList();
	//ArrayList mergedOutput;
	Network net;
	ArrayList groupOutput;
	public Group(Network n){
		net = n;
	}
	public ArrayList getGroupOutput(){
		return groupOutput;
	}
	//add a layer
	public void addLayers(LinkedList l){
		layerList = l;
	}
	
	//distributes and unknown pattern
	public void distributePattern(ArrayList a){
		ArrayList layerOutputs = new ArrayList();
		for(int n = 0; n < layerList.size(); n++){
			Layer l = (Layer) layerList.get(n);
			layerOutputs.add(l.distributePattern((ArrayList) a));
		}
		//System.out.println("Done!");
		merge(layerOutputs);
	}
	public void printGroupOutput(ArrayList a){
		System.out.println("printing output...");
		for(int n = 0; n < a.size(); n++){		
			ArrayList column = (ArrayList) a.get(n);
			for(int m = 0; m < column.size(); m++){
				ArrayList neuronOP = (ArrayList) column.get(m);
				System.out.print(""+neuronOP);
			}
			System.out.println("");
		}
	}
	public void memoryAdjustment(int n, int m, int d){
		for(int x = 0; x < layerList.size(); x++){
			Layer l = (Layer) layerList.get(x);
			l.memoryAdjustment(n, m, d);
		}
	}
	public void merge(ArrayList a){
		//System.out.print("merging layer outputs...");
		float meanTemp = 0;
		int layerNum = a.size();
		int neuronRow = (net.getInputSize())[0];
		int neuronColumn = (net.getInputSize())[1];
		int classNum = net.getNumberOfClasses();
		ArrayList mergedRow = new ArrayList();
		for(int b = 0; b < neuronColumn; b++){
		
			ArrayList mergedColumn = new ArrayList();
			for(int d = 0; d < neuronRow; d++){	
				ArrayList classFreq = new ArrayList();	
				for(int e = 0; e < classNum; e++){
					meanTemp = 0;
					for(int c =0; c < layerNum; c++){
						//System.out.println("row= "+d+", column= "+b+" layer= "+c+" class= "+e);
						meanTemp = meanTemp + getNeuronOutput(a, c, b, d, e);
					}
					meanTemp =meanTemp /layerNum;
					int intMean = Math.round(meanTemp);
					classFreq.add(intMean+"");
				}
				mergedColumn.add(classFreq);
			}
			mergedRow.add(mergedColumn);
		}
		
		adjustMerge(mergedRow);
	}
	public void adjustMerge(ArrayList as){
		//System.out.println("Adjusting merge output");
		int div = net.getNumDivisions();
		float total = 0;
		int layerNum = as.size();
		int neuronRow = (net.getInputSize())[0];
		int neuronColumn = (net.getInputSize())[1];
		int classNum = net.getNumberOfClasses();
		ArrayList adjustedRow = new ArrayList();
		for(int b = 0; b < neuronColumn; b++){
			ArrayList adjustedColumn = new ArrayList();
			for(int d = 0; d < neuronRow; d++){	
				ArrayList classFreq = new ArrayList();	
				total = 0;
				for(int e = 0; e < classNum; e++){
					//System.out.println("row= "+d+", column= "+b+" class= "+e);
					total = total + getNeuronOutput(as, b, d, e);
				}
				//total has been found of frequencies
				for(int e =0; e < classNum; e++){
					//so adjust the merged values
					float value = getNeuronOutput(as, b, d, e);
					float divF = div;
					value = value * (divF/total);
					int result = Math.round(value);
					classFreq.add(result+"");
					
				}
				adjustedColumn.add(classFreq);
			}
			adjustedRow.add(adjustedColumn);
		}
		//System.out.print("Done!");
		//System.out.println("");
		//System.out.println("printing adjusted merge...");
		//printGroupOutput(adjustedRow);
		groupOutput = adjustedRow;
		//adjustMerge(mergedRow);	
		//System.out.println("this has not been implemented yet");	
	}
	public float getNeuronOutput(ArrayList a, int layer, int row, int column, int classNum){
		//gets a neurons output for a particualr class, row , column and layer
		ArrayList layerOutput = (ArrayList) a.get(layer);
		ArrayList neuronRowOutput = (ArrayList) layerOutput.get(row);
		ArrayList neuronColumnOutput = (ArrayList) neuronRowOutput.get(column);
		String neuronClassOutput = (String) neuronColumnOutput.get(classNum);
		Integer f = new Integer(neuronClassOutput);
		int freqTemp = f.intValue();
		float result = freqTemp;
		return result;
	}
	public float getNeuronOutput(ArrayList a, int row, int column, int classNum){
		//same as above except does not use layers
		ArrayList neuronRowOutput = (ArrayList) a.get(row);
		ArrayList neuronColumnOutput = (ArrayList) neuronRowOutput.get(column);
		String neuronClassOutput = (String) neuronColumnOutput.get(classNum);
		Integer f = new Integer(neuronClassOutput);
		int freqTemp = f.intValue();
		float result = freqTemp;
		return result;
	}
}
