.\" use ms macros
.if n \{\
.	nr LL 70n
.	ll 70n
.	nr FL 70n
.	nr LT 70n
.\}
.if t \{\
.	nr PD 0.5v
.	nr PO 1.5i
.	po 1.5i
\}
.ds LF \fBVista Installation Instructions\fP
.ds CF
.ds RF \fBJune 1994\fP
.de Ds
.LP
.KS
.in +4n
.nf
..
.de De
.fi
.in -4n
.KE
..
.de Ip
.LP
.ne 3
\fB\\$1\fP
.br
.IP "" 4n
..
.de Pa
.\" .IP "\fB\\$1\fR (\fB\\$2\fR)" 20n
.Ip "\fB\\$1\fR (\fB\\$2\fR)"
..
.ce 5
\s+3\fBVista Version 2.1\fP\s-3

\s+1\fBInstallation Guide\fP\s-1

Art Pope
University of British Columbia
Vancouver, B.C., Canada
.sp 1
.LP
This document contains instructions for configuring, building, and
installing Vista, a software environment for computer vision research.
Before using these instructions, you should familiarize yourself with Vista
somewhat by reading the contents of the \fBANNOUNCEMENT\fP file.
.NH 1
Overview of the Distribution
.LP
The distribution is organized into the following directories:
.in +2n
.Ip \fBconfig\fP
This directory contains configuration files for use in conjunction with the
\fBimake\fP program. Details are described below.
.Ip \fBdata\fP
This directory contains sample data files. A few are included with the
Vista distribution file. Additional ones are
available separately, by anonymous FTP from the \fB/pub/local/vista/data\fP
directory of \fBftp.cs.ubc.ca\fP.
.Ip \fBdoc\fP
This directory contains LaTeX sources and/or PostScript renditions for
three documents: a brief paper describing Vista, an introduction to
programming with Vista, and a guide to writing software for inclusion in
Vista.
.Ip \fBexamples\fP
This directory contains some programs that illustrate use of the Vista
library.
.Ip \fBinclude\fP
This directory is created automatically during the build process. It will
contain links to header files.
.Ip \fBman\fP
This directory contains man pages for file formats (section 5) and general
topics (section 7). (Man pages for programs and libraries are kept in
subdirectories of \fBsrc\fP, closer to their respective source code files.)
.Ip \fBsrc/base\fP
Subdirectories contain source code for the Vista library, its man pages,
and programs based on the library.
.Ip \fBsrc/camera\fP
Subdirectories contain a library of camera modeling and calibration code,
man pages for the library, and related programs.
.IP \fBsrc/vx\fP
A subdirectory contains source code for the VX library, which aids
development of X Windows applications for image processing. Other
subdirectories contain man pages for the VX library, and programs that use
it.
.IP \fBsrc/X11\fP
This directory contains updates for old versions of the X Window System.
The updates are only needed if you are using Vista under X11R4, or a
version of X11R5 that doesn't have public patch 21 installed.
.in -2n
.NH 1
What's New in Version 2.1
.LP
This section describes changes to Vista since V2.0.2. There is new
functionality as well as bug fixes.  Except where noted, all libraries and
other interfaces are upward compatible with V2.0. There has been no change
in the data file format, which means that new programs will continue to
work with existing data files.
.NH 2
Camera Modeling and Calibration
.LP
V2.1 includes a port of Reg Willson's implementation of Roger Tsai's camera
model and its associated calibration procedure. The calibration software is
available both as a library (\fB-lvcam\fP) and as a standalone program
(\fBvcamcal\fP). A new type, \fBVCamera\fP, models a camera. The library
includes routines for estimating model accuracy, and converting among
world, camera, and image coordinate systems.  See the \fBVCamera\fP(3Vi)
man page.
.NH 2
Optical Flow
.LP
V2.1 includes a port of John Barron's implementation of an optical flow
estimation method due to Bruce Lucas and Takeo Kanade. The implementation
is available both as a library routine (\fBVOptFlowWLS\fP) and as a program
(\fBvflow\fP).  There is both a program (\fBvtops\fP) and a library routine
(\fBVGradientImageToPS\fP) for producing PostScript renditions of optical
flow.
.NH 2
Edge Segmentation
.LP
V2.1 implements David Lowe's algorithm for dividing edges into segments
that can be approximated by straight lines. The implementation is available
both as a library routine (\fBVSegEdgesIntoLines\fP) and as a program
(\fBvsegedges\fP).
.NH 2
Image Display
.LP
There is (we estimate) a roughly fourfold improvement in the speed of image
display.
.LP
All of the image display programs now accept a \fB-palette\fP option for
specifying the set of display colors to use. You can use this option to
speed up and/or improve the quality of image display. (On a 24-bit Sun
display, for example, grayscale images are displayed about twice as fast
with \fB-palette\ gray\fP versus the default.)
.LP
The \fBvxviewi\fP image display program has been upgraded. It now shows
movies, and has commands for going to the first and last frame of the
current image.  It also now informs the window manager of its preferred
aspect ratio so that resizing is faster. The \fB-colormap\fP option has
been renamed \fB-palette\fP for consistency with other Vista programs (an
incompatible change).
.LP
A new routine, \fBVForkImageDisplay\fP, forks a process to independently
display an image. This, for example, allows your program to display
intermediate images using \fBvxviewi\fP while proceeding with its
calculations.
.LP
Routines for establishing \fBVColormaps\fP have been enhanced so that they
can be used by Motif-based program. There are now routines for mapping
colors to pixel values. See the \fBVColormap\fP(3Vi) man page.
.NH 2
VX Changes
.LP
The VX package has been placed in a separate library, \fB-lvx\fP, which
must be included before \fB-lvista\fP.
.LP
All VX-based programs now inherit a \fB-palette\fP option like that of
\fBvxviewi\fP, described above.
.LP
There is a new VX routine, \fBVXReportValidOptions\fP, for reporting the
options parsed by VX.
.NH 2
Other New Features
.LP
The \fBplaintov\fP, \fBpnmtov\fP, \fBvcatbands\fP, and \fBvcomplex\fP
programs now accept a \fB-name\fP option for naming the created image.
.LP
A new program, \fBvblur\fP, degrades an image by reducing its contrast,
blurring it, and adding Gaussian noise.
.LP
New options for the \fBvcatband\fP program allow band interpretation
attributes to be set. There is a new routine, \fBVSetBandInterp\fP, for
setting band interpretation attributes.
.LP
The \fBvconvolve\fP program will now convolve with a 3D mask, and it has
additional methods of treating border pixels (\fB-pad\ none\fP and 
\fB-pad\ trim\fP).  Similar enhancements have been made to the 
\fBVConvolveImage\fP routine. There is a new routine, 
\fBVConvolveImageSep\fP, for convolving images with separable filters.
.LP
The \fBvgauss\fP program now takes an option for specifying the size of
Gaussian filter to use. The \fBVGaussianConvolveImage\fP routine takes an
additional argument specifying filter size (this is an incompatible
change). There are new routines for generating Gaussian kernels (see
\fBVKernel\fP(3Vi)), and for computing spatiotemporal derivatives
(\fBVImageGradientSeq\fP).
.LP
The \fBvlayout\fP and \fBvtops\fP programs now accept an \fB-eps\fP option
determining whether regular or Encapsulated PostScript is produced.
PostScript produced by \fBvtops\fP is now more concise, and less likely to
cause problems when embedded in other documents. Any \fB%%EOF\fP,
\fB%%Page\fP, and \fB%%Pages\fP comments are now stripped by \fBvlayout\fP.
The \fB-widths\fP option of vtops has been renamed \fB-linewidths\fP to
distinguish is from \fB-width\fP (an incompatible change).  The
\fBVBeginPSDoc\fP and \fBVBeginVPSDoc\fP routines now take an additional
argument, \fItitle\fP, supplying a title for a \fB%%Title\fP comment (an
incompatible change).
.LP
The \fBvscale\fP program will now scale edge sets as well as images. It has an
additional option allowing images to be subsampled without averaging pixel
values. This subsampling method is also available as a library routine
(\fBVSampleImage\fP). 
.LP
A new program, \fBvselbands\fP, selects specified bands from multi-band images.
.LP
A new program, \fBvsynth\fP, synthesizes images containing patterns or
random noise. There are also new library routines for synthesizing images
(see \fBVPatternImage\fP(3Vi) and \fBVNoiseImage\fP(3Vi)) and filling
images with constants (\fBVFillImage\fP).
.LP
There is new software to simplify the task of supplying moderate numbers of
parameters to programs. A set of parameter names, values, and descriptions
may be collected into a single file whose format is described by
\fBVpd\fP(5Vi).  A compiler, \fBvpdc\fP(1Vi), processes the file to produce
a header file that can be included by C programs needing those parameters.
Library routines allow the program to obtain new, overriding values for the
parameters from program options and Vista data files.
.LP
The library defines new macros for specifying constants of a desired type
in a platform-independent way (see \fBVConst\fP(3Vi)). A typedef now exists
for the filter procedure argument to \fBVReadFile\fP. There are new
routines for opening a file with error checking (\fBVOpenInputFile\fP and
\fBVOpenOutputFile\fP), and for printing command line options
(\fBVPrintOptions\fP and \fBVPrintOptionValue\fP).  The behavior of
\fBVMalloc\fP, \fBVRealloc\fP, etc., is now fully defined for zero and
\fBNULL\fP arguments.
.LP
Definitions of \fBVErrorHandler\fP and \fBVWarningHandler\fP have been
changed from pointers to functions, to functions so that they can be used
for prototype and extern declarations (this is an incompatible change).
.LP
There are new macros that allow one to save and restore a \fBVList\fP's
current position (see \fBVList\fP(3Vi)).
.LP
Restrictions on the length and character sets of attribute names have been
loosened (see \fBVfile\fP(5Vi)). Attribute names can be up to 256 characters
long, and they may contain any characters except \fB}\fP, \fB^\fP, \fB:\fP,
space, tab, or newline.
.LP
More data files, including camera models and image sequences, have been
included with the distribution or made available on the FTP server.
.NH 2
Improved Portability
.LP
Some things that were formerly of type \fBint\fP in the library are now
declared to be \fBsize_t\fP for better conformance with ANSI C. Affected
are arguments to \fBVCopy\fP, \fBVZero\fP, \fBVMalloc\fP, \fBVRealloc\fP,
\fBVCalloc\fP, \fBVCreateBundle\fP, \fBVPackData\fP, \fBVUnpackData\fP, and
the EncodeData and DecodeData methods (see \fBVtype\fP(3Vi)); also results
returned by \fBVOffset\fP, \fBVOffsetOf\fP, \fBVNumber\fP,
\fBVPixelSize\fP, \fBVImageSize\fP, and \fBVRepnSize\fP. On systems where
\fBsize_t\fP is not defined as \fBint\fP, this amounts to an incompatible
change.
.LP
The standard routines \fBmemcpy\fP() and \fBmemset\fP() are now used
instead of the nonstandard \fBbcopy\fP() and \fBbzero\fP().
.LP
In man pages, \fB.LP\fP has been replaced by \fB.PP\fP, which seems to be
more widely recognized.
.LP
All instances of \fB#pragma\ once\fP have been removed from header files.
This \fB#pragma\fP was recognized by V1 of the \fBgcc\fP compiler, but
complained about by V2.
.LP
Static functions now have prototypes that declare them as such, eliminating
another source of \fBgcc\fP V2 complaints.
.LP
Most platform dependencies are now isolated to a single header file,
\fBsrc/base/lib/os.h\fP.
.NH 2
Bug Fixes
.LP
We fixed a program associated with \fBVImageView\fP widget's busy cursor. The
problem caused image display programs to produce a ``BadAlloc'' X protocol
error when used with some servers.
.LP
We fixed a \fBVReportValidOptions\fP bug that affected printing of multi-value
options.
.LP
We fixed a dithering bug that affected images with SByte, Short, and Long
pixels, sometimes causing a segmentation fault or incorrect display.
.LP
The \fBvfft\fP program now takes an \fB-in\fP option without confusing it
with \fB-inverse\fP.
.LP
We fixed a bug in the way \fBvtops\fP reported bounding boxes for landscape
orientation. Bounding box dimensions are now rounded to integers.
.LP
\fBVReadPnm\fP, when reading a raw PPM file containing an RGB color image,
would create a Vista image with \fBnframes:\ 3\fP (as well as 
\fBncolors:\ 3\fP).  It now creates the image with just \fBnframes:\ 1\fP.
.LP
We included fixes for two \fBVLinkImage\fP problems, including one that
corrupted dynamic memory allocation.
.LP
A missing section has been restored to the \fBvxview\fP(1Vi) man page.
.NH 1
Requirements
.LP
Vista is distributed as ANSI C source code. To build it you will need an
ANSI C compiler (we use the GNU project's \fBgcc\fP), Release 4 or 5 of the
X Window System (preferably Release 5 at patch level 21 or later), and
20 to 40 megabytes of disk space (depending on how much of Vista you choose
to build).
.LP
The OSF/Motif widget library is needed to build a portion of the Vista
library, and some Vista programs. We've been using V1.1.2 of the OSF/Motif
library. Lacking OSF/Motif, however, it is still possible to build most
Vista software, including a program for displaying images under X Windows.
.LP
Vista conforms almost completely to the relevant ANSI C, POSIX.1, and
X/Open Portability Guide interfaces. The departures are:
.IP \(bu 2n
Some filenames are longer than the UNIX System V Release 3 limit of 14
characters. Most platforms now accept the longer filenames.
.IP \(bu
Many C external names need more than the minimum 6 characters of
significance that ANSI C guarantees. Most platforms now allow the longer
external names.
.IP \(bu
A few non-standard C library routines, such as \fBrint()\fP and
\fBffs()\fP, are used.  These are available on most platforms.
.LP
Like the X Window System, Vista uses the \fBimake\fP facility to configure
the build and installation procedures for a particular site and machine
architecture. You will need the \fBimake\fP and \fBmakedepend\fP tools
distributed with X11. These tools are available by anonymous FTP from
\fBftp.x.org\fP.
.LP
The distribution is shipped in compressed form. To uncompress it, you will
need the GNU project's \fBgunzip\fP program. It's available from
\fBprep.ai.mit.edu\fP in the tar file \fB/pub/gnu/gzip-\fIxxx\fB.tar\fR.
.NH 1
Installation Instructions
.LP
We have built and tested the software on the following systems at UBC:
.IP "" 4n
HP-UX 9.01 on an HP 9000/720 using HP's C compiler, \fBcc\fP
.IP ""
IRIX 4.0.4 using Silicon Graphics' C compiler, \fBcc\fP 
.IP ""
SunOS 4.1 on a SPARCstation 2 using version 2.5.4 of the GNU C compiler, 
\fBgcc\fP
.IP ""
Solaris 2.3 on a SPARCstation 10 using both \fBgcc\fP V2.5.4 and Sun's
SPARCompiler C 3.0. (However, on this system we haven't yet tried to build
the four programs that require the OSF/Motif widget library.)
.fi
.RE
.LP
If you will be installing on one of these systems your task should be
fairly straightforward.
.LP
Others have reported installing the previous version of Vista on Linux and
Ultrix systems; you should have no real trouble building V2.1 on those
systems, either.
.LP
If your system is none of the above, you should read both this section
(section 4) and section 7 before proceeding with the installation.
.NH 2
Unpacking the Distribution
.LP
The distribution comes as a compressed tar file. Since you're reading this
you have probably already succeeded in unpacking it. Here are some
unpacking instructions nevertheless.
.in +2n
.IP 1. 4n
Create a directory to contain the distribution. It can have any name, and
it can be located anywhere in the filesystem. Throughout this and other
Vista documents, this directory will be denoted by the environment variable
\fB$VISTA\fP.
.IP 2.
Unpack the distribution into the \fB$VISTA\fP directory:
.LP
.RS
.nf
.ft B
gunzip -c \fItar-file\fP | ( cd $VISTA; tar xfp - )
.ft
.fi
.RE
.in -2n
.NH 2
Before You Print Documentation
.LP
Some man pages contain printed references to particular files or
directories. During the build process those references will be changed
automatically to refer to the appropriate places in your filesystem,
according to configuration parameters you supply. So if at this stage you
print some documentation in order to look over the system, don't be
discouraged if you see some strange pathnames \(em they will be corrected in
due course.
.NH 2
Setting Configuration Parameters
.LP
You will notice that few of the source code subdirectories contain a
\fBMakefile\fP, but they do contain an \fBImakefile\fP.  The
\fBImakefile\fP is a template file used to create a \fBMakefile\fP
containing build rules and variables appropriate for the target machine.
The \fBMakefile\fP is generated by the program \fBimake\fP, which is
distributed with the X Window System.  Most of the configuration work prior
to building the release is to set parameters so that \fBimake\fP will
generate correct files.
.LP
The directory \fBconfig\fP contains configuration files that control how
the distribution is built.  On systems directly supported by this
distribution, the necessary files are already present in \fBconfig\fP and
only minimal editing of these files should be necessary.  Configuration
files for some additional types of systems have been contributed by others.
These are in the \fBconfig/contrib\fP subdirectory; copy them up to
\fBconfig\fP before using them.
.PP
If your system is not supported by the distribution but it does support the
ANSI C and POSIX.1 standards, then you should be able to build a new
configuration file relatively easily.  Otherwise, edits to many files
throughout the system may be necessary. The edits you're likely to have to
consider are described in section 7.
.LP
The main files to be concerned with in the \fBconfig\fP directory are
\fBsite.def\fP and one of the \fIvendor\fP\fB.cf\fP files.  The
\fBsite.def\fP file should be used for most site-specific configuration
customizations, and the \fIvendor\fP\fB.cf\fP file for customizations
specific to a machine architecture, operating system, or vendor's platform.
Both files contain definitions of parameters. Section 8 of this note
contains a complete list of the parameters involved in configuration. It
also lists the default values given to those parameters that are not
explicitly set in either the \fBsite.def\fP file or the
\fIvendor\fP\fB.cf\fP file.
.LP
The \fBImakefile\fPs, templates, and other configuration files distributed
with Vista are similar to the ones included with X11R5.  So if these
instructions are unclear, you may find it helpful to consult the X11R5
documents on using \fBimake\fP and installing X11R5.
.NH 3
The site.def File
.LP
The \fBsite.def\fP file specifies the locations of directories at your
site and how things should be built to conform to your site's conventions.
Vista is distributed with a \fBsite.def\fP file that defines the parameters
you will most likely have to tailor. You should look over the file and make
any changes that are necessary while consulting section 8 for descriptions
of the parameters.
.LP
The \fBsite.def\fP file included with the distribution does not define all
of the parameters you might conceivably want to set. Some parameters have
been left to take on their default values. You should look over sections
8.1, 8.2, and 8.3 to see if those default values are appropriate for your
site. If they're not, override the defaults by placing definitions in
\fBsite.def\fP. (Don't worry too much if you do not understand what one or
two parameters are for \(em their default values will probably work for
you.)
.LP
The directories where the software will be installed are compiled in to
various programs and files during the build process, so it is important
that you get the configuration correct at the outset. If you change your
mind later, you will want to do a \fBmake Everything\fP to rebuild correctly.
.NH 3 
The vendor.cf File
.LP
If your operating system is SunOS or IRIX, look at, respectively, the
\fBsun.cf\fP or \fBsgi.cf\fP file. As with the \fBsite.def\fP file, you
should edit this file so that it correctly describes the machine on which
you will be building. The parameters most commonly defined in the \fB.cf\fP
files are listed in sections 8.4 and 8.5.
.LP
If your operating system is neither SunOS nor IRIX then there you will need
to create a new \fB.cf\fP file, and perhaps make other changes as well.
Refer to the instructions in section 6 on porting to a new architecture.
.NH 3
Other Files
.LP
A couple of files aren't presently reached by the automatic configuration
process.  You'll have to edit them by hand so that they agree with the
information you have recorded in \fBsite.def\fP. Look at the following
files:
.LP
.in +2n
.B doc/intro/intro.tex
.br
.B doc/contrib/contrib.tex
.IP
The first few lines of each of these LaTeX files contains some
site-specific definitions for the name of your site, and the locations of
some directories. After editing each \fB.tex\fP file, issue a \fBmake\fP
command in its directory to reprocess it with LaTeX and \fBdvips\fP.
.in -2n
.LP
Information on the \fBVlib\fP(7Vi) man page is rather dependent on how
you've configured the installation at your site. Look at the following
file:
.LP
.in +2n
.B man/man7/Vlib.man
.IP
Don't worry about the pathnames appearing in the first few lines \(em they
will be set to the values you specified in the \fBsite.def\fP file when the
software is built. Review the ``Usage'' section, particularly where it
mentions the availability of debugging and profiling version of the
library, and where it mentions the need to include a \fBgcc\fP-related
library. If you specified \fBNO\fP for the configuration option
\fBDebugLib\fP or \fBProfileLib\fP, or if you aren't using \fBgcc\fP to
compile, then you will need to delete some of this material from the
``Usage'' section.
.in -2n
.LP
If you don't have the OSF/Motif widget library you won't be able to build a
portion of the library and a few of the programs. Some man pages, however,
will still make references to those missing routines and programs. Here are
some references you should delete.
.LP
.in +2n
.B man/man7/Vindex.man
.br
.B man/man7/Vista.man
.br
.B man/man7/Vtutorial.man
.IP
Delete mention of the \fBvxview\fP, \fBvxviewe\fP, \fBvxadjust\fP, and
\fBvxcrop\fP programs. They require the OSF/Motif widget library.
.LP
.B man/man7/Vista.man
.br
.B man/man7/Vlib.man
.br
.B man/man7/Vtutorial.man
.IP
Delete mention of the VX library. It requires the OSF/Motif widget library.
.in -2n
.LP
As distributed, the Vista software for generating PostScript documents
assumes that 8.5 by 11 inches is your default page size, and 1 inch
is your default margin width. If you'd like to establish different
defaults, edit the following files:
.LP
.in +2n
.B src/base/lib/PostScript.c
.IP
Edit the \fBmeasures\fP table so that it contains your preferred defaults.
.LP
.B src/base/man/VParsePSOptions.man
.br
.B src/base/pgms/vlayout/vlayout.man
.br
.B src/base/pgms/vlayout/vtops.man
.IP
Edit these man pages so that they document your new defaults rather than
the old ones.
.in -2n
.NH 3
Installing Under Earlier Versions of the X Window System
.LP
Vista prefers Release 5 of the X Window System, with the X11R5 public patch
21 installed. It can, however, be installed under earlier versions of X
Windows. We haven't yet tried it under X11R6.
.NH 4
Fixes to the Xmu library
.LP
If you have X11R4, or if you have X11R5 without public patch 21 installed,
then your Xmu library has bugs that will plague Vista programs. Public
patch 21 fixed those bugs. Included in the \fBsrc/X11/XmuR5\fP
directory of the distribution is the portion of the Xmu code containing the
fixes.  Setting the \fBHasXmuFixes\fP configuration parameter in the
\fBsite.def\fP file to \fBNO\fP will cause the fixed Xmu code to be built
into a small library, \fBlibXmuR5.a\fP, which is then linked with Vista
programs to override the buggy Xmu routines.
.LP
The \fBlibXmuR5.a\fP library will also be installed in the library
destination directory (named by the \fBMachineLibDir\fP configuration
parameter in \fBsite.def\fP).  Whenever you link a program that uses the
Vista library's \fBVImageView\fP widget or the VX library, you should
include the new \fBlibXmuR5.a\fP library prior to the standard Xmu library
so that you get the repaired versions of Xmu routines.  You may wish to
edit the user documentation (the \fBVImageView\fP man page in
\fBsrc/base/man\fP, the VX man page in \fBsrc/vx/man\fP, and the
``Introduction to the Vista Library'' document in
\fBdoc/intro/intro.tex\fP) to replace instances of \fB-lXmu\fP with
\fB-lXmuR5\ -lXmu\fP.
.LP
In summary, if you are not running X11R5 with public patch 21 installed,
set \fBHasXmuFixes\fP to \fBNO\fP prior to building Vista, and don't forget
to include \fBlibXmuR5.a\fP when linking programs that use the Xmu library.
.NH 4
Building Under X11R4
.LP
If you have X11R4, your version of X Windows will be missing an X11R5
header file that Vista relies upon: \fBXfuncproto.h\fP. This header file
is needed not only to build Vista, but also to compile programs that use
the Vista library since Vista's header files refer to \fBXfuncproto.h\fP.
.LP
However, we have included \fBXfuncproto.h\fP in the
\fBsrc/X11/include\fP directory of the Vista distribution so that
you can build and use Vista under X11R4. If you are building Vista under
X11R4, specify this directory prior to any other directories in the
\fBStandardIncludes\fP configuration parameter, which is defined in
\fBsite.def\fP. You can specify it like this:
.Ds
\fBStandardIncludes         -I$(TOP)/src/X11/include \fP...
.DE
.LP
When compiling programs that use the Vista library, you will have to ensure
that the header file can be found by the compiler. You can specify
\fB-I$(VISTA)/src/X11/include\fP on the compiler command line, or copy the
header file into a directory the compiler already searches (e.g.,
\fB/usr/include/X11\fP).  If you keep the header file in a non-standard
directory, you may wish to edit the user documentation (the \fBVlib\fP man
page in \fBman/man7\fP, the VX man page in \fBsrc/vx/man\fP,
and the ``Introduction to the Vista Library'' document in
\fBdoc/intro/intro.tex\fP) to mention the additional \fB-I\fP option
needed by those compiling against the Vista library.
.LP
One feature not available under X11R4 is the editres protocol. You will not
be able to use the X Window System's \fBeditres\fP program to dynamically
modify the appearance of Vista applications, such as \fBvxadjust\fP and
\fBvxview\fP.
.NH 2
Typing ``make World''
.LP
One more piece of information is required before building, at least on some
systems: bootstrap flags.  Look in your \fB.cf\fP file for a line of the
form
.Ds
.B "#define BootstrapCFlags \fIvalue\fP"
.De
.LP
If there isn't one things are simple; otherwise things are only slightly
more complicated.  If there is more than one (for example, in any
\fBibm.cf\fP, \fBmoto.cf\fP, or \fBsony.cf\fP file you may have copied from
the X Window System distribution), then you need to select the right one; 
it should be pretty obvious
by the grouping according to operating system type.  Note that on A/UX you
only need this value if you are using \fBgcc\fP, and that on a Sun you only
need this value if you are using an earlier version of the operating
system.
.LP
If no value is required on your system, you can \fBcd\fP to the \fB$VISTA\fP
directory and start the build with:
.Ds
.B "make World >& world.log"
.De
.LP
If a value is required, start the build with:
.Ds
.ft B
make World BOOTSTRAPCFLAGS="\fIvalue\fP" >& world.log
.ft
.De
.LP
You can call the output file something other than \fBworld.log\fP, but do not
call it \fBmake.log\fP because files with this name are automatically deleted
during the ``cleaning'' stage of the build.
.LP
Because the build can take a half-hour to complete, you will probably want
to run it in the background and keep a watch on the output.  For example:
.Ds
.B "make World >& world.log &"
.B "tail -f world.log"
.De
.LP
Note that \fBmake World\fP compiles everything in directories beneath
\fB$VISTA\fP, but it doesn't install anything.  If something goes wrong,
the easiest thing is to just start over (typing \fBmake World\fP again)
once you have corrected the problem.  It is possible that a failure will
corrupt the top-level \fBMakefile\fP.  If that happens, simply delete the
file and recreate a workable substitute with:
.Ds
.B "cp Makefile.ini Makefile"
.De
.LP
When the build completes, examine the \fBworld.log\fP file for errors.  If
you search for `:' (colon) characters, and skip the obvious compile lines,
it is usually pretty easy to spot any errors.
.NH 2
Installing
.LP
Although it is possible to test the release before installing it, it is a
lot easier to test after it has been installed.  If everything is built
successfully, you can install the software by typing the following from the
\fB$VISTA\fP directory (provided you have the necessary filesystem
permissions):
.Ds
.B "make install >& install.log"
.De
.LP
Again, you might want to run this in the background and use \fBtail\fP
to watch the progress.
.LP
You can install the man pages by typing the following from the \fB$VISTA\fP
directory:
.Ds
.B "make install.man >& man.log"
.De
.NH 2
Troubleshooting
.LP
On SunOS 4.1 systems, you may find that the symbols
\fB_get_wmShellWidgetClass\fP and \fB_get_applicationShellWidgetClass\fP
are left undefined when you link X11 clients. This is apparently due to a
shared-library bug in \fBld\fP that conflicts with the way the shared Xmu
library is built. A workaround is to compile with 
.B "-Bstatic\ -lXmu\ -Bdynamic"
(for \fBcc\fP) or \fB-static\fP (for \fBgcc\fP). To use this
workaround when building Vista, add the options to the \fBXtClientLibs\fP
definition in \fBsun.cf\fP.
.LP
If an X-based Vista program like \fBvxview\fP fails with a ``BadMatch'' X
protocol error on an \fBX_CreateWindow\fP request, it may be a sign that
the program was linked with a buggy version of the Xmu library.  The buggy
library creates standard colormaps with inconsistent choices of colormap
and visual. The bug was fixed by X11R5's public patch 21 but it is present
in earlier versions of X11, including X11R4, OpenWindows 3.0, and IRIX
4.0.4. For a workaround, see section 3.3.4.1, ``Fixes to the Xmu library''.
.NH 1
Rebuilding the Release
.LP
You shouldn't need this right away, but eventually you are probably going
to make changes to the sources.  If only C source files are changed, you
should be able to rebuild just by going to the \fB$VISTA\fP directory and
typing:
.Ds
.B "make >& make.log"
.De
.LP
If configuration files are changed, the safest thing to do is to type:
.Ds
.B "make Everything >& every.log"
.De
.LP
\fBEverything\fP is similar to \fBWorld\fP in that it rebuilds every
\fBMakefile\fP, but unlike \fBWorld\fP it does not delete the
existing objects, libraries, and executables, and only rebuilds
what is out of date.
.LP
Note that in both kinds of rebuilds you do not need to supply the
\fBBootstrapCFlags\fP value any more \(em the information is already recorded.
.NH 1
Getting Started Using Vista
.LP
The section 7 man pages, particularly \fBVtutorial\fP(7Vi) and
\fBVista\fP(7Vi), are an appropriate place to start learning how to use
Vista. A few sample data files are included with the distribution in
\fBdata\fP, and more are available from \fBftp.cs.ubc.ca\fP
in the directory \fB/pub/local/vista/data\fP.
.LP
For a brief overview of Vista, see the paper in \fBdoc/paper\fP.
.LP
For an introduction to Vista programming, see the document in
\fBdoc/intro\fP.
.LP
We maintain a mailing list of those working with Vista. To subscribe to the
list, send a message to \fBvista-request@cs.ubc.ca\fP.
.NH 1
Porting to a New Architecture
.LP
If your machine and/or operating system are not among those to which Vista
has already been ported then the task of installing Vista will involve some
additional steps. The steps of which we're aware are listed below. Although
we've tried to organize the software so that porting it is as
straightforward as possible, there are bound to be difficulties we have not
anticipated. Don't hesitate to contact us if you need help with a port.
.in +2n
.IP \(bu 2n
Craft your own \fB.cf\fP file. Since the \fBimake\fP facility is used in a
similar fashion to configure both Vista and X11R5, you should be able to
base your new \fB.cf\fP file on the \fB.cf\fP file that was used to
install X11R5 on your system.  However Vista's use of \fBimake\fP is
somewhat simpler than X11R5's. You will be able to delete several
definitions that are specific to X11R5 but not used by Vista. The
definitions to retain are those for the parameters listed in section 8.  A
parameter used in both X11R5 and Vista configuration files is used for the
same purpose in both cases.
.IP \(bu
Edit \fBconfig/Vista.tmpl\fP so that it refers to your new \fB.cf\fP file.
The first part of \fBVista.tmpl\fP determines which \fB.cf\fP file to
include. Since it uses the same method as X11R5's \fBconfig/Imake.tmpl\fP
file you can simply copy the appropriate lines from that file. The lines
are explained in section 9.1 of the X11R5 release notes, and by comments in
\fBVista.tmpl\fP.
.IP \(bu
You should look at the definitions of the numeric types \fBVBit\fP through
\fBVUByte\fP, present in \fBsrc/base/lib/Vlib.h\fP. These types are documented
by the man page \fBman/man7/Vlib.man\fP. Ensure that the definitions are
appropriate for your machine and that each type will have at least the
minimum precision specified by comments in that file.
.IP \(bu
In \fBVlib.h\fP, immediately following those type definitions are
definitions of macros for generating constants of the various types. Ensure
that these macro definitions match the types you've chosen.
.IP \(bu
Ensure that the types \fBVBitPromoted\fP through \fBVUBytePromoted\fP,
appearing next in \fBVlib.h\fP, are also correct for your machine.
\fBVBitPromoted\fP, for example, should be the type that a \fBVBit\fP gets
cast to when passed as an argument to a function lacking a prototype \(em
so if \fBVBit\fP were defined as \fBchar\fP then \fBVBitPromoted\fP should
be \fBint\fP, but if \fBVBit\fP were defined as \fBlong\fP then
\fBVBitPromoted\fP should be \fBlong\fP.
.IP \(bu
If you have to amend the definitions in \fBVlib.h\fP, bracket your
modifications with conditional compilation directives so that they only
apply when \fBVlib.h\fP is being compiled for a specific machine type. For
example:
.Ds
.ft B
.ta 24n
#ifdef cray
typedef int VBit;	/* 0 or 1 */
#else
typedef char VBit;	/* 0 or 1 */
#endif
.ft
.De
.IP \(bu 2n
In Vista data files, numeric types such as \fBVFloat\fP have universal
representations regardless of machine architecture.  Those representations
are as follows:
.in +4n
.IP \fBVUByte\fP 10n
represents an unsigned integer in an 8-bit byte
.IP \fBVSByte\fP
represents a two's-complement integer in an 8-bit byte
.IP \fBVShort\fP
represents a two's-complement integer in two 8-bit bytes
.IP \fBVLong\fP
represents a two's-complement integer in four 8-bit bytes
.IP \fBVFloat\fP
represents a floating-point number in four 8-bit bytes, using IEEE standard
representation
.IP \fBVDouble\fP
represents a floating-point number in eight 8-bit bytes, using IEEE
standard representation
.in -4n
.IP "" 2n
If the definitions you are establishing in \fBVlib.h\fP for the internal
representations of these types are different than their external
representations in data files, you may need to write software to convert
between the two kinds of representation. All conversions are performed by
the library routines \fBVPackData\fP and \fBVUnpackData\fP so your
modifications will be confined to those routines. The source code for them
is in \fBsrc/base/lib/PackData.c\fP. Their man page is
\fBsrc/base/man/VPackData.man\fP.
.IP \(bu
The program \fBvop\fP, whose source code is in
\fBsrc/base/pgms/vop/vop.c\fP, tries to catch and report exceptions while
performing arithmetic operations on image pixels. To do this it uses some
architecture-specific code. You might review \fBvop.c\fP, and add code that
is appropriate for catching exceptions on your machine.
.IP \(bu
If, when compiling, you find that something is undefined, first consider
adding the necessary \fB#include\fP or other directives to the
\fBsrc/base/lib/os.h\fP header file, since that is where most platform
dependencies are now isolated.
.in -2n
.NH 1
Summary of Configuration Parameters
.LP
This section describes all of the parameters used to configure the software
and to control the build and installation processes. The parameters are
organized here according to purpose. Those listed in sections 8.1, 8.2, and
8.3 are typically set in a \fBsite.def\fP file; those listed in sections
8.4 and 8.5 are typically set in a \fB.cf\fP file.
.LP
Every parameter has a default value, shown here in parentheses, which it
will adopt if no explicit definition is supplied in either the
\fBsite.def\fP or the \fB.cf\fP file. In some cases the default value
depends on other parameters; you may need to consult
\fBconfig/Vista.tmpl\fP to determine what the default value is in those
cases.
.NH 2
Locations of Files and Directories
.in +2n
.Pa BinDir /usr/bin/vista
the directory in which programs are to be installed
.Pa FileManSuffix 5
suffix to be used for installed man pages about file formats
.Pa GenericLibDir /usr/lib
the directory in which architecture-independent libraries and other data
files are to be installed
.Pa IncRoot /usr/include
the directory in which a \fBvista\fP subdirectory of include files is to be
installed
.Pa LibManSuffix 3
suffix to be used for installed library man pages
.Pa LinkerLibDirs \fRnothing\fP
-L options identifying directories in which libraries are to be found
during linking
.Pa LintlibDir MachineLibDir/lint
the directory in which lint libraries are to be installed
.Pa MachineLibDir /usr/lib
the directory in which architecture-dependent libraries are to be installed
.Pa ManRoot /usr/man
the parent of the various \fBman\fP\fIi\fP directories in which man pages
are to be installed
.Pa MiscManSuffix 7
suffix to be used for installed man pages about miscellaneous topics
.Pa PgmManSuffix 1
suffix to be used for installed program man pages
.Pa SourceDir /usr/src/vista
the directory in which the Vista distribution was unpacked (i.e.,
\fB$VISTA\fP)
.Pa XAppLoadDir GenericLibDir/X11/app-defaults
the directory in which application defaults files are to be installed for X
Window System clients
.Pa XBitmapDir /usr/include/X11/bitmaps
the directory in which bitmaps are to be installed for X Window System clients
.Pa XColorDatabase /usr/lib/X11/rgb.txt
the file containing the color database used by the X Window System
.in -2n
.NH 2
Build Behavior
.in +2n
.Pa DebugLib NO
whether to build a \fBlib\fIxxx\fB_d.a\fR version of each library that
includes debugging information
.Pa HasMotif YES
whether you have the OSF/Motif widget library. If you don't have it, you
won't be able to build a portion of the Vista library called the VX package
(see \fBsrc/vx/man/Vx.man\fP). Nor will you be able to build the
\fBvxview\fP, \fBvxviewe\fP, \fBvxadjust\fP, or \fBvxcrop\fP programs.
.Pa HasXmuFixes YES
whether your Xmu library has X11R5's public patch 21 installed. If not (or
if you're using X11R4), set this to \fBNO\fP so that an Xmu excerpt containing
the fixes, called \fBlibXmuR5.a\fP, will be built and installed.
.Pa InstallAppDefFiles YES
whether to install application defaults files for X clients
.Pa ProfileLib NO
whether to build a \fBlib\fIxxx\fB_p.a\fR version of each library that
includes profiling information
.Pa RemoveTargetProgramByMoving NO
whether, when a target program is rebuilt, the old version is saved by
renaming it
.Pa StripInstalledPrograms NO
whether to install with \fBinstall -s\fP
.Pa SupportUbcIff NO
whether software should be built to include support for UBC's old image file
format. Unless you're at UBC, the answer should probably be \fBNO\fP.
.in -2n
.NH 2
Miscellaneous Configuration Parameters
.in +2n
.Pa DefaultPSUnits in
the abbreviation for the default distance unit assumed by
\fBVParsePSDistance\fP routine, and accepted by programs such as
\fBvlayout\fP and \fBvtops\fP. The choices are \fBpt\fP (points), \fBpc\fP
(picas), \fBin\fP (inches), \fBbp\fP (big points, of 1/72 in), \fBcm\fP
(centimeters), \fBmm\fP (millimeters), \fBdd\fP (didot points), \fBcc\fP
(ciceros), \fBsp\fP (scaled points, of 1/65536 \fBpt\fP).
.Pa DefaultPSUnitsName inches
the spelled-out version of the \fBDefaultPSUnits\fP value
.Pa FilesToClean "*.o *.a \fRetc.\fP"
files to remove on \fBmake clean\fP
.Pa NeedDefaultDepLibs YES
whether the make variable \fBLOCAL_LIBRARIES\fP should, by default, be
included in the dependency lists of programs
.Pa Version 2.1
the version number of this Vista release
.in -2n
.NH 2
Operating System Characteristics
.in +2n
.Pa BourneShell /bin/sh
the command used to run the Bourne shell
.Pa ConstructMFLAGS "\fRdepends on\fP SystemV" 
System V option to set \fBMFLAGS\fP make variable
.Pa ExecableScripts "\fRdepends on\fP SystemV"
whether the system can \fBexec() #!/bin/sh\fP
.Pa HasLargeTmp NO
whether the system has lots of \fB/tmp\fP space
.Pa HasSaberC NO
whether the system has Saber C or CenterLine C. Specifying \fBYES\fP adds
to Makefiles some additional targets for loading files into those debugging
tools.
.Pa OSMajorVersion 0
the major version number of the operating system
.Pa OSMinorVersion 0
the minor version number of the operating system
.Pa SystemV NO
whether the operating system is System V, at least Release 2
.Pa SystemV4 NO
whether the operating system is System V Release 4
.in -2n
.NH 2
Program Names and Flags
.in +2n
.Pa ArCmd "ar cq"
the command for creating a library
.Pa BootstrapCFlags \fRnothing\fP
missing cpp symbols needed to get started
.Pa CcCmd "cc \fRor\fP gcc"
the command for running the C compiler
.Pa CpCmd cp
the command for copying a file
.Pa CppCmd /lib/cpp
the command for running the C preprocessor
.Pa DebuggableCDebugFlags -g
C compiler options to produce debugging information
.Pa DefaultCCOptions \fRnothing\fP
extra options that, unless overridden by an \fBImakefile\fP, will be
supplied to the C compiler
.Pa DefaultCDebugFlags OptimizedCDebugFlags
options controlling optimization and the generation of debugging
information that, unless overridden by an \fBImakefile\fP, will be supplied to
the C compiler
.Pa DoRanlibCmd "\fRdepends on\fP SystemV"
whether the operating system uses \fBranlib\fP
.Pa ExtraLibraries \fRnothing\fP
operating system-specific libraries that must be linked with all programs
.Pa ExtraLoadFlags \fRnothing\fP
operating system-specific options needed for linking
.Pa HasGcc NO
whether you want to compile using the GNU C compiler, \fBgcc\fP, or the
vendor's compiler, \fBcc\fP
.Pa HasSunC NO
defined only in the \fBsun.cf\fP configuration file, this parameter
specifies whether you want to compile using Sun's SPARCompiler C compiler
under Solaris 2
.Pa InstBinFlags "-m 0755"
options for installing a script
.Pa InstDatFlags "-m 0444"
options for installing a data file
.Pa InstIncFlags "-m 0444"
options for installing a header file
.Pa InstLibFlags "-m 0664"
options for installing a library
.Pa InstManFlags "-m 0444"
options for installing a man page
.Pa InstPgmFlags "-s"
options for installing an executable program
.Pa InstallCmd install
the command for installing a file
.Pa LdCmd ld
the command for linking a program
.Pa LintCmd lint
the command for running \fBlint\fP
.Pa LintLibFlag "-o \fRor\fP -C"
\fBlint\fP options to produce lint libraries
.Pa LintOpts "-ax \fRor\fP -axz"
\fBlint\fP options to control strictness
.Pa LnCmd "ln -s \fRor\fP ln -s"
the command for creating a link
.Pa MakeCmd make
the command for runing \fBmake\fP
.Pa MkDirHier "$(TOP)/config/util/mkdirhier.sh"
the command for invoking the \fBmkdirhier\fP script distributed with X11R5.
The default finds a copy that is distributed in \fBconfig/util\fP.
Note that a version of \fBmkdirhier\fP distributed with OpenWindows doesn't
work as required by Vista.
.Pa MotifClientLibs "-lXm XtClientLibs"
libraries needed to link programs that use the OSF/Motif widget library
.Pa MvCmd mv
the command for renaming a file
.Pa NoOpCDebugFlags \fRnothing\fP
C compiler options to neither optimize nor produce debugging information
.Pa OptimizedCDebugFlags -O
C compiler options to turn on optimization
.Pa PreProcessCmd "CcCmd -E"
the command for running \fBcpp\fP on a script
.Pa RanlibCmd ranlib
the command for running \fBranlib\fP
.Pa RmCmd "rm -f"
the command for deleting a file
.Pa StandardCppDefines StandardDefines
-D options for running \fBcpp\fP
.Pa StandardDefines "\fRdepends on\fP SystemV"
-D options for running the C compiler
.Pa StandardIncludes \fRnothing\fP
-I options for running the C compiler
.Pa TagsCmd ctags
the command for creating a tags file
.Pa XtClientLibs "-lXt -lXmu -lXext -lX11"
libraries needed to link programs that use the X Toolkit
.in -2n
.NH 1
Acknowledgements
.LP
Contributions in the form of new software, ports to additional platforms,
bug reports, and bug fixes were received from the following people:
Volker Aurich (Heinrich-Heine-Universitaet Duesseldorf),
Esfandiar Bandari (University of British Columbia),
Wilson Burrows (Ohio State University),
Franco Callari (University of Colorado at Boulder),
Uwe Daub (Heinrich-Heine-Universitaet Duesseldorf),
Abby Duh (NASA),
Chuck Dyer (University of Wisconsin),
Ata E. (NASA),
ganz (gateway.cybernet.com),
Karl Geppert (cit.gu.edu.au),
Todd Holland (Oregon State University),
Arun Katkere (University of California at San Diego),
Mike Lawley (cit.gu.edu.au),
Todd Law (nitech.ac.jp),
Gabriele Lohmann (Technische Universitaet Muenchen),
Andrew Naiberg (University of British Columbia),
Thomas Peurach (Cybernet Systems),
Richard Pollock (University of British Columbia),
M. Umasuthan (Heriot-Watt University),
and Mark Wheeler (Carnegie-Mellon University).
.NH 1
Small Print
.LP
Since Vista uses the same configuration facility that the X Window System
uses, portions of these instructions have been adapted from the X11R5
release notes, which are copyright 
.if n (c)
.if t \(co 
1991 by the Massachusetts Institute
of Technology. This use of the material is permitted under the copyright
terms as defined by the following notice:
.QP
\s-2Permission to use, copy, modify, and distribute this document for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and that
the name of MIT not be used in advertising or publicity pertaining to this
document without specific, written prior permission. MIT makes no
representations about the suitability of this document for any purpose. It
is provided ``as is'' without express or implied warranty.
.LP
\fIX Window System\fP is a trademark of MIT.
