import java.util.*;
import java.io.*;
class MainLayer implements Layer, Serializable{
	int xInputSize = 0;
	int yInputSize = 0;
	ArrayList inputPattern = new ArrayList();
	ArrayList output = new ArrayList();
	int numNeuronInputs = 0;
	//the array to hold the input pattern for each pattern
	ArrayList hotSpots;
	//constructor
	public MainLayer(int x, int y, ArrayList patt){
		//set the input dimensions
		xInputSize = x;
		yInputSize = y;
		//these neurons are 8bit
		numNeuronInputs = 8;
		hotSpots = patt;
		
	}
	//adjust the result from the distrubution
	public void memoryAdjustment(int n, int m, int d){
		//System.out.println("adjusting memory..");
	}
	//distrubute an unknown input pattern
	//this specific class looks at a row of 3 pixels horizontaly
	public ArrayList distributePattern(ArrayList al){
		//System.out.println("a Group2 layer is distributing unknown pattern...");
		//reference pixel is always in the middle
		//this is where the neurons will be implemented algorithmically
		ArrayList layerOutput = new ArrayList();
		//gives the pattern to the neurons in this layer using the 1L1R input
		inputPattern = al;
		for(int row = 0; row < inputPattern.size(); row++){
			ArrayList rowTemp = (ArrayList) inputPattern.get(row);
			ArrayList rowOutput = new ArrayList();
			for(int column = 0; column < rowTemp.size(); column++){
				//this is the data that will be given to the neurons
				ArrayList neuronInput = new ArrayList();
				//then get the other data from the two surrounding neurons as well as the
				//reference pixel
				for(int a = 0; a < numNeuronInputs; a++){
					//this is the data that will be taken from the input image
					//it contains string that represent class freqs
					Coord c = (Coord) hotSpots.get(a);
					int indexX = c.getX();
					int indexY = c.getY();
					if((indexX + column) >= rowTemp.size()){
						//wrap in x
						indexX = (indexX + column) - rowTemp.size();
					}
					else{
						indexX = indexX + column;
					}
					if((indexY + row) >= inputPattern.size()){
						//wrap in y
						indexY = (indexY + row) - inputPattern.size();
					}
					else{
						indexY = indexY + row;
					}	
					ArrayList neuronInputTemp = getInfo(indexX, indexY, inputPattern);
					
					/*int index = column - a;
					if((index) < 0){			
						index = rowTemp.size() -1;
					}
					if(index == rowTemp.size()){
						index = 0;
					}
					*/
					neuronInput.add(neuronInputTemp);
				}
				//this is where the data is passed to the "soft" neurons
				ArrayList columnOutput = averageInput(neuronInput);
				rowOutput.add(columnOutput);
			}
			layerOutput.add(rowOutput);
		}
		//System.out.println("done");
		//System.out.println("printing layer output...");
		//printLayerOutput(layerOutput);
		return layerOutput;	
	}
	//method to get a particuler pixel information from an input image
	private ArrayList getInfo(int x, int y, ArrayList input){
		ArrayList result = new ArrayList();
		ArrayList row = (ArrayList) input.get(y);
		result = (ArrayList) row.get(x);
		return result;	
	}
	// the softneuron implementation
	private ArrayList averageInput(ArrayList input){
		ArrayList output = new ArrayList();
		//for each class
		int numClasses = ((ArrayList) input.get(0)).size();
		for(int j = 0; j < numClasses; j++){
			//for working out the average
			float total = 0;
			//for each pixels value for that class
			for(int i = 0; i < input.size(); i++){
				ArrayList pixelClassValues = (ArrayList) input.get(i);
				String thisClassValue = (String) pixelClassValues.get(j);
				Integer bigI = new Integer(thisClassValue);
				total = total + bigI.floatValue();
			}
			float mean = total / (numClasses);
			int value = Math.round(mean);
			output.add(value+"");
		}	
		return output;
	}
	//print to screen the layers output
	public void printLayerOutput(ArrayList a){
		for(int n = 0; n < a.size(); n++){		
			ArrayList column = (ArrayList) a.get(n);
			for(int m = 0; m < column.size(); m++){
				ArrayList neuronOP = (ArrayList) column.get(m);
				System.out.print(""+neuronOP);
			}
			System.out.println("");
		}
	}
}
