//used to set the input patterns to each layer in a group
import java.io.*;
import java.util.*;
public class NetSetter implements Serializable{
	Network net;
	ArrayList lines = new ArrayList();
	File file1;
	File hotSpotFilePre;
	File hotSpotFileMain;
	int numLayersPre = 2;
	int numLayersMain = 2;
	int numDiv = 100;
	int numIter =100;
	int numGroups = 2;
	int inputXSize = 16;
	int inputYSize = 24;
	String name = "net1";
	//the constructor
	public NetSetter(File f, Network n) throws Exception{
		net = n;
		file1 = f;
		//check the file exists
		if(checkFile()){
			//carry on
			readFile();
			parseLines();
			passParams();
		}
		else{
		//stop the whole app
			System.out.println("file cannot be read or doesn't exist!");
		}	
	}
	//this checks that the file can be read and is available
	private boolean checkFile() throws Exception{
		boolean b = true;
		File fileinfo = file1;
		if(!fileinfo.exists() || !fileinfo.canRead()){
			b = false;
		}
		/*catch(Exception e){
			System.out.println(e.getMessage());
		}
		*/
		return b;
	}
	//read the config file
	private void readFile() throws Exception{
		//try{
			//read the whole file into an array then process it
			BufferedReader reader = new BufferedReader(new FileReader(file1));
			String line = reader.readLine();
			//read the rest of the lines untill a empty one is found and add them to the array
			while(line != null){
				lines.add(line);
				line = reader.readLine();
			}
			reader.close();
			System.out.println("config file reading finished");
		//}
		//catch(Exception e){
		//	System.out.println(e.getMessage());
		//}
	}
	//pass the settings to the network
	private void passParams(){
		net.setParams(name, numGroups, numLayersPre, numLayersMain, numIter, numDiv, inputXSize,
			inputYSize, hotSpotFilePre, hotSpotFileMain);
	}
	//parse the config file
	private void parseLines() throws Exception{
		System.out.println("parseing config file");
		//check used to see if input file is valid
		//look at each line
		int check = 0;
		for(int i = 0; i < lines.size(); i++){
			//match the keyword
			String s = (String) lines.get(i);
			if(s.equals("#name")){
				check++;
				i++;
				name = (String) lines.get(i);
				System.out.println("name parsed");
			}
			if(s.equals("#numGroups")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				numGroups = n.intValue();	
				System.out.println("num groups parsed: "+numGroups);
			}
			if(s.equals("#numLayersPre")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				numLayersPre = n.intValue();	
				System.out.println("numlayers pre parsed: "+numLayersPre);
			}
			if(s.equals("#numLayersMain")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				numLayersMain = n.intValue();	
				System.out.println("num layers main parsed: "+numLayersMain);
			}
			if(s.equals("#numIter")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				numIter = n.intValue();	
				System.out.println("num iter parsed: "+numIter);
			}
			if(s.equals("#numDiv")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				numDiv = n.intValue();	
				System.out.println("num div parsed: "+numDiv);
			}
			if(s.equals("#inputSizeX")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				inputXSize = n.intValue();
				System.out.println("x input parsed: "+inputXSize);	
			}
			if(s.equals("#inputSizeY")){
				check++;
				i++;
				Integer bigI = new Integer((String) lines.get(i));
				Integer n = new Integer((String) lines.get(i));
				inputYSize = n.intValue();
				System.out.println("y input parsed: "+inputYSize);	
			}
			if(s.equals("#hotSpotFilePre")){
				check++;
				i++;
				String s2 = (String) lines.get(i);
				File f = new File(s2);
				if(f.canRead() && f.exists()){
					hotSpotFilePre = f;
					System.out.println("hotSpotFilePre parsed");
				}
				else{
					throw new Exception("error in config file");
				}
					
			}
			if(s.equals("#hotSpotFileMain")){
				check++;
				i++;
				String s3 = (String) lines.get(i);
				File f = new File(s3);
				if(f.canRead() && f.exists()){
					hotSpotFileMain = f;
					System.out.println("hotSpotFileMain parsed");
				}
				else{
					throw new Exception("error in config file");
				}
					
			}
		}
		//wrong number of arguments in file
		if(check != 10){
			System.out.println("error in config file!");
			throw new Exception("incorrect number of arguments in config file");
		}
	}	
}