//the main class for the network
//it sets up the architecture of the network
import java.util.*;
import java.io.*;
import javax.swing.*;

public class Network implements Serializable{
	File configFile;
	File hotSpotFilePre;
	File hotSpotFileMain;
	//list of the layers
	LinkedList layerListPre = new LinkedList();
	LinkedList layerListMain = new LinkedList();
	//are we in training?
	boolean trainingMode = true;
	//the groups
	int divisions = 0;
	ArrayList groups = new ArrayList();
	//Group preGroup = new Group(this);
	//Group mainGroup = new Group(this);
	int numberOfClasses = 1;
	ArrayList trainingSet = new ArrayList();
	ArrayList allClasses = new ArrayList();
	int xInputSize = 0;
	int yInputSize = 0;
	int numLayersPre = 0;
	int numLayersMain = 0;
	int numGroups = 0;
	int numIter = 0;
	String[] classNames;
	//PCN GUI;
	boolean trained = false;
	ArrayList networkRegonitionOP = new ArrayList();
	String netName = "";
	public Network(){
		
	}
	//this is due to no-arg constructor
	public void initNetwork(PCNGui g, File f){
		//GUI = g;
		configFile = f;
		System.out.println("Network is initialising itself...");
		//File afile = new File("inputPatterns.patt");
		try{
			createNetwork();
			
		}catch(Exception e){
			System.out.println(e.getMessage());
			//System.exit(0);
		}
	}
	//gets the networks name
	public String getNetName(){
		return netName;
	}
	public boolean isTrained(){
		return trained;
	}
	public void setGui(PCNGui g){
		//GUI = g;
	}
	//accessor and mutator for the trained classes names
	public void setClassNames(String[] ss){
		classNames = ss;
	}
	public String[] getClassNames(){
		return classNames;
	}
	public void setParams(String name, int groups, int layersPre, int layersMain, int iter, int div,
		int xsize, int ysize, File hsfp, File hsfm){
		netName = name;
		xInputSize = xsize;
		yInputSize = ysize;
		numGroups = groups;
		numLayersPre = layersPre;
		numLayersMain = layersMain;
		divisions = div;
		numIter = iter;
		hotSpotFilePre = hsfp;
		hotSpotFileMain = hsfm;
		//GUI.printToMessageBox("Params set");
		System.out.println("params set");
	}
	//find the hotspots in a pattern config file
	private ArrayList findHotSpots(File f) throws Exception{
		System.out.println("finding hotspots...");
		ArrayList result = new ArrayList();
		//read the lines of the file
		ArrayList lines = new ArrayList();
		try{
			BufferedReader r = new BufferedReader(new FileReader(f));
			String line = r.readLine();
			//System.out.println(line);
			while(line != null){
				lines.add(line);
				line = r.readLine();
				//System.out.println(line);
			}
			r.close();
		}
		catch(Exception e){
			System.out.println(e.getMessage());
		}
		//then find the hotspots
		int count = 0;
		for(int i = 0; i < lines.size(); i++){
			String s = (String) lines.get(i);
			if(s.startsWith("@")){
				//System.out.println("header found "+count);
				ArrayList hotSpotList = new ArrayList();
				i++;
				for(int j = 0; j < 8; j++){
					
					s = (String) lines.get(i+j);
					//parse each string for hotspots. if any is found add them to a 
					//list
					findSpotsSub(s, j, hotSpotList);
					
				}
				if(hotSpotList.size() != 8){
					throw new Exception("missing hotspots (!=8) in input pattern file");
				}
				else{
					//System.out.println("number of spots found for this header ="+hotSpotList.size());
					result.add(hotSpotList);
					count++;
				}
			}
			i++;		
		}
		return result;
	}
	//a sub method used in the above to keep things simple
	private void findSpotsSub(String s, int c, ArrayList as){
		boolean contd = true;
		int index = 0;
		//System.out.println("examining: "+s);
		while(contd){
			index = s.indexOf('#', index);
			//another check is made to check that you can only have 8 hotspots
			if(index == -1){
				contd = false;
			}
			else{
				if(as.size() == 8){
					//System.out.println("max number of hotspots reached, others will be skipped");
					contd = false;
				}
				else{
					//System.out.println("found hotspot at "+index+","+c);
					Coord co = new Coord(index, c);
					//add the hotspot to the list
					as.add(co);
					index++;
				}
			}
		}
	}	
	public void createNetwork() throws Exception{
		//the network setup
		//GUI.printToMessageBox("PCN Running...");
		System.out.println("PCN Running...");
		//GUI.printToMessageBox("Reading config file");
		System.out.println("Reading config file");
		NetSetter ns = new NetSetter(configFile, this);
		//GUI.printToMessageBox("input = "+xInputSize+"x"+yInputSize);
		System.out.println("input = "+xInputSize+"x"+yInputSize);
		//create load the neuron input patterns
		ArrayList preSpotList = findHotSpots(hotSpotFilePre);
		ArrayList mainSpotList = findHotSpots(hotSpotFileMain);
		if((preSpotList.size() < numLayersPre) || (mainSpotList.size() < numLayersMain)){
			System.out.println("!!!!!!!!!!!!!!!!error!!!!!!!!!!!!!");
			throw new Exception("not enough patterns in hotspot file!");
		}
		else{
		//create the amount of groups
		//for(int j = 0; j < numGroups; j++){
			PreGroup g = new PreGroup(this);
			//create the layers and pass the network details to them
			System.out.println("creating "+ numLayersPre+" layers in the pregroup...");
			for(int n = 0; n < numLayersPre; n++){
				//GUI.printToMessageBox("Creating neuron matrices...");
				System.out.print("Creating neuron matrices...");
				ArrayList inputPatTemp = (ArrayList) preSpotList.get(0);
				PreLayer l1 = new PreLayer(xInputSize, yInputSize, inputPatTemp);
				inputPatTemp = (ArrayList) preSpotList.get(n);
				//PreLayer2 l2 = new PreLayer2(xInputSize, yInputSize, inputPatTemp);
				layerListPre.add(l1);
				//layerListPre.add(l2);
				//GUI.printToMessageBox("Done!");
				System.out.print("Done!");
				System.out.println("");		
			}
			//add the layers to the group
			g.addLayers(layerListPre);
			//add the group to the group list
			groups.add(g);
			Group g2 = new Group(this);
			System.out.println("creating "+numLayersMain+" layers in the main group...");
			for(int num = 0; num < numLayersMain; num++){
				//don't actualy think that the size of the input for the second
				//layer matters
				
				ArrayList inputPatTemp2 = (ArrayList) mainSpotList.get(num);
				MainLayer l3 = new MainLayer(xInputSize, yInputSize, inputPatTemp2);
				layerListMain.add(l3);
			}
			g2.addLayers(layerListMain);
			groups.add(g2);
		//}
		}
		System.out.println("Network init finshed!");
	}
	//set all components to training mode
	public void setTrainingMode(boolean b){
		trainingMode = b;
		PreGroup g = (PreGroup) groups.get(0);
		//set the neurons in the first group to training mode if b = true
		g.setTrainingMode(b);
		
	}
	public void setNumberOfClasses(int i){
		numberOfClasses = i;
	}
	public int getNumDivisions(){
		return divisions;
	}
	public int getNumberOfClasses(){
		return numberOfClasses;
	}
	public int[] getInputSize(){
		int[] ints = new int[2];
		ints[0] = xInputSize;
		ints[1] = yInputSize;
		return ints;
	}
	public int getNumGroups(){
		return numGroups;
	}
	public int getNumLayersPre(){
		return numLayersPre;
	}
	public int getNumLayersMain(){
		return numLayersMain;
	}
	public int getNumIter(){
		return numIter;
	}
	public void train(trainThread pm){
		//System.out.println("asking for collection of garbage...");
		//System.gc();
		//the number of training patterns to use for each class
		//int noOfTrainingPatts = 50;
		//GUI.printToMessageBox("training net with patterns...");
		System.out.println(" training net with patterns...");
		System.out.println("number of training sets= "+allClasses.size());
		for(int n = 0; n < numberOfClasses; n++){
			pm.setProg(n);
			ArrayList trainingSetTemp = (ArrayList) allClasses.get(n);
			//distribute the converted pattern to the layers and neurons
			//for(int m = 0; m < trainingSetTemp.size(); m++){
			//get the pre group
			PreGroup g = (PreGroup) groups.get(0);
			//for(int m = 0; m < noOfTrainingPatts; m++){
			System.out.println("Number of training Patterns in this set= "+trainingSetTemp.size());
			for(int m = 0; m < trainingSetTemp.size(); m++){
				
				ArrayList anImage = (ArrayList) trainingSetTemp.get(m);
				//printTrainingPattern(anImage);
				//printTrainingPattern(anImage);
				//GUI.printToMessageBox("distributing pattern "+m+" of class "+n+"...");
				System.out.println("distributing pattern "+m+" of class "+n+"...");
				g.distributePattern(anImage, n);
			}
			
			//adjust the neuron's memory locations
			g.memoryAdjustment(n, trainingSetTemp.size(), divisions);
			//preGroup.memoryAdjustment(n, 10, divisions);
		}
		//GUI.printToMessageBox("done!");
		System.out.print("Done!");
		System.out.println("");
		//GUI.printToMessageBox("Training is complete!");
		System.out.println("Training is complete!");
		trained = true;	
		pm.setFinished();
		///System.out.println("asking for collection of garbage...");
		///System.runFinalization();
		//System.gc();
		//System.out.println("finished gc?");
	}
	//load the training patterns
	public void loadTrainingPatterns(ArrayList trainingData){
		//String[] files = findTrainingClasses();
		//String[] files = { "0tp.dos", "1tp.dos", "2tp.dos", "3tp.dos", "4tp.dos", "5tp.dos",
		//	  	"6tp.dos", "7tp.dos", "8tp.dos", "9tp.dos"};
		//String[] files = { "0tp.dos", "1tp.dos"};
		File[] dirs = new File[trainingData.size()];
		for(int i = 0; i < trainingData.size(); i++){
			String[] dataRow = (String[]) trainingData.get(i);
			File f = new File(dataRow[3]);
			dirs[i] = f;
		}
		
		setNumberOfClasses(trainingData.size());
		System.out.println("no of classes= "+trainingData.size());
		//setNumberOfClasses(1);
		//GUI.printToMessageBox("Reading Training patterns from Disk...");
		System.out.println("reading files from disk...");
		for(int n = 0; n < getNumberOfClasses(); n++){
			File folder = dirs[n];
			loadTrainingSet lts = new loadTrainingSet(folder);
			ArrayList trainingSet = lts.getTrainingSet();
			allClasses.add(trainingSet);
			
		}
		//System.out.println("printing all training sets...");
		//printTrainingSet(allClasses);
		//GUI.printToMessageBox("Loaded "+allClasses.size()+ " training Set(s)");	
		//GUI.printToMessageBox("Creating neuron memory spaces...");
		System.out.println("network creating neuron memory spaces...");
		//create the approiate number of storage spaces in each neuron
		createNeuronMemorySpaces(getNumberOfClasses());
		
	}
	public void resetMem(){
		System.out.println("resetting neuron memory...");
		//GUI.printToMessageBox("resetting neuron memory...");
		//only the first group needs to be wiped
		PreGroup g = (PreGroup) groups.get(0);
		g.resetMem();
		trained = false;
		System.out.println("done!");
		//GUI.printToMessageBox("done!");
		
	}
	//creates the memory spaces in the neurons
	private void createNeuronMemorySpaces(int numberOfClasses){
		System.out.println("creating neuron memory...");
		//GUI.printToMessageBox("creating neuron memory...");
		//only the pregroup has memory spaces as it only one that has neurons
		//for(int i = 0; i < groups.size(); i++){
			System.out.println("size of groups ="+groups.size());
			PreGroup g = (PreGroup) groups.get(0);
			g.createNeuronMemorySpaces(numberOfClasses);
		//}
		System.runFinalization();
		System.gc();
		System.out.println("done!");
		//GUI.printToMessageBox("done!");	
	}
	//show the contents of each of the neurons memory
	public void dumpNeuronMemory(){
		System.out.println("Dumping pre-group memory...");
		PreGroup g = (PreGroup) groups.get(0);
		g.dumpNeuronMemory();
	}
	//print a training pattern
	public void printTrainingPattern(ArrayList al){
		//System.out.println("printing training pattern...");
		for(int m = 0; m < al.size(); m++){
			System.out.println(al.get(m));
		}
	}
	//print a whole training set for a class
	public void printTrainingSet(ArrayList al){
		System.out.println("Printing all training patterns");
		for(int n = 0; n< al.size(); n++){
			System.out.println("Printing set "+n);
			ArrayList pattern = (ArrayList) al.get(n);
			for(int m = 0; m < pattern.size(); m++){
				printTrainingPattern((ArrayList) pattern.get(m));
			}
			System.out.println("");
			//System.out.println("Pattern "+n);
		}
		System.out.println("done");
	}
	//the main method
	public String[] findTrainingClasses(){
		String[] fileList = new String[0];
		try{
           		String inFile = "f:\\java\\";
           		String extension = ".dos";
			File fileInfo = new File(inFile);
			String[] files = fileInfo.list();
			fileList = files;
		}
		catch(Exception e){
			//GUI.printToMessageBox(e.getMessage());
			System.out.println(e.getMessage());
		}	
		return fileList;
	}
	//recognise an unknown pattern
	public void recognise(File f, batchRecogThread pm){
		ArrayList unknownPat = new ArrayList();
		try{
			BufferedReader r = new BufferedReader(new FileReader(f));
			String s = r.readLine();
			while(s != null){
				unknownPat.add(s);
				s = r.readLine();
			}
		}
		catch(Exception e){
			//GUI.printToMessageBox("ERROR! reading unknown pattern "+e.getMessage());
		}
		System.out.println("distributing unknown pattern to first group...");
		//GUI.printToMessageBox("distributing unknown pattern to first group...");
		PreGroup g = (PreGroup) groups.get(0);
		g.distributePattern(unknownPat);
		//get the output from the first group and pass it to the next
		ArrayList unknown = g.getGroupOutput();
		System.out.println("distributing to second group...");
		//GUI.printToMessageBox("Distributing to second group...");
		Group g2 = (Group) groups.get(1);
		for(int i = 0; i < numIter; i++){
			////GUI.printToMessageBox("Iteration "+(i+1)+" of "+numIter);
			//System.out.println("Iteration "+(i+1)+" of "+numIter);
			pm.setProg(i);
			g2.distributePattern(unknown);
			unknown = g2.getGroupOutput();
		}
		//for the time being the recognition output is taken from the top left
		//neuron.
		ArrayList opRow = (ArrayList) unknown.get(0);
		networkRegonitionOP = (ArrayList) opRow.get(0);
		//add some details to the results
		networkRegonitionOP.add(getNetName());
		networkRegonitionOP.add(f);
		System.out.println("Recognition is complete!");
		pm.setFinished();
		////GUI.printToMessageBox("Recognition is complete!");
		
	}
	public ArrayList getRecognitionOP(){
		return networkRegonitionOP;
	}
}
