//tim terry started 22/11/00
import javax.swing.*;
import java.beans.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class PCNGui extends JFrame{
    //the timer for recog time
    Date startTime;
    PCNGui thisGui;
    JMenuBar menuBar1 = new JMenuBar();
    Network net;
    JDesktopPane desktop;
    JTextArea textArea1 = new JTextArea("");
    ImageIcon saveButtonIcon = new ImageIcon("icons/save.gif");
    ImageIcon openButtonIcon = new ImageIcon("icons/open.gif");
    ImageIcon helpButtonIcon = new ImageIcon("icons/helpIcon.gif");
    ImageIcon graphButtonIcon = new ImageIcon("icons/graphIcon.gif");
    HashMap netRecogFilenames = new HashMap();
    //create a file object to store the last open dir
    File currentDir = new File(System.getProperty("user.home"));

    //this must be declared here as they are used by other methods
    final JMenuItem saveNet = new JMenuItem("save", saveButtonIcon);
    final JMenuItem train = new JMenuItem("train");
    final JMenuItem recognise = new JMenuItem("recognition");
    final JMenuItem resetMem = new JMenuItem("Reset memory");
    final JMenuItem saveResults = new JMenuItem("Save", saveButtonIcon);
    final JMenuItem graphResults = new JMenuItem("Graph", graphButtonIcon);
   
    //the sub menus for each of these needed for multi networks
    final JMenu saveNetSub = new JMenu("Save");
    final JMenu trainSub = new JMenu("Train");
    final JMenu recogniseSub = new JMenu("Recognise");
    final JMenu batchRecogniseSub = new JMenu("Batch Recog.");
    final JMenu resetMemSub = new JMenu("Reset Mem");
    final JMenu saveResultsSub = new JMenu("Save");
    final JMenu saveBatchResultsSub = new JMenu("Save batch");
    final JMenu graphResultsSub = new JMenu("Graph");
    final JMenu graphBatchResultsSub = new JMenu("Graph batch");
    //this list hold all the netowrks details
    HashMap networkList = new HashMap();
    HashMap resultsList = new HashMap();
    HashMap batchResultsList = new HashMap();
    //ArrayList fileNameList = new ArrayList();
    public PCNGui() {
        //the constructor
        super("PCN by Tim Terry");
	    thisGui = this;
        //Make the big window be indented 50 pixels from each edge 
        //of the screen.
        int inset = 60;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds(inset, inset, 
                  screenSize.width - inset*2, 
                  screenSize.height- inset*2);
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        //Quit this app when the big window closes.
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                //create the quit dialog box with a question
                final JFrame frame1 = new JFrame();
          	    final JOptionPane optionPane = new JOptionPane(
                    	"Are you sure you want to Quit?",
                    	JOptionPane.QUESTION_MESSAGE,
                    	JOptionPane.YES_NO_OPTION);
		    final JDialog dialog1 = new JDialog(frame1, "Click a button",true);
		    dialog1.setContentPane(optionPane);
		    //add an actionlistener to the buttons of the dialog
		    dialog1.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE); 
		    optionPane.addPropertyChangeListener(new PropertyChangeListener() {
                    	public void propertyChange(PropertyChangeEvent e) {
            			String prop = e.getPropertyName();
            			if (dialog1.isVisible() 
             				&& (e.getSource() == optionPane)
             				&& (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                 			prop.equals(JOptionPane.INPUT_VALUE_PROPERTY)))
            			{
                			//what happens when a button on the exit dialog is clicked
                			dialog1.setVisible(false);
                			int value = ((Integer)optionPane.getValue()).intValue();
					    if (value == JOptionPane.YES_OPTION) {
						    System.exit(0);
					    }
					    else{
					    	//don't close
					    }
            	    		}
        	    	}
    	        });
    	    //make the quit dialog visible
		    dialog1.pack();
		    dialog1.setVisible(true);
            }
        });

        //Set up the GUI.
        desktop = new JDesktopPane(); //a specialized layered pane
        setContentPane(desktop);
        setJMenuBar(createMenuBar());
        //sets the starting state of these components
        saveNet.setEnabled(false);
        train.setEnabled(false);
        recognise.setEnabled(false);
        resetMem.setEnabled(false);
        saveResults.setEnabled(false);
        graphResults.setEnabled(false);
        createMsgBox();
        updateMenus();
        textArea1.setText(textArea1.getText()+"\n"+"System init finished");

        //Make dragging faster:
        desktop.putClientProperty("JDesktopPane.dragMode", "outline");
	}
	//create the message box
	private void createMsgBox(){
		textArea1.setEditable(false);
		textArea1.setText("Java PCN simulation written by Tim Terry 25/11/00 tt9@ukc.ac.uk\n"+"System init...");
		//textArea1.setFont(new Font("Serif", Font.ITALIC, 16));
		textArea1.setLineWrap(true);
		textArea1.setWrapStyleWord(true);
		JScrollPane areaScrollPane = new JScrollPane(textArea1);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(250, 250));
		//called when a new internal window is needed
        	createFrame(areaScrollPane, "System messages", 400, 150, true);
	}
	//update the current working directory
	private void updateCurrentDir(File aFile){
		if(aFile.isDirectory()){
			currentDir = aFile;
		}
		else{
			currentDir = aFile.getParentFile();
		}
	}
	//update the menu bar called after each operation
	private void updateMenus(){
		//update all the menus with respect to this network name.
		//first the saveMenu
		Set keys = networkList.keySet();
		String[] names = new String[keys.size()];
		names = (String[]) keys.toArray(names);
		saveNetSub.removeAll();
		for(int i = 0; i < names.length; i++){
			final JMenuItem item = new JMenuItem(names[i]);
			item.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
                			String itemName = item.getText();
                			//open a dialog box and save the network
                			saveNetwork(itemName);
                		}
                	});
                	saveNetSub.add(item);
		}
		trainSub.removeAll();
		for(int i = 0; i < names.length; i++){
			final JMenuItem item = new JMenuItem(names[i]);
			item.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
                			String name = item.getText();
                			Network netTemp = (Network) networkList.get(name);
                			createFrame(createTrainBox(netTemp), "Train Network: "+ netTemp.getNetName(), 450, 350, false);
                		}
                	});
			trainSub.add(item);
			Network n = (Network) networkList.get(names[i]);
			//disbale this button if the network is already trained
			if(n.isTrained() == true){
				item.setEnabled(false);
			}
		}
		recogniseSub.removeAll();
		for(int i = 0; i < names.length; i++){
			final JMenuItem item = new JMenuItem(names[i]);
			item.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
                			String name = item.getText();
                			Network netTemp = (Network) networkList.get(name);
               				createFrame(createRecogniseBox(netTemp), "Recognise Pattern for: "+ netTemp.getNetName(), 420, 280, false); 			
                			//updateMenus();
                		}
                		
                	});
                	recogniseSub.add(item);
			Network n = (Network) networkList.get(names[i]);
			//disbale this button if the network is already trained
			if(n.isTrained() == false){
				item.setEnabled(false);
			}
		}
		batchRecogniseSub.removeAll();
		for(int i = 0; i < names.length; i++){
			final JMenuItem item = new JMenuItem(names[i]);
			item.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
                			String name = item.getText();
                			Network netTemp = (Network) networkList.get(name);
               				createFrame(createBatchRecog(netTemp), "Batch Recognition for: "+ netTemp.getNetName(), 380, 170, false); 			
                			//updateMenus();
                		}
                		
                	});
                	batchRecogniseSub.add(item);
			Network n = (Network) networkList.get(names[i]);
			//disbale this button if the network is already trained
			if(n.isTrained() == false){
				item.setEnabled(false);
			}
		}
		resetMemSub.removeAll();
		for(int i = 0; i < names.length; i++){
			final JMenuItem item = new JMenuItem(names[i]);
			item.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
                			String name = item.getText();
                			Network netTemp = (Network) networkList.get(name);
                			netTemp.resetMem();
                      			JFrame frameTemp = new JFrame();
					JOptionPane.showMessageDialog(frameTemp, "Memory has been wiped for Network: "+netTemp.getNetName());                			
                			updateMenus();
                		}
                	});
			resetMemSub.add(item);
			Network n = (Network) networkList.get(names[i]);
			if(n.isTrained() == false){
				item.setEnabled(false);
			}
		}
		//now update the results
		Set keys2 = resultsList.keySet();
		String[] names2 = new String[keys2.size()];
		final String[] names21 = (String[]) keys2.toArray(names2);
		
		saveResultsSub.removeAll();
		for(int i = 0; i < names2.length; i++){
			final JMenu subMenu = new JMenu(names2[i]);
			HashMap resultItems = (HashMap) resultsList.get(names2[i]);
			Set keys3 = resultItems.keySet();
			String[] names3 = new String[keys3.size()];
			final String[] names31 = (String[]) keys3.toArray(names3);
			for(int k = 0; k < names31.length; k++){
				final JMenuItem item = new JMenuItem(names3[k]);
				item.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
                				String name = item.getText();
                				//find the correct result from the list
                				ArrayList resultsToSave = findResult(name);
                				saveResults(resultsToSave); 
                			}
                		});
                		subMenu.add(item);
                	}
			saveResultsSub.add(subMenu);
		}
		//now the graph results sub menu 
		graphResultsSub.removeAll();
		for(int i = 0; i < names2.length; i++){
			final JMenu subMenu = new JMenu(names2[i]);
			HashMap resultItems = (HashMap) resultsList.get(names2[i]);
			Set keys3 = resultItems.keySet();
			String[] names3 = new String[keys3.size()];
			final String[] names31 = (String[]) keys3.toArray(names3);
			for(int k = 0; k < names31.length; k++){
				final JMenuItem item = new JMenuItem(names31[k]);
				item.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						String name = item.getText();
                				ArrayList resultsToGraph = findResult(name);
                				graphResults(resultsToGraph, name);
                			}
                		});
                		subMenu.add(item);
                	}
			graphResultsSub.add(subMenu);
		}
		//now update the batch results
		Set bkeys2 = batchResultsList.keySet();
		String[] bnames2 = new String[bkeys2.size()];
		final String[] bnames21 = (String[]) bkeys2.toArray(bnames2);
		
		saveBatchResultsSub.removeAll();
		for(int i = 0; i < bnames2.length; i++){
			final JMenu subMenu = new JMenu(bnames2[i]);
			HashMap bresultItems = (HashMap) batchResultsList.get(bnames2[i]);
			Set bkeys3 = bresultItems.keySet();
			String[] bnames3 = new String[bkeys3.size()];
			final String[] bnames31 = (String[]) bkeys3.toArray(bnames3);
			for(int k = 0; k < bnames31.length; k++){
				final JMenuItem item = new JMenuItem(bnames3[k]);
				item.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
                				String name = item.getText();
                				//find the correct result from the list
                				ArrayList resultsToSave = findBatchResult(name);
                				saveBatchResults(resultsToSave);
                			}
                		});
                		subMenu.add(item);
                	}
			saveBatchResultsSub.add(subMenu);
		}
		graphBatchResultsSub.removeAll();
		for(int i = 0; i < bnames2.length; i++){
			final JMenu subMenu = new JMenu(bnames2[i]);
			HashMap bresultItems = (HashMap) batchResultsList.get(bnames2[i]);
			Set bkeys3 = bresultItems.keySet();
			String[] bnames3 = new String[bkeys3.size()];
			final String[] bnames31 = (String[]) bkeys3.toArray(bnames3);
			for(int k = 0; k < bnames31.length; k++){
				final JMenuItem item = new JMenuItem(bnames3[k]);
				item.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
                				String name = item.getText();
                				//find the correct result from the list
                				ArrayList resultsToGraph = findBatchResult(name);
                				graphBatchResults(resultsToGraph, name);
                				
                			}
                		});
                		subMenu.add(item);
                	}
			graphBatchResultsSub.add(subMenu);
		}	
	}
	//to load a previously created network
	private void loadNetwork(){
		final JFileChooser fc = new JFileChooser(currentDir);
        	int returnVal = fc.showOpenDialog(null);
        	if (returnVal == JFileChooser.APPROVE_OPTION) {
        		File file1 = fc.getSelectedFile();
        		if(file1.canRead()){
        			//recreates a network from a serialised file
        			try{
        				FileInputStream in = new FileInputStream(file1);
					ObjectInputStream s = new ObjectInputStream(in);
					Network createdNet = (Network) s.readObject();
					createdNet.setGui(this);
					JFrame fTemp = new JFrame();
					JOptionPane.showMessageDialog(fTemp, "Network:"+createdNet.getNetName()+" loaded!");
					networkList.put(""+createdNet.getNetName(), (Network) createdNet);
					updateCurrentDir(file1);
                			updateMenus();
                		}
                		catch(Exception e){
                			System.out.println(e.getMessage());
                		}
                		
                	}
        		else{
        			JFrame fTemp = new JFrame();
        			JOptionPane.showMessageDialog(fTemp, "IOError can't read selected file");
        		}
    		} 
    		else {
        		//do nothing
    		}
        }
	//to save a created network
	private void saveNetwork(String netName){
		Network netToSave = (Network) networkList.get(netName);
		final JFileChooser fc2 = new JFileChooser(currentDir);
		//set to appear in the center of the screen (null)
		int returnVal = fc2.showSaveDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
        		File f2 = fc2.getSelectedFile();
        		FileOutputStream file;
			ObjectOutputStream freezer;
        		try{
				//set the gui attibute to null so it won't be serialised
				netToSave.setGui(null);
				file = new FileOutputStream(f2);
				freezer = new ObjectOutputStream(file);
				//save the object
				freezer.writeObject(netToSave);
				freezer.close();
				//set it back
				netToSave.setGui(this);
				updateCurrentDir(f2);
				System.out.println("written network to "+f2.getAbsolutePath());
        		}
        		catch(IOException g){
        			System.out.println("a write error ocured");
        			System.out.println(g.getMessage());
        		}
        		printToMessageBox("PCN saved path= "+ f2.getAbsolutePath()+ "...");
    		}	
		
	}
	//to find a result after being given a name
	private ArrayList findResult(String name){
		ArrayList result = new ArrayList();
		Set keySet1 = resultsList.keySet();
		String[] temp = new String[keySet1.size()];
		String[] keyStrings = (String[]) keySet1.toArray(temp);
		//for all networks
		for(int i = 0; i < keyStrings.length; i++){
			HashMap resultMap = (HashMap) resultsList.get(keyStrings[i]);
			//then find out all the result names
			Set keySet2 = resultMap.keySet();
			String[] temp2 = new String[keySet2.size()];
			String[] resultKeyStrings = (String[]) keySet2.toArray(temp2);
			//look through all these keys to find the one that matches the name given
			//int index = 10000000;
			for(int j = 0; j < resultKeyStrings.length; j++){
				if(name.equals(resultKeyStrings[j])){
					System.out.println("key has been matched and results set!");
					result = (ArrayList) resultMap.get(resultKeyStrings[j]);
				}
			}	
		}
		return result;
	}
	private ArrayList findBatchResult(String name){
		ArrayList result = new ArrayList();
		Set keySet1 = batchResultsList.keySet();
		String[] temp = new String[keySet1.size()];
		String[] keyStrings = (String[]) keySet1.toArray(temp);
		//for all networks
		for(int i = 0; i < keyStrings.length; i++){
			HashMap resultMap = (HashMap) batchResultsList.get(keyStrings[i]);
			//then find out all the result names
			Set keySet2 = resultMap.keySet();
			String[] temp2 = new String[keySet2.size()];
			String[] resultKeyStrings = (String[]) keySet2.toArray(temp2);
			//look through all these keys to find the one that matches the name given
			//int index = 10000000;
			for(int j = 0; j < resultKeyStrings.length; j++){
				if(name.equals(resultKeyStrings[j])){
					System.out.println("key has been matched and results set!");
					result = (ArrayList) resultMap.get(resultKeyStrings[j]);
				}
			}	
		}
		return result;	
	 }
	//create a graph and legend window
	private void graphResults(ArrayList r, String name){
		int index = (r.size()-1);
		System.out.println("array size "+r.size());
		File f = (File) r.get(index);
		String fileName = f.getAbsolutePath();
		drawGraph graphPanel = new drawGraph(r, fileName);
       		createFrame(graphPanel, "Results of PCN:"+name, 485, 410, false);
		createFrame(createLegend(r), "legend:"+name, 195, 240, false);	
	}
	//create a graph and legend window with the specified class names
	private void graphResults(ArrayList r, String name, ArrayList classesNames){
		int index = (r.size()-1);
		System.out.println("array size "+r.size());
		File f = (File) r.get(index);
		String fileName = f.getAbsolutePath();
		drawGraph graphPanel = new drawGraph(r, fileName);
       		createFrame(graphPanel, "Results of PCN:"+name, 485, 410, false);
		createFrame(createLegend(r, classesNames), "legend:"+name, 195, 240, false);	
	}
	private void graphBatchResults(ArrayList resultsToGraph, String name){
		BatchDrawGraph graphPanel = new BatchDrawGraph(resultsToGraph);
		createFrame(graphPanel, "Batch Results of PCN:"+name, 485, 410, false);
		createFrame(createBatchLegend(resultsToGraph), "Batch legend:"+name, 195, 240, false);
	}
	//save a result to a file
	private void saveResults(ArrayList result){
		final JFileChooser fc2 = new JFileChooser(currentDir);
		//set to appear in the center of the screen (null)
		int returnVal = fc2.showSaveDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
        		File f2 = fc2.getSelectedFile();
        		try{
        			updateCurrentDir(f2);
        			writeResultsFile(f2, result);
        		}
        		catch(Exception g){
        			System.out.println(g.getMessage());
        		}
        			//this is where a real application would open the file.
        			printToMessageBox("PCN results saved path= "+ f2.getAbsolutePath()+ "...");
    		}	
	}
	private void saveBatchResults(ArrayList result){
	         final JFileChooser fc2 = new JFileChooser(currentDir);
		//set to appear in the center of the screen (null)
		int returnVal = fc2.showSaveDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
        		File f2 = fc2.getSelectedFile();
        		try{
        			updateCurrentDir(f2);
        			writeBatchResultsFile(f2, result);
        		}
        		catch(Exception g){
        			System.out.println(g.getMessage());
        		}
        			//this is where a real application would open the file.
        			printToMessageBox("PCN results saved path= "+ f2.getAbsolutePath()+ "...");
    		}
	}
	//load a saved results file
	private void loadResultsFile(File f){
		ArrayList lines = new ArrayList();
		try{
			BufferedReader reader1 = new BufferedReader(new FileReader(f));
			//read the file
			String line = reader1.readLine();
			while(!(line == null)){
				lines.add(line);
				line = reader1.readLine();	
			}
			reader1.close();
		}
		catch(Exception e){
			System.out.println(e.getMessage());
		}
		//make some checks
		if(lines.size() >= 11){
			System.out.println("loading saved results file...");
			//now parse the lines
			//find the name of the network
			String firstLine = (String) lines.get(0);
			int n = firstLine.indexOf(',');
			String netName = firstLine.substring(n+1);
			//build the array to pass to the existing methods
			ArrayList loadedResult = new ArrayList();
			for(int i = 10; i < lines.size(); i++){
				String aLine = (String) lines.get(i);
				int position = aLine.indexOf(',', (aLine.indexOf(',')+1));
				String num = aLine.substring(position+1);
				int retVal = 0;
				NumberFormat integerFormatter;
				integerFormatter = NumberFormat.getNumberInstance(Locale.US);
        			integerFormatter.setParseIntegerOnly(true);
        			//check to see if the data in the file can be a number.
        			try {
            				retVal = integerFormatter.parse(num).intValue();
            				loadedResult.add(num); 
        			} 
        			catch (ParseException e) {
            				JFrame frameTemp = new JFrame();
					JOptionPane.showMessageDialog(frameTemp, "Error in loaded file: \n"+f.getAbsolutePath()+
						"\n contains invalid data");
        			}
			}
			//now find out the class names from the file
			ArrayList classNamesList = new ArrayList();
			for(int k = 10; k < lines.size(); k++){
				String aLine = (String) lines.get(k);
				int position = aLine.indexOf(',');
				int pos2 = aLine.indexOf(',', (position + 1));
				String clName = aLine.substring(position +1 , pos2);
				classNamesList.add(clName);
			}
			
			loadedResult.add(netName);
			//add the input file
			String inputFile = (String) lines.get(8);
			n = inputFile.indexOf(',');
			inputFile = inputFile.substring(n);
			File inputF = new File(inputFile);
			loadedResult.add(inputF);
			System.out.println("finished loading saved result! displaying");
			graphResults(loadedResult, netName, classNamesList);
		}
		else{
			JFrame frameTemp = new JFrame();
			JOptionPane.showMessageDialog(frameTemp, "Error in loaded file: \n"+f.getAbsolutePath()+
				"\n wrong number of lines");
		}
	}
	//write a results file
	private void writeBatchResultsFile(File f1, ArrayList results){
		System.out.println("starting to write output file...");
		final ArrayList aResult = (ArrayList) results.get(0);
        	int columns = aResult.size();
		int rows = results.size();
	 	String networkName = (String) aResult.get(aResult.size()-2);
	 	Network net = (Network) networkList.get(networkName);
		final String[] columnHeaders = new String[columns];
		columnHeaders[0] = "NO.";
		columnHeaders[1] = "Input Patt.";
		for(int j = 2; j< columns; j++){
			columnHeaders[j] = (net.getClassNames())[j-2];
		}
	 	final String[][] tableData = new String[rows][columns];
	    	for(int i = 0; i < rows; i++){
			ArrayList aResult2 = (ArrayList) results.get(i);
			File inputFile = (File) aResult2.get((aResult2.size()-1));
			String inputFileName = inputFile.getAbsolutePath();
		        tableData[i][0] = i+"";
			tableData[i][1] = inputFileName;
			for(int k = 0; k < (aResult.size() -2); k++){
				tableData[i][k+2] = (String) aResult2.get(k);
			}
	  	}
	  	
		System.out.println(f1.getAbsolutePath());
		if(!(f1.exists())){
			
		try{
			BufferedWriter writer1 = new BufferedWriter(new FileWriter(f1));
			//write the results in an excell/lotus compatible file
			//first find the network which these results came from
			
			//then get it's stats
			writer1.write("name,"+networkName);
			writer1.newLine();
			writer1.write("numGroups,"+net.getNumGroups());
			writer1.newLine();
			writer1.write("numLayersPre,"+net.getNumLayersPre());
			writer1.newLine();
			writer1.write("numLayersMain,"+net.getNumLayersMain());	
			writer1.newLine();
			writer1.write("inputSizeX,"+net.getInputSize()[0]);
			writer1.newLine();
			writer1.write("inputSizeY,"+net.getInputSize()[1]);
			writer1.newLine();
			writer1.write("numIter,"+net.getNumIter());
			writer1.newLine();
			writer1.write("numDiv,"+net.getNumDivisions());
			writer1.newLine();
			String aRow = columnHeaders[0];
			
			for(int k = 1; k < columnHeaders.length; k++){
				aRow = aRow + ","+ columnHeaders[k];
			}
			writer1.write(aRow);
			writer1.newLine();
			for(int i = 0; i < tableData.length; i++){
				
				String[] rowString = tableData[i];
				aRow = rowString[0];
				for(int j = 1; j < rowString.length; j++){
					aRow = aRow + ","+ rowString[j];		
				}
				writer1.write(aRow);
				writer1.newLine();
			}
			writer1.close();
		}
		
		catch(Exception e){
			System.out.println("A write error occured! "+e.getMessage());
		}
		System.out.println("results file has been saved");
		}
		else{
			System.out.println("file already exists!");
		}
	}
	private void writeResultsFile(File f, ArrayList results){
		System.out.println("starting to write output file...");
		System.out.println(f.getAbsolutePath());
		if(!(f.exists())){
			
		try{
			BufferedWriter writer1 = new BufferedWriter(new FileWriter(f));
			//write the results in an excell/lotus compatible file
			//first find the network which these results came from
			String networkName = (String) results.get(results.size()-2);
			Network net = (Network) networkList.get(networkName);
			//then get it's stats
			writer1.write("name,"+networkName);
			writer1.newLine();
			writer1.write("numGroups,"+net.getNumGroups());
			writer1.newLine();
			writer1.write("numLayersPre,"+net.getNumLayersPre());
			writer1.newLine();
			writer1.write("numLayersMain,"+net.getNumLayersMain());	
			writer1.newLine();
			writer1.write("inputSizeX,"+net.getInputSize()[0]);
			writer1.newLine();
			writer1.write("inputSizeY,"+net.getInputSize()[1]);
			writer1.newLine();
			writer1.write("numIter,"+net.getNumIter());
			writer1.newLine();
			writer1.write("numDiv,"+net.getNumDivisions());
			writer1.newLine();
			File inputFile = (File) results.get(results.size()-1);
			String fileName = inputFile.getAbsolutePath();
			writer1.write("input file,"+fileName);
			writer1.newLine();
			writer1.write("classNo,className,Result");
			String[] netsClassesNames = net.getClassNames();
			for(int i = 0; i < (results.size()-2); i++){
				writer1.newLine();
				String className = netsClassesNames[i];
				writer1.write(""+i+","+className+","+results.get(i));
			}
			writer1.close();
		}
		catch(Exception e){
			System.out.println("A write error occured! "+e.getMessage());
		}
		System.out.println("results file has been saved");
		}
		else{
			System.out.println("file already exists!");
		}
	}
	private JComponent createOnlineHelp(){
		//creates the online help window
		OnlineHelp oh = new OnlineHelp();
		return oh;
	}
	//creates the train dialog
	private JPanel createTrainBox(Network n){
		final Network netTemp = n;
		final ArrayList tableData = new ArrayList();
		//create some panels for the layout
		final JPanel main = new JPanel();
		final JPanel top = new JPanel();
		final JPanel mid = new JPanel();
		mid.setLayout(new GridLayout(0,2));
		final JPanel tablePanel = new JPanel();
		Dimension d = new Dimension(400, 100);
		tablePanel.setPreferredSize(d);
		final JPanel bottom = new JPanel();
		bottom.setLayout(new GridLayout(1,0));
		//needed as the frame seams to change size when it is refreshed
		//frame =450, 350; width = 9, hieght = 33
		main.setPreferredSize(new Dimension(441, 347));
		main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
		//create the components
		final JButton cancelButton = new JButton("Cancel");
		final JButton addButton = new JButton("Add training set");
		addButton.setEnabled(false);
		JLabel dirNameLabel = new JLabel("Training pattern dir:");
		JLabel numTrainingPatts = new JLabel("Number of patterns found:", JLabel.CENTER);
		JLabel className = new JLabel("Name of Class to be trained:", JLabel.CENTER);
		final JLabel tableHeadingLabel = new JLabel("Loaded Training Patterns", JLabel.LEFT);
		
		final JTextField dirNameField = new JTextField("",10);
		dirNameField.setEditable(false);
		final JTextField numTrainingPattsField = new JTextField();
		final JTextField classNameField = new JTextField();
		
		JButton dirNameBrowse = new JButton("Browse", openButtonIcon);
		dirNameBrowse.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
                		//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
				//add the defualt file filter to the file chooser
				//fc.addChoosableFileFilter(new dirFilter());
				//make it that dirs can only be selected
				fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				main.setPreferredSize(new Dimension(441, 317));
        				try{
        					dirNameField.setText(f.getCanonicalPath());
        					updateCurrentDir(f);
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
        				int numFiles = f.listFiles().length;
        				if(numFiles == 0){
        					addButton.setEnabled(false);
        				}
        				else{
        					addButton.setEnabled(true);
        				}
        				numTrainingPattsField.setText(""+numFiles);
        				printToMessageBox("Number of files found: "+numFiles);
    				}
    			}
    		});
		final ArrayList classNamesList = new ArrayList();
		JButton trainButton = new JButton("Train");
		trainButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				printToMessageBox("Training network...");
				if(tableData.size() == 0){
					printToMessageBox("Error! no training data has been entered");
					JFrame fTemp = new JFrame();
                			JOptionPane.showMessageDialog(fTemp, "ERROR! No training details \n"+" please Input some first");					
					main.setPreferredSize(new Dimension(441, 317));
				}
				else{
					//convert the arrayList to a string list to be passed to the network
					String[] namesofclasses = new String[classNamesList.size()];
					for(int j = 0; j < classNamesList.size(); j++){
						namesofclasses[j] = (String) classNamesList.get(j);
					}
					netTemp.setClassNames(namesofclasses);
					//load the patterns
					netTemp.loadTrainingPatterns(tableData);
					//train the network
					System.out.println("Patterns loaded, Training network"); 
					System.out.println("asked for GC");
					System.runFinalization();
					System.gc();
					trainThread tt = new trainThread(netTemp, thisGui);
					startTime = new Date();
					
					tt.run();
					
					
        			}
							
			}
		});
		
		cancelButton.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		//Clear all of the training data contents
                		tableData.clear();
                		closeInternalFrame();
            		}
        	});
		
		addButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				//make a check to see if all data has been entered
				if(classNameField.getText().equals("") || numTrainingPattsField.getText().equals("0")
					|| numTrainingPattsField.getText().equals("") || dirNameField.getText().equals("")){
					printToMessageBox("Error! in training details, please input again");
                			JFrame fTemp = new JFrame();
                			JOptionPane.showMessageDialog(fTemp, "ERROR in training details! \n"+" please Input again");
					main.setPreferredSize(new Dimension(210, 140));
				}
				else{
					Integer i = new Integer(numTrainingPattsField.getText());
					int num = i.intValue(); 
					if((num > 30) || (num < 5)){
						//check the size of the training set
						printToMessageBox("WARNING! training set size is out of preferred range");
						JFrame fTemp = new JFrame();
                				JOptionPane.showMessageDialog(fTemp, "WARNING! Size of training Set n \n"+" is out of advisable range where\n"+
                					"5 < n > 30" );
                			}
					//if so, continue
					//map the class number to a name by adding to the list				
					classNamesList.add(classNameField.getText());
					//build the table data
					String[] row = new String[4];
					row[0] = tableData.size()+"";
					row[1] = classNameField.getText();
					row[2] = numTrainingPattsField.getText();
					row[3] = dirNameField.getText();
					//add the data to the arrayList
					tableData.add(row);
					//convert the training data so that it can be displayed in a JTable
					int numOfCols = ((String[]) tableData.get(0)).length; 
					String[][] data = new String[tableData.size()][numOfCols];
					//String[][] data2 = {{"1", "fgh", "3", "4fhfh"}};
					for(int k = 0; k < tableData.size(); k++){
						String[] s = (String[]) tableData.get(k);
						for(int j = 0; j < s.length; j++){
							data[k][j] = s[j];
						}
					}
					//remove the prevoius table and create the new one
					tablePanel.removeAll();
					trainingTableModel tTM = new trainingTableModel();
					tTM.setData(data);
					JTable trainedClassesTable = new JTable(tTM);
        				JScrollPane scrollPane1 = new JScrollPane(trainedClassesTable);
					trainedClassesTable.setPreferredScrollableViewportSize(new Dimension(400, 80));
					main.setPreferredSize(new Dimension(441, 317));
					tablePanel.add(scrollPane1);
					//refresh
					main.validate();
					classNameField.setText("");
				}
				
			}
		});
		numTrainingPattsField.setEditable(false);
		dirNameField.setEditable(true);
		//add the components to the panels
		top.add(dirNameLabel);
		top.add(dirNameField);
		top.add(dirNameBrowse);
		mid.add(numTrainingPatts);
		mid.add(numTrainingPattsField);
		mid.add(className);
		mid.add(classNameField);
		bottom.add(trainButton);
		bottom.add(cancelButton);
		main.add(top);
		main.add(mid);
		main.add(addButton);
		main.add(tableHeadingLabel);
		main.add(tablePanel);
		//main.add(pBar);
		main.add(bottom);
		return main;
	}
	//called by the progres bar thread when the network has finished training
	public void finishedTraining(Network netTemp){
		Date timeTaken = new Date();
		long time1 = (timeTaken.getTime() - startTime.getTime())/(long) 1000;
		JFrame fTemp2 = new JFrame();
                JOptionPane.showMessageDialog(fTemp2, "The network: "+ netTemp.getNetName()+" has been trained!"+
                	"\n Time Taken: "+time1+"s");
		closeInternalFrame();
		updateMenus();
	}
	//the dialog to recognise a pattern
	private JPanel createRecogniseBox(Network n){
		final Network netTemp = n;
		//create the components
		final JPanel main = new JPanel(new BorderLayout());
		JPanel top = new JPanel();
		JPanel mid = new JPanel();
		JPanel bottom = new JPanel();
		JLabel patternName = new JLabel("FileName", JLabel.CENTER);
		final JTextField patternField = new JTextField(10);
		patternField.setEditable(false);
		final JTextArea picture1 = new JTextArea(8,10);
		picture1.setEditable(false);
		//the standard browse button
		JButton browse = new JButton("browse", openButtonIcon);
		browse.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
		        	//add the defualt file filter to the file chooser
				fc.addChoosableFileFilter(new RecogFileFilter());
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				try{
        					//once a file has been selected
        					//update the dialog
        					patternField.setText(f.getCanonicalPath());
        					main.setPreferredSize(new Dimension (411, 247));
        					updateCurrentDir(f);
                				
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
    				}
           		}
        	});
        	JButton preview = new JButton("Preview");
        	preview.addActionListener(new ActionListener(){
        		public void actionPerformed(ActionEvent e){
        			File f = new File(patternField.getText());
        			String pic = readPattern(f);
                		//update the preview
                		picture1.setText(pic);
        		}
        	});
		JButton recognise = new JButton("Recognise");
		recognise.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		if(patternField.getText().equals("")){
					JFrame fTemp = new JFrame();
                			JOptionPane.showMessageDialog(fTemp, "ERROR! please select a\n"+"pattern to recognise");                			
                		}
                		else{
                			netTemp.setTrainingMode(false);
                			File f = new File(patternField.getText());
               				//fileNameList.add(patternField.getText());
                			//recognise the pattern
                			/*netTemp.recognise(f);
                			
					*/
					thisGui.setEnabled(false);
					System.out.println("starting new thread");
					File[] fs = new File[1];
					fs[0] = f;
					batchRecogThread rt = new batchRecogThread(netTemp, thisGui, fs);
					startTime = new Date();
					rt.run();
            			}
            		}
        	});
        	//the cancel button and its action
		JButton cancel = new JButton("Cancel");
		cancel.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		closeInternalFrame();
            		}
        	});
        	//the preview pane
		JPanel scrollPanel = new JPanel();
		scrollPanel.add(picture1);
		JScrollPane scrollPane1 = new JScrollPane(scrollPanel);
		scrollPane1.setPreferredSize(new Dimension(200, 150));
		top.add(patternName);
		top.add(patternField);
		top.add(browse);
		mid.add(scrollPane1);
		bottom.add(recognise);
		bottom.add(preview);
		bottom.add(cancel);
		main.add(top, BorderLayout.NORTH);
		main.add(mid, BorderLayout.CENTER);
		main.add(bottom, BorderLayout.SOUTH);
		return main;
	}
	//this is called when recognition is finished
	public void finishedRecognisation(Network netTemp){
		Date timeTaken = new Date();
		long time1 = (timeTaken.getTime() - startTime.getTime())/(long) 1000;
		thisGui.setEnabled(true);
		JFrame fTemp2 = new JFrame();
             	JOptionPane.showMessageDialog(fTemp2, "Recognition finished for: "+netTemp.getNetName()+"\n"+"Click 'Graph' on the 'results' menu\n"+
             		"for graphical display"+
             		"\n Time Taken: "+time1+"s");
		closeInternalFrame();
		ArrayList results = netTemp.getRecognitionOP();
		String resultName = "";
		if(resultsList.containsKey(netTemp.getNetName())){
			System.out.println("network has already got a list to hold its results, adding a new result...");
			HashMap tempMap = (HashMap) resultsList.get(netTemp.getNetName());
			resultName = "result"+(resultsList.size()+1);
			tempMap.put(resultName, results);
		}
		else{
			System.out.println("createing new list to hold this network results...");
			HashMap tempMap = new HashMap();
			resultName = "result"+(resultsList.size()+1);
			tempMap.put(resultName, results);
			resultsList.put(netTemp.getNetName(), tempMap);
			
		}
             		updateMenus();
          
			createFrame(createResultsBox(results), "Recognition Results: "+netTemp.getNetName(), 450, 220, false);
	}
	public void finishedBatchRecognisation(ArrayList results, Network netTemp){
	    	Date timeTaken = new Date();
		long time1 = (timeTaken.getTime() - startTime.getTime())/ (long)1000;
		
	    	thisGui.setEnabled(true);
		JFrame fTemp2 = new JFrame();
             	JOptionPane.showMessageDialog(fTemp2, "Recognition finished for: "+netTemp.getNetName()+"\n"+results.size()+
             		" Unknown patterns classified"+
             		"\n Time Taken: "+time1+"s");
		closeInternalFrame();
		String resultName = "";
		if(batchResultsList.containsKey(netTemp.getNetName())){
			System.out.println("network has already got a list to hold its results, adding a new result...");
			HashMap tempMap = (HashMap) batchResultsList.get(netTemp.getNetName());
			resultName = "result"+(batchResultsList.size()+1);
			tempMap.put(resultName, results);
		}
		else{
			System.out.println("createing new list to hold this network results...");
			HashMap tempMap = new HashMap();
			resultName = "result"+(batchResultsList.size()+1);
			tempMap.put(resultName, results);
			batchResultsList.put(netTemp.getNetName(), tempMap);
			
		}
             		updateMenus();
	    createFrame(createBatchResultsBox(results), "Batch recog. Results:"+netTemp.getNetName(), 550, 450, false);
	}
	//create the batch recog dialog
	private JPanel createBatchRecog(Network n){
		final Network netTemp = n;
		final JPanel main = new JPanel();
		main.setLayout(new GridLayout(0,1));
		JPanel top = new JPanel();
		JPanel mid = new JPanel();
		JPanel bottom = new JPanel();
		JLabel numberFilesLabel = new JLabel("No. of files found");
		final JTextField numberFiles = new JTextField(10);
		numberFiles.setEditable(false);
		JLabel path = new JLabel("Path:");
		final JTextField pathField = new JTextField(10);
		final JButton recogAll = new JButton("Recog All");
		recogAll.setEnabled(false);
		recogAll.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				String dir = pathField.getText();
				File f = new File(dir);
				File[] files = f.listFiles(new RecogFileFilterB());
				thisGui.setEnabled(false);
				System.out.println("starting new thread");
				batchRecogThread rt = new batchRecogThread(netTemp, thisGui, files);
				startTime = new Date();
					
				rt.run();			
						
			}
		});
		JButton browse = new JButton("Browse", openButtonIcon);
		JButton cancel = new JButton("Cancel");
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				closeInternalFrame();
			}
		});
		browse.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
                		//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
				//add the defualt file filter to the file chooser
				//fc.addChoosableFileFilter(new dirFilter());
				//make it that dirs can only be selected
				fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				try{
        					pathField.setText(f.getCanonicalPath());
        					updateCurrentDir(f);
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
        				int numFiles = f.listFiles().length;
        				if(numFiles == 0){
        					recogAll.setEnabled(false);
        				}
        				else{
        					recogAll.setEnabled(true);
        				}
        				numberFiles.setText(""+numFiles);
        				printToMessageBox("Number of files found: "+numFiles);
    				}
    			}
    		});
		
		top.add(path);
		top.add(pathField);
		top.add(browse);
		mid.add(numberFilesLabel);
		mid.add(numberFiles);
		bottom.add(recogAll);
		bottom.add(cancel);
		main.add(top);
		main.add(mid);
		main.add(bottom);
		return main;	
	}
	//method for creating the results table
	private JPanel createResultsBox(ArrayList results){
		File inputFile = (File) results.get((results.size()-1));
		String inputFileName = inputFile.getAbsolutePath();
		JLabel fileRecog = new JLabel("Input file= "+inputFileName);
		ArrayList tableData = new ArrayList();
		String networkName = (String) results.get(results.size()-2);
		Network net = (Network) networkList.get(networkName);
		String[] classNames = net.getClassNames();
		JPanel main = new JPanel();
		//build the table data
		System.out.println("networkName="+networkName);
		System.out.println("size of results array="+results.size());
		for(int i = 0; i < (results.size()-2); i++){
			String[] row = new String[3];
			System.out.print(i+"  ");
			row[0] = i + "";
			System.out.print(classNames[i]+"  ");
			row[1] = classNames[i];
			System.out.print((String) results.get(i));
			row[2] = (String) results.get(i);
			//add the data to the arrayList
			tableData.add(row);
			System.out.println("");
		}
		
		//convert the training data so that it can be displayed in a JTable
		int numOfCols = ((String[]) tableData.get(0)).length; 
		String[][] data = new String[tableData.size()][numOfCols];
		for(int k = 0; k < tableData.size(); k++){
			String[] s = (String[]) tableData.get(k);
			for(int j = 0; j < s.length; j++){
				data[k][j] = s[j];
			}
		}
		ResultsTableModel tTM = new ResultsTableModel();
		tTM.setData(data);
		JTable trainedClassesTable = new JTable(tTM);
        	JScrollPane scrollPane1 = new JScrollPane(trainedClassesTable);
		trainedClassesTable.setPreferredScrollableViewportSize(new Dimension(400, 110));
		main.add(fileRecog, BorderLayout.NORTH);
		main.add(scrollPane1, BorderLayout.CENTER);
		
		return main;
	}
	private JPanel createBatchResultsBox(ArrayList results){
        	System.out.println("number of patterns recog.ed="+results.size());
        	JPanel main = new JPanel();
        	final ArrayList aResult = (ArrayList) results.get(0);
        	int columns = aResult.size();
		int rows = results.size();
	 	String networkName = (String) aResult.get(aResult.size()-2);
	 	Network net = (Network) networkList.get(networkName);
		final String[] columnHeaders = new String[columns];
		columnHeaders[0] = "NO.";
		columnHeaders[1] = "Input Patt.";
		for(int j = 2; j< columns; j++){
			columnHeaders[j] = (net.getClassNames())[j-2];
		}
	 	final String[][] tableData = new String[rows][columns];
	    	for(int i = 0; i < rows; i++){
			ArrayList aResult2 = (ArrayList) results.get(i);
			File inputFile = (File) aResult2.get((aResult2.size()-1));
			String inputFileName = inputFile.getAbsolutePath();
		        tableData[i][0] = i+"";
			tableData[i][1] = inputFileName;
			for(int k = 0; k < (aResult.size() -2); k++){
				tableData[i][k+2] = (String) aResult2.get(k);
			}
	  	}
	  	final JTable table = new JTable(tableData, columnHeaders);
	  	JScrollPane scrollPane1 = new JScrollPane(table);
		table.setPreferredScrollableViewportSize(new Dimension(500, 350));
		main.add(scrollPane1, BorderLayout.CENTER);
		return main;		
	}
	//a method for reading the preview image
	private String readPattern(File f){
		String op = "";
		try{
			BufferedReader r = new BufferedReader(new FileReader(f));
			String s = r.readLine();
			while(s != null){
				op = op + s + "\n";
				s = r.readLine();
			}
			r.close();
		}
		catch(Exception e){
			printToMessageBox("ERROR! "+e.getMessage());
		}
		return op;
	}
	//creates the new network config dialog
	private JPanel createConfigBox(){
		//create some panels for the layout
		final JPanel main = new JPanel();
		main.setPreferredSize(new Dimension(421, 390));
		JPanel top = new JPanel();
		JPanel mid = new JPanel();
		mid.setLayout(new GridLayout(0,2));
		JPanel bottom = new JPanel();
		bottom.setLayout(new GridLayout(0,3));
		JPanel last = new JPanel();
		last.setLayout(new GridLayout(0, 2));
		main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
		final JCheckBox check1 = new JCheckBox("Load config from file");
		
		final JLabel divLabel = new JLabel("No. of Divisions:", JLabel.CENTER);
		final JLabel iterLabel = new JLabel("No. of Iterations:", JLabel.CENTER);
		final JLabel layers1Label = new JLabel("No. of Layers in Pre-Group:", JLabel.CENTER);
		final JLabel layers2Label = new JLabel("No. of Layers in Main-Group:", JLabel.CENTER);
		final JLabel configNameLabel = new JLabel("Config Name:", JLabel.CENTER);
		final JLabel xSizeLabel = new JLabel("X input size:", JLabel.CENTER);
		final JLabel ySizeLabel = new JLabel("Y input size:", JLabel.CENTER);
		final JLabel fileName = new JLabel("File:");
		final JLabel netName = new JLabel("Net Name", JLabel.CENTER);
		final JLabel preFileText = new JLabel("Pre Group patt. file:", JLabel.CENTER);
		final JLabel mainFileText = new JLabel("Main Group patt. file:", JLabel.CENTER);
		
		final JTextField filePathField = new JTextField("",20);
		final WholeNumberField divField = new WholeNumberField(100, 10);
		final WholeNumberField iterField = new WholeNumberField(10, 10);
		final WholeNumberField layers1Field = new WholeNumberField(2, 10);
		final WholeNumberField layers2Field = new WholeNumberField(2, 10);
		final WholeNumberField xSizeField = new WholeNumberField(16, 10);
		final WholeNumberField ySizeField = new WholeNumberField(24, 10);
		final JTextField configNameField = new JTextField("");
		final JTextField netNameField = new JTextField("");
		
		JPanel top2 = new JPanel();
		JPanel mid2 = new JPanel();
		
		final JLabel pathLabel = new JLabel("Pattern File:", JLabel.CENTER);
		final JTextField pattsPath = new JTextField(15);
		pattsPath.setEditable(false);
		final JButton browse3 = new JButton("browse", openButtonIcon);
		browse3.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
		        	//add the defualt file filter to the file chooser
				//fc.addChoosableFileFilter();
				fc.addChoosableFileFilter(new inputPattFilter());
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				try{
        					//once a file has been selected
        					//update the dialog
        					pattsPath.setText(f.getCanonicalPath());
        					updateCurrentDir(f);
        					main.setPreferredSize(new Dimension (421, 390));
        					
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
    				}
           		}
        	});
        	final JTextField preFileField = new JTextField();
        	final JTextField mainFileField = new JTextField();
        	preFileField.setEditable(false);
        	mainFileField.setEditable(false);
        	final JButton setAsPreButton = new JButton("Set Pre");
        	setAsPreButton.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		preFileField.setText(pattsPath.getText());
                	}
                });
        	final JButton setAsMainButton = new JButton("Set Main");
        	setAsMainButton.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		mainFileField.setText(pattsPath.getText());
                	}
                });
        	        	
        	JButton createNet = new JButton("Create");
		final JButton browse = new JButton("Browse", openButtonIcon);
		final JButton browse2 = new JButton("Location", saveButtonIcon);
		browse.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                	//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
				//add the defualt file filter to the file chooser
				fc.addChoosableFileFilter(new CFGFileFilter());
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				try{
        					main.setPreferredSize(new Dimension(421, 390));
        					filePathField.setText(f.getCanonicalPath());
        					updateCurrentDir(f);
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
    				}
           		}
        	});
        	browse2.addActionListener(new ActionListener() {
          		public void actionPerformed(ActionEvent e) {
                	//Create a file chooser
				final JFileChooser fc2 = new JFileChooser(currentDir);
				//add the defualt file filter to the file chooser
				fc2.addChoosableFileFilter(new CFGFileFilter());
				int returnVal = fc2.showSaveDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        				File f2 = fc2.getSelectedFile();
        				try{
        					main.setPreferredSize(new Dimension(421, 390));
        					configNameField.setText(f2.getCanonicalPath());
        					updateCurrentDir(f2);
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("PCN CFG save path= "+ f2.getAbsolutePath()+ "...");
    				}
            		}
        	});
		createNet.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		if(check1.isSelected()){
                			File f = new File(filePathField.getText());
                			if(f.canRead() && f.exists()){
                			    Network net1 = new Network();
                			    try{
                			    	net1.initNetwork(thisGui, f);
                			    	System.out.println("network has been initiated");
                			    	networkList.put(""+net1.getNetName(), (Network) net1);
                			    	JFrame fTemp2 = new JFrame();
                			    	JOptionPane.showMessageDialog(fTemp2, "The network: "+ net1.getNetName()+" has been created!");
                			    	updateMenus();
                			    	closeInternalFrame();
                			    	saveNet.setEnabled(true);
            	                	    	train.setEnabled(true);
            	                	    }catch(Exception ex){
            	                	    	JFrame fTemp2 = new JFrame();
                				JOptionPane.showMessageDialog(fTemp2, "ERROR reading inputted info! \n"+ex.getMessage());
                			    }
                			}
                			else{
                			    printToMessageBox("Error! reading "+filePathField.getText());
                			    JFrame fTemp = new JFrame();
                			    JOptionPane.showMessageDialog(fTemp, "ERROR reading selected file! \n"+" please select another");
                			    main.setPreferredSize(new Dimension(421, 390));
                			}
             
                		}
                		//else create the config file from the data entered and pass it to the net
                		else{             		    
                		    boolean bError = false;
                		    //check split into two to help reading
                		    if(configNameField.getText().equals("") || layers1Field.getText().equals("") || layers2Field.getText().equals("")){
                                 	bError = true;
                		    }
                		    if(xSizeField.getText().equals("") || ySizeField.getText().equals("") || iterField.getText().equals("") || divField.getText().equals("")){
                		        bError = true;
                		    }
                		    if(netNameField.getText().equals("")){
                		    	bError = true;
                		    }
                		    if((preFileField.getText().equals("")) || (mainFileField.getText().equals(""))){
                		    	bError = true;
                		    }
                		    Set keys = networkList.keySet();
				    String[] names = new String[keys.size()];
				    names = (String[]) keys.toArray(names);
				    for(int k = 0; k < names.length; k++){
					String g = names[k];
					if(netNameField.getText().equals(g)){
						bError = true;
						
                		    	}
				    }
                		    if(bError){
                		        JFrame fTemp2 = new JFrame();
                			JOptionPane.showMessageDialog(fTemp2, "ERROR reading inputted info! \n"+" Not all data has been entered or name already in use");
                		    }
                		    		
                		    else{    
                		        //writeconfigfile method will check the data inputed
                		        writeConfigFile(netNameField.getText(), configNameField.getText(), "2", layers1Field.getText(), layers2Field.getText(),
                		            xSizeField.getText(), ySizeField.getText(), iterField.getText(), divField.getText(), preFileField.getText(), mainFileField.getText());
            	                	JFrame fTemp2 = new JFrame();
                			JOptionPane.showMessageDialog(fTemp2, "The network: "+ netNameField.getText()+" has been created!");
            	                	closeInternalFrame();
            	                	saveNet.setEnabled(true);
            	                	train.setEnabled(true);
            	                	
                		    }
                		}
                   }
        	});
		JButton cancelNet = new JButton("Cancel");
		cancelNet.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		closeInternalFrame();
            		}
        	});
        	check1.addActionListener(new ActionListener() {
        		public void actionPerformed(ActionEvent e){
        			if(check1.isSelected()){
        				fileName.setEnabled(true);
        				configNameField.setEnabled(false);
        				configNameLabel.setEnabled(false);
        				browse.setEnabled(true);
        				browse2.setEnabled(false);
        				filePathField.setEnabled(true);
        				divLabel.setEnabled(false);
        				iterLabel.setEnabled(false);
        				layers1Label.setEnabled(false);
        				layers2Label.setEnabled(false);
        				xSizeLabel.setEnabled(false);
        				ySizeLabel.setEnabled(false);
        				netName.setEnabled(false);
        				netNameField.setEnabled(false);
        				divField.setEnabled(false);
        				iterField.setEnabled(false);
        				layers1Field.setEnabled(false);
        				layers2Field.setEnabled(false);
        				xSizeField.setEnabled(false);
        				ySizeField.setEnabled(false);
        				
        				//pattView.setEnabled(false);
        				pathLabel.setEnabled(false);
        				pattsPath.setEnabled(false);
        				//list1.setEnabled(false);
        				browse3.setEnabled(false);
        				setAsPreButton.setEnabled(false);
        				setAsMainButton.setEnabled(false);
        				preFileText.setEnabled(false);
        				mainFileText.setEnabled(false);
        				
        			}
        			else{
        				fileName.setEnabled(false);
        				configNameField.setEnabled(true);
        				configNameLabel.setEnabled(true);
        				browse.setEnabled(false);
        				browse2.setEnabled(true);
        				filePathField.setEnabled(false);
        				divLabel.setEnabled(true);
        				iterLabel.setEnabled(true);
        				layers1Label.setEnabled(true);
        				layers2Label.setEnabled(true);
        				xSizeLabel.setEnabled(true);
        				ySizeLabel.setEnabled(true);
        				netName.setEnabled(true);
        				netNameField.setEnabled(true);
        				divField.setEnabled(true);
        				iterField.setEnabled(true);
        				layers1Field.setEnabled(true);
        				layers2Field.setEnabled(true);
        				xSizeField.setEnabled(true);
        				ySizeField.setEnabled(true);
        				
        				//pattView.setEnabled(true);
        				pathLabel.setEnabled(true);
        				pattsPath.setEnabled(true);
        				//list1.setEnabled(true);
        				browse3.setEnabled(true);
        				setAsPreButton.setEnabled(true);
        				setAsMainButton.setEnabled(true);
        				preFileText.setEnabled(true);
        				mainFileText.setEnabled(true);
        			}
        		}
        	});
        	fileName.setEnabled(true);
        	check1.setSelected(true);
        	configNameField.setEnabled(false);
        	configNameLabel.setEnabled(false);
        	browse.setEnabled(true);
        	browse2.setEnabled(false);
        	filePathField.setEnabled(true);
        	divLabel.setEnabled(false);
        	iterLabel.setEnabled(false);
        	layers1Label.setEnabled(false);
        	layers2Label.setEnabled(false);
        	xSizeLabel.setEnabled(false);
        	ySizeLabel.setEnabled(false);
        	netName.setEnabled(false);
        	netNameField.setEnabled(false);
              	divField.setEnabled(false);
        	iterField.setEnabled(false);
        	layers1Field.setEnabled(false);
        	layers2Field.setEnabled(false);
        	xSizeField.setEnabled(false);
        	ySizeField.setEnabled(false);
        	
        	//pattView.setEnabled(false);
        	pathLabel.setEnabled(false);
        	pattsPath.setEnabled(false);
        	//list1.setEnabled(false);
        	browse3.setEnabled(false);
        	setAsPreButton.setEnabled(false);
        	setAsMainButton.setEnabled(false);top.add(fileName);
        	preFileText.setEnabled(false);
        	mainFileText.setEnabled(false);
        	top.add(filePathField);
        	top.add(browse);
        	main.add(check1);
        	mid.add(divLabel);
		mid.add(divField);
		mid.add(iterLabel);
		mid.add(iterField);
		mid.add(layers1Label);
		mid.add(layers1Field);
		mid.add(layers2Label);
		mid.add(layers2Field);
		mid.add(xSizeLabel);
		mid.add(xSizeField);
		mid.add(ySizeLabel);
		mid.add(ySizeField);
		mid.add(netName);
		mid.add(netNameField);
        	bottom.add(pathLabel);
        	bottom.add(pattsPath);
        	bottom.add(browse3);
        	bottom.add(preFileText);
        	bottom.add(preFileField);
        	bottom.add(setAsPreButton);
        	bottom.add(mainFileText);
        	bottom.add(mainFileField);
        	bottom.add(setAsMainButton);
		bottom.add(configNameLabel);
		bottom.add(configNameField);
		bottom.add(browse2);
		last.add(createNet);
		last.add(cancelNet);
		main.add(top);
		main.add(mid);
		main.add(bottom);
		main.add(last);
		mid2.setEnabled(false);
		return main;
		
	}
	//creates the legend for the graph
	private JPanel createLegend(ArrayList results){
		//access the arraylist made by the training dialog ("classNames")
		JPanel main = new JPanel();
		JTextArea legendtextArea = new JTextArea();
		legendtextArea.setEditable(false);
		String s = "";
		File iFile = (File) results.get(results.size()-1);
		String inputFile = iFile.getAbsolutePath();
		String netName = (String) results.get(results.size()-2);
		s = "Net Name = "+ netName+"\n"+"Input File =\n"+inputFile+"\n";
		Network net = (Network) networkList.get(netName);
		String[] classNames = net.getClassNames();
		//ArrayList classNames = (ArrayList) netClassNames.get(netName);
		for(int i = 0; i < classNames.length; i++){
			s = s + ""+i+": "+classNames[i]+"\n";
		}
		legendtextArea.setText(s);
		
		JScrollPane areaScrollPane = new JScrollPane(legendtextArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(180, 200));
		main.add(areaScrollPane);
		return main;
	}
	//creates the Batch legend for the graph
	private JPanel createBatchLegend(ArrayList data){
		ArrayList results = (ArrayList) data.get(0);
		//access the arraylist made by the training dialog ("classNames")
		JPanel main = new JPanel();
		JTextArea legendtextArea = new JTextArea();
		legendtextArea.setEditable(false);
		String s = "";
		String netName = (String) results.get(results.size()-2);
		s = "Net Name = "+ netName+"\n";
		Network net = (Network) networkList.get(netName);
		String[] classNames = net.getClassNames();
		//ArrayList classNames = (ArrayList) netClassNames.get(netName);
		for(int i = 0; i < classNames.length; i++){
			s = s + ""+i+": "+classNames[i]+"\n";
		}
		legendtextArea.setText(s);
		
		JScrollPane areaScrollPane = new JScrollPane(legendtextArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(180, 200));
		main.add(areaScrollPane);
		return main;
	}
	//creates the legend for the graph with specified classnames
	private JPanel createLegend(ArrayList results, ArrayList classesNames){
		String[] classNames = new String[classesNames.size()];
		for(int j = 0; j< classesNames.size(); j++){
			classNames[j] = (String) classesNames.get(j);
		}
		//access the arraylist made by the training dialog ("classNames")
		JPanel main = new JPanel();
		JTextArea legendtextArea = new JTextArea();
		legendtextArea.setEditable(false);
		String s = "";
		File iFile = (File) results.get(results.size()-1);
		String inputFile = iFile.getAbsolutePath();
		String netName = (String) results.get(results.size()-2);
		s = "Net Name = "+ netName+"\n"+"Input File =\n"+inputFile+"\n";
		//ArrayList classNames = (ArrayList) netClassNames.get(netName);
		for(int i = 0; i < classesNames.size(); i++){
			s = s + ""+i+": "+classNames[i]+"\n";
		}
		legendtextArea.setText(s);
		
		JScrollPane areaScrollPane = new JScrollPane(legendtextArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(180, 200));
		main.add(areaScrollPane);
		return main;
	}
	//write the config file to past to the network after creatation
	private void writeConfigFile(String name, String fileName, String numGroups, String numLayersPre,String numLayersMain,
	     String inputSizeX, String inputSizeY, String numIter, String numDiv, String prePattern, String mainPattern){
	    printToMessageBox("Writing network config file...");
	    //must do some checks fisrt to see if the filename exists etc
	    try{
	        File f = new File(fileName);
	        BufferedWriter writer1 = new BufferedWriter(new FileWriter(fileName));
	        //write the file
	        writer1.write("#name");
	        writer1.newLine();
	        writer1.write(name);
	        writer1.newLine();
	        writer1.write("#numGroups");
	        writer1.newLine();
	        writer1.write(numGroups);
	        writer1.newLine();
	        writer1.write("#numLayersPre");
	        writer1.newLine();
	        writer1.write(numLayersPre);
	        writer1.newLine();
	        writer1.write("#numLayersMain");
	        writer1.newLine();
	        writer1.write(numLayersMain);
	        writer1.newLine();
	        writer1.write("#inputSizeX");
	        writer1.newLine();
	        writer1.write(inputSizeX);
	        writer1.newLine();
	        writer1.write("#inputSizeY");
	        writer1.newLine();
	        writer1.write(inputSizeY);
	        writer1.newLine();
	        writer1.write("#numIter");
	        writer1.newLine();
	        writer1.write(numIter);
	        writer1.newLine();
	        writer1.write("#numDiv");
	        writer1.newLine();
	        writer1.write(numDiv);
	        writer1.newLine();
	        writer1.write("#hotSpotFilePre");
	        writer1.newLine();
	        writer1.write(prePattern);
	        writer1.newLine();
	        writer1.write("#hotSpotFileMain");
	        writer1.newLine();
	        writer1.write(mainPattern);
	        writer1.close();
	        printToMessageBox("finished writing");
	        Network net1 = new Network();
                net1.initNetwork(thisGui, f);
                System.out.println("GUI finished network init");
                networkList.put(net1.getNetName(), net1);
                updateMenus();
                System.out.println("updated GUI menus");
	    }
	    catch(Exception e){
	        printToMessageBox("ERROR! "+e.getMessage());
	        e.printStackTrace();
	        JFrame fTemp = new JFrame();
                JOptionPane.showMessageDialog(fTemp, "ERROR in creating CFG file! \n"+" please select another");
	    }
	    
	}
	
	//create the dialog for viewing input patterns
	private JPanel createEditInputPatts(){
		final JPanel main = new JPanel();
		main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
		JPanel bottom = new JPanel();
		bottom.setLayout(new BoxLayout(bottom, BoxLayout.Y_AXIS));
		JPanel top = new JPanel();
		JPanel mid = new JPanel();
		
		JLabel pathLabel = new JLabel("Pattern File:");
		final JTextField pattsPath = new JTextField(15);
		pattsPath.setEditable(false);
		final JTextArea pattView = new JTextArea();
		pattView.setEditable(false);
		File f1 = new File("inputPatterns.patt");
		//final HashMap inputPatts = createInputPattMap(f1);
		final HashMap inputPatts = new HashMap();
		final JList list1 = new JList();
		list1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		//what happens when an item in the list is selected
		//the jlist listener for the edit input patterns dialog
		class ListSelectionListener1 implements ListSelectionListener{
			public void valueChanged(ListSelectionEvent e) { 
             			if (e.getValueIsAdjusting()){
                      			//the value is still adjusting
                      			return;
	   		 	}
	   			JList theList = (JList)e.getSource();
            			if (theList.isSelectionEmpty()) {
                      			System.out.println("no item selected");;
           		 	}
            			else {
                      			int index = theList.getSelectedIndex();
		      			System.out.println("selected item = "+index);         
            				String s = (String) inputPatts.get(index+"");
            				pattView.setText(s);
            			}
        		}
		}
		//list1.setSelectedIndex(0);
		//pattView.setText((String) inputPatts.get("0"));
		list1.addListSelectionListener(new ListSelectionListener1());    
		//final JComboBox pattsList = new JComboBox(names);
		JScrollPane listScrollPane = new JScrollPane(list1);
		JScrollPane pattViewScrollPane = new JScrollPane(pattView);
		listScrollPane.setPreferredSize(new Dimension(50, 160));
		pattViewScrollPane.setPreferredSize(new Dimension(75, 170));
		//the standard browse button
		JButton browse = new JButton("browse", openButtonIcon);
		browse.addActionListener(new ActionListener() {
            		public void actionPerformed(ActionEvent e) {
                		//Create a file chooser
		        	final JFileChooser fc = new JFileChooser(currentDir);
		        	//add the defualt file filter to the file chooser
				//fc.addChoosableFileFilter();
				fc.addChoosableFileFilter(new inputPattFilter());
				int returnVal = fc.showOpenDialog(main);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
        		   		File f = fc.getSelectedFile();
        				try{
        					//once a file has been selected
        					//update the dialog
        					pattsPath.setText(f.getCanonicalPath());
        					updateCurrentDir(f);
        					//main.setPreferredSize(new Dimension (391, 247));
        					inputPatts.clear();
        					inputPatts.putAll(createInputPattMap(f));
        					Set keys2 = inputPatts.keySet();
						String[] names2 = new String[keys2.size()];
						names2 = (String[]) keys2.toArray(names2);
                				list1.setListData(names2);
                				list1.setSelectedIndex(0);
                				main.validate();
        				}
        				catch(Exception g){
        					System.out.println(g.getMessage());
        				}
        				//this is where a real application would open the file.
        				printToMessageBox("Selected: " + f.getAbsolutePath()+ "...");
    				}
           		}
        	});
        	final JButton setAsPreButton = new JButton("Set Pre");
        	final JButton setAsMainButton = new JButton("Set Main");
        	top.add(pathLabel);
        	top.add(pattsPath);
        	top.add(browse);
        	bottom.add(setAsPreButton);
        	bottom.add(setAsMainButton);
        	//bottom.add(cancelButton);
        	mid.add(listScrollPane, BorderLayout.WEST);
        	mid.add(pattViewScrollPane, BorderLayout.CENTER);
        	//mid.add(bottom, BorderLayout.EAST);
        	main.add(top);
        	main.add(mid);
        	//main.add(bottom);
		return main;
	}
	//parse the input pattern config file and give the data to the viewer
	public HashMap createInputPattMap(File file1){
		HashMap map = new HashMap();
		ArrayList lines = new ArrayList();
		try{
			BufferedReader r = new BufferedReader(new FileReader(file1));
			//read all lines into an array
			
			String line = r.readLine();
			while(line != null){
				lines.add(line);
				line = r.readLine();
			}
			r.close();
		}
		catch(Exception e){
			System.out.println("Error! "+e.getMessage());
		}
		//parse the lines
		int i = 0;
		int count = 0;
		while(i < lines.size()){
			String s = (String) lines.get(i);
			if(s.charAt(0) == '@'){
				i++;
				s = (String) lines.get(i);
				String input = "";
				for(int j = 1; j < 9; j++){
					input = input + s + "\n";
					s = (String) lines.get(i+j);
				}
				System.out.println("count="+count);
				System.out.println("i="+i);
				System.out.println("input="+input);
				map.put(""+count, input);
				count++;
			}
			i++;	
		}		
		return map;
	}
	//close an internal frame
	private void closeInternalFrame(){
		JInternalFrame intframe = desktop.getSelectedFrame();
		intframe.dispose();
	}
	//create the menu bar to the virtual desktop
    	protected JMenuBar createMenuBar() {
        	//make the menu bar and the menus
        	JMenuBar menuBar1 = new JMenuBar();
        	JMenu netMenu = new JMenu("Network");
        	JMenu resultsMenu = new JMenu("Results");
        	JMenu opsMenu = new JMenu("Operations");
        	JMenu helpMenu = new JMenu("Help");
        	JMenu quitMenu = new JMenu("Quit");
        	netMenu.setMnemonic(KeyEvent.VK_N);
        	helpMenu.setMnemonic(KeyEvent.VK_H);
        	resultsMenu.setMnemonic(KeyEvent.VK_R);
        	opsMenu.setMnemonic(KeyEvent.VK_O);
        	quitMenu.setMnemonic(KeyEvent.VK_Q);
        	
        	JMenuItem quitItem = new JMenuItem("Quit!");
        	quitItem.addActionListener(new ActionListener() {
            	public void actionPerformed(ActionEvent e) {
                	//create the quit dialog box with a question
                	JFrame frame1 = new JFrame();
          	    	final JOptionPane optionPane = new JOptionPane(
                    		"Are you sure you want to Quit?",
                    		JOptionPane.QUESTION_MESSAGE,
                    		JOptionPane.YES_NO_OPTION);
		        final JDialog dialog = new JDialog(frame1, "Click a button",true);
		        dialog.setContentPane(optionPane);
		        //add an actionlistener to the buttons of the dialog
		        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
        		    public void propertyChange(PropertyChangeEvent e) {
            			String prop = e.getPropertyName();
            			if (dialog.isVisible() 
             				&& (e.getSource() == optionPane)
             				&& (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                 			prop.equals(JOptionPane.INPUT_VALUE_PROPERTY)))
            			{
                			//what happens when a button on the exit dialog is clicked
                			dialog.setVisible(false);
                			int value = ((Integer)optionPane.getValue()).intValue();
					        if (value == JOptionPane.YES_OPTION) {
						        System.exit(0);
					        }
            	    	}
        	    }
    	        });
    	    	//make the quit dialog visible
		dialog.pack();
		dialog.setVisible(true);
            }
        });
        //construct some menuitems
        JMenuItem newNet = new JMenuItem("new");
        newNet.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {        
                createFrame(createConfigBox(), "Create new PCN", 430, 430, false);
            }
        });
        JMenuItem loadNet = new JMenuItem("load", openButtonIcon);
        loadNet.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent e){
        		loadNetwork();	
        	}
        });
        JMenuItem onlineHelp = new JMenuItem("online help", helpButtonIcon);
        onlineHelp.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {        
                createFrame(createOnlineHelp(), "OnlineHelp", 625, 490, true);
            }
        });
        JMenuItem about = new JMenuItem("about");
        about.addActionListener(new ActionListener() {
        	public void actionPerformed(ActionEvent e) {        
            		JFrame fTemp = new JFrame();
            		fTemp.setTitle("About");
            		Runtime rt = Runtime.getRuntime();
			JOptionPane.showMessageDialog(fTemp, "PCN simulation by Tim Terry \n"+
                		" Version 2.1 beta (23/02/01) \n"+ 
                		"Java Version: "+ System.getProperty("java.version")+"\n"+
                		"JVM Free memory: "+ (rt.freeMemory() / 1024)+ "KB\n"+
                		"JVM Total memory: "+ (rt.totalMemory() / 1024)+ "KB");
		}
        });
        //load a saved result
        JMenuItem loadResults = new JMenuItem("Load", openButtonIcon);
        loadResults.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent e){
        		final JFileChooser fc = new JFileChooser(currentDir);
        		int returnVal = fc.showOpenDialog(null);
        		if (returnVal == JFileChooser.APPROVE_OPTION) {
        			File file = fc.getSelectedFile();
        			if(file.canRead()){
        				loadResultsFile(file);
        				updateCurrentDir(file);
        			}
        			else{
        				JFrame fTemp = new JFrame();
        				JOptionPane.showMessageDialog(fTemp, "IOError can't read selected file");
        			}
    			} 
    			else {
        			//do nothing
    			}
        	}
        });
        JMenuItem editInputPatterns = new JMenuItem("Input Patterns");
        editInputPatterns.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent e){
        		createFrame(createEditInputPatts(), "View Input Patterns", 430, 280, true);
        	}
        });
        //add the menu items the the menubar
        netMenu.add(newNet);
        netMenu.add(loadNet);
        netMenu.add(saveNetSub);
        helpMenu.add(onlineHelp);
        helpMenu.add(about);
        resultsMenu.add(saveResultsSub);
        resultsMenu.add(saveBatchResultsSub);
        resultsMenu.add(loadResults);
        resultsMenu.add(graphResultsSub);
        resultsMenu.add(graphBatchResultsSub);
        opsMenu.add(trainSub);
        opsMenu.add(recogniseSub);
        opsMenu.add(batchRecogniseSub);
        opsMenu.add(resetMemSub);
    	opsMenu.add(editInputPatterns);
        quitMenu.add(quitItem);
        menuBar1.add(netMenu);
        menuBar1.add(opsMenu);
        menuBar1.add(resultsMenu);
        menuBar1.add(helpMenu);
        menuBar1.add(quitMenu);
        return menuBar1;
    }
    //print some text to the message box
    public void printToMessageBox(String s){
    	JInternalFrame[] frames = desktop.getAllFrames();
    	JInternalFrame mesgBox = frames[0];
    	textArea1.setText(textArea1.getText()+"\n"+s);
    	mesgBox.pack();
    	
    }
    //create an internal frame
    protected void createFrame(JComponent p, String s, int x, int y, boolean resize) {
        //called when a new internal window is needed
        InternalFrame frame1 = new InternalFrame(s, x, y, resize);
	frame1.getContentPane().add(p);
	frame1.setVisible(true);
        desktop.add(frame1);
        try {
            frame1.setSelected(true);
        } 
        catch (Exception e) {
        	System.out.println("a known error occured during frame selection: "+e.getMessage());
        }
    }
    
    public static void main(String[] args) {
    	//the main method
        try{
        	PCNGui frame = new PCNGui();
        	frame.setVisible(true);
        }
        catch(Exception e){
        	System.out.println("An exception was caught, possibly due to a bug in JDK1.3\n"+e.getMessage());	
        }
    }
}
