import java.util.*;
import java.io.*;
public class PreGroup extends Group implements Serializable{
	public PreGroup(Network n){
		super(n);
		net = n;
	}
	
	public void setTrainingMode(boolean b){
		for(int n = 0; n < layerList.size(); n++){
			PreLayer l = (PreLayer) layerList.get(n);
			l.setTrainingMode(b);
		}
	}
	//create the memory locations in all of the neurons
	public void createNeuronMemorySpaces(int numberOfClasses){
		for(int i = 0; i < layerList.size(); i++){
			PreLayer l = (PreLayer) layerList.get(i);
			l.createNeuronMemorySpaces(numberOfClasses);
			
		}
	}
	public void resetMem(){
		for(int i = 0; i < layerList.size(); i++){
			PreLayer l = (PreLayer) layerList.get(i);
			l.resetMem();
		}
	}
	//distribute the pattern to the layers and the class it is part of
	//for training
	public void distributePattern(ArrayList a, int classNo){	
		for(int n = 0; n < layerList.size(); n++){
			PreLayer l = (PreLayer) layerList.get(n);
			System.out.print("distributing pattern to layer "+n+"...");
			l.distributePattern((ArrayList) a, classNo);
			System.out.print("Done!");
			System.out.println("");
		}
		
	}
	
	//dump neuron memory
	public void dumpNeuronMemory(){
		for(int n = 0; n < layerList.size(); n++){
			PreLayer l = (PreLayer) layerList.get(n);
			l.dumpNeuronMemory();
		}
	}
}