import java.util.*;
import java.io.*;
public class PreLayer implements Layer, Serializable{
	//matric to hold all the neurons in this layer
	ArrayList neuronMatrix = new ArrayList();
	//the input pattern
	ArrayList inputPattern = new ArrayList();
	//number of inputs of each neuron
	int numNeuronInputs;
	int numClasses;
	ArrayList hotSpots;
	boolean trainingMode = true;
	public PreLayer(int x, int y, ArrayList patt){
		//neurons are 8bit
		numNeuronInputs = 8;
		hotSpots = patt;
		//create the neurons in this layer
		for(int a =0; a < y; a++){
			ArrayList row = new ArrayList(x);
			for(int b = 0; b < x; b++){
				Neuron n = new Neuron(numNeuronInputs);
				row.add(n);	
			}
			neuronMatrix.add(row);
		}
	}
	//show the contents of the neuron memory
	public void dumpNeuronMemory(){
		for(int n = 0; n < neuronMatrix.size(); n++){
			ArrayList matrix = (ArrayList) neuronMatrix.get(n);
			for(int m = 0; m < matrix.size(); m++){
				Neuron k = (Neuron) matrix.get(m);
				k.dumpMemory();
			}
		}
	}
	//not sure if needed???
	//set the neurons to training mode
	public void setTrainingMode(boolean b){
		trainingMode = b;
		for(int n = 0; n < neuronMatrix.size(); n++){
			ArrayList matrix = (ArrayList) neuronMatrix.get(n);
			for(int m = 0; m < matrix.size(); m++){
				Neuron k = (Neuron) matrix.get(m);
				k.setTrainingMode(b);
			}
		}
	}
	//creates the neuron memory spaces
	public void createNeuronMemorySpaces(int numberOfClasses){
		System.out.println("layer creating neuron memory spaces...");
		numClasses = numberOfClasses;
		for(int n = 0; n < neuronMatrix.size(); n++){
			ArrayList matrix = (ArrayList) neuronMatrix.get(n);
			for(int m = 0; m < matrix.size(); m++){
			
				Neuron k = (Neuron) matrix.get(m);
				k.createStorageSpace(numberOfClasses);
				
			}
		}
	}
	//resets the the neuron memory spaces
	public void resetMem(){
		for(int n = 0; n < neuronMatrix.size(); n++){
			ArrayList matrix = (ArrayList) neuronMatrix.get(n);
			for(int m = 0; m < matrix.size(); m++){
				Neuron k = (Neuron) matrix.get(m);
				k.resetMem();
			}
		}
	}
	public void memoryAdjustment(int n, int m, int d){
		for(int row = 0; row < neuronMatrix.size(); row++){
			ArrayList rowTemp = (ArrayList) neuronMatrix.get(row);
			for(int column = 0; column < rowTemp.size(); column++){
				Neuron  ne = (Neuron) rowTemp.get(column);
				ne.memoryAdjustment(n, m, d);
			}
		}
	}
	//distribute an input pattern to all the neurons, and the class that it is part of
	public void distributePattern(ArrayList al, int classNo){
		//gives the pattern to the neurons in this layer using the 1L1R input
		inputPattern = al;
		int inputPatternSize = inputPattern.size();
		
		for(int row = 0; row < neuronMatrix.size(); row++){
			ArrayList rowTemp = (ArrayList) neuronMatrix.get(row);
			int rowTempSize = rowTemp.size();
			for(int column = 0; column < rowTemp.size(); column++){
				Neuron  n = (Neuron) rowTemp.get(column);
				String neuronInput = "";
				for(int a = 0; a< numNeuronInputs; a++){
					//this is the data that will be taken from the input image
					//it contains string that represent class freqs
					Coord c = (Coord) hotSpots.get(a);
					int indexX = c.getX();
					int indexY = c.getY();
					if((indexX + column) >= rowTempSize){
						//wrap in x
						indexX = (indexX + column) - rowTempSize;
					}
					else{
						indexX = indexX + column;
					}
					if((indexY + row) >= inputPatternSize){
						//wrap in y
						indexY = (indexY + row) - inputPatternSize;
					}
					else{
						indexY = indexY + row;
					}	
					//String c1 = ""+ getInfo(indexX, indexY, inputPattern);
					neuronInput = neuronInput + getInfo(indexX, indexY, inputPattern);
				}
				//System.out.println("neuron input = "+neuronInput+ "("+column+","+row+")");
				n.trainNeuron(neuronInput, classNo);
				
			}
			//System.runFinalization();
			//System.gc();
		}
	}
	public ArrayList distributePattern(ArrayList al){
		ArrayList layerOutput = new ArrayList();
		//gives the pattern to the neurons in this layer using the 1L1R input
		inputPattern = al;
		int inputPatternSize = inputPattern.size();
		for(int row = 0; row < neuronMatrix.size(); row++){
			ArrayList rowTemp = (ArrayList) neuronMatrix.get(row);
			int rowTempSize = rowTemp.size();
			ArrayList rowOutput = new ArrayList();
			for(int column = 0; column < rowTemp.size(); column++){
				Neuron n = (Neuron) rowTemp.get(column);
				//String inputTemp = (String) inputPattern.get(row);
				String neuronInput = "";
				for(int a = 0; a< numNeuronInputs; a++){
					//this is the data that will be taken from the input image
					//it contains string that represent class freqs
					Coord c = (Coord) hotSpots.get(a);
					int indexX = c.getX();
					int indexY = c.getY();
					if((indexX + column) >= rowTempSize){
						//wrap in x
						indexX = (indexX + column) - rowTempSize;
					}
					else{
						indexX = indexX + column;
					}
					if((indexY + row) >= inputPatternSize){
						//wrap in y
						indexY = (indexY + row) - inputPatternSize;
					}
					else{
						indexY = indexY + row;
					}	
					char c2 = getInfo(indexX, indexY, inputPattern);
					neuronInput = neuronInput + c2;
				}
				
				rowOutput.add(n.matchPattern(neuronInput));
				
			}
			layerOutput.add(rowOutput);
		}
		//System.out.println("printing layer output...");
		//printLayerOutput(layerOutput);
		return layerOutput;
	}
	//method to get a particuler pixel information from an input image
	private char getInfo(int x, int y, ArrayList input){
		ArrayList result = new ArrayList();
		String row = (String) input.get(y);
		char c = row.charAt(x);
		return c;	
	}
	public void printLayerOutput(ArrayList a){
		for(int n = 0; n < a.size(); n++){		
			ArrayList column = (ArrayList) a.get(n);
			for(int m = 0; m < column.size(); m++){
				ArrayList neuronOP = (ArrayList) column.get(m);
				System.out.print(""+neuronOP);
			}
			System.out.println("");
		}
	}
	
				
}