/* Copyright (c) 2001 S.E. Grigorescu */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tip.h>

//   Example program for the "Downsample" function.
//
//   Usage:
//      test_downsample <input_image>
//

int main(int argc, char *argv[])
{
  // Test for the correct number of arguments in the command line.
  if (argc != 2) {
    cout << "Usage: " << argv[0] << " <input_image>" << endl;
    exit(0);
  }

  // Read an image from the file specified by "argv[1]" and display it.
  Image< int > im1; 
  im1.readImage(argv[1]);
  im1.setName("test_image");
  im1.showImage();
 
  // Downsample the input image and store the result in a second image.
  Image< int > im2; 
  Downsample(im1, im2);
  im2.setName("test_image_1");
  im2.showImage();

  // Downsample the input image in place.
  Image< int > im3 = im1;
  Downsample(im3);
  im3.setName("test_image_2");
  im3.showImage(); 

  char l;
  cin >> l;
  
  // Close all displaying windows.
  im1.closeWindow();
  im2.closeWindow();
  im3.closeWindow();                                                                         

  return(1);
}
