/* Copyright (c) 2001 S.E. Grigorescu */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <tip.h>

//   Example program for the "Reflect" function.
//
//   Usage:
//      test_reflect <input_image>
//

int main(int argc, char *argv[])
{
  // Test for the correct number of arguments in the command line.
  if (argc != 2) {
    cout << "Usage: " << argv[0] << " <input_image>" << endl;
    exit(0);
  }

  // Read an image from the file specified by "argv[1]" and display it.
  Image< float > im1; 
  im1.readImage(argv[1]);
  im1.setName("test_image");
  im1.showImage();
 
  // Reflect the input image along the vertical axis and store the result in a second image.
  Image< float > im2; 
  Reflect(im1, "vertical", im2); 
  im2.setName("test_image_1");
  im2.showImage();

  // Reflect the input image along the horizontal axis in place.
  Image< float > im3 = im1;
  Reflect(im3, "horizontal");
  im3.setName("test_image_2");
  im3.showImage();
 
  char l;
  cin >> l;
  im1.closeWindow();
  im2.closeWindow();
  im3.closeWindow();                                    
  return(1);
}
