/* Copyright (c) 2001 S.E. Grigorescu */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tip.h>

//   Example program for the "Rotate" function.
//
//   Usage:
//      test_rotate <input_image>
//

int main(int argc, char *argv[])
{
  // Test for the correct number of arguments in the command line.
  if (argc != 2) {
    cout << "Usage: " << argv[0] << " <input_image>" << endl;
    exit(0);
  }

  // Read an image from the file specified by "argv[1]" and display it.
  Image< int > im1; 
  im1.readImage(argv[1]);
  im1.setName("test_image");
  im1.showImage();
 
  // Rotate 30.5 degrees CCW the input image and store the result in a second image.
  Image< int > im2; 
  Rotate(im1, 30.5, im2);
  im2.setName("test_image_1");
  im2.showImage();

  // Rotate 30.5 degrees CW the input image in place.
  Image< int > im3 = im1;
  Rotate(im3, -30.5);
  im3.setName("test_image_2");
  im3.showImage(); 

  char l;
  cin >> l;
  im1.closeWindow();
  im2.closeWindow();
  im3.closeWindow();          
  return(1);
}
