/* Copyright (c) 2001 S.E. Grigorescu */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tip.h>

//   Example program for the "Threshold" function.
//
//   Usage:
//      test_thresh <input_image>
//

int main(int argc, char *argv[])
{
  // Test for the correct number of arguments in the command line.
  if (argc != 2) {
    cout << "Usage: " << argv[0] << " <input_image>" << endl;
    exit(0);
  }

  // Read an image from the file specified by "argv[1]" and display it.
  Image< float > im1;
  im1.readImage(argv[1]);
  im1.setName("test_image");
  im1.showImage();
  char l;
  cin >> l;

  // Threshold the input image with the thereshold level equal to 49.5 and 
  // store the result in a second image.
  ByteImage im2;
  Threshold(im1, 49.5, im2);
  im2.showImage();
  cin >> l;
  
  im1.closeWindow();
  im2.closeWindow();                             
  return(1);
}
