/* Copyright (c) 2001 C. Grigorescu */

#ifndef BYTE_KERNEL_H
#define BYTE_KERNEL_H

#include "Kernel.h"

#define ON  255
#define OFF 0

/**
  Implements data structures and functions for manipulating morphological kernels. */

class ByteKernel : public Kernel < byte >
{
 public:
  /*! Creates a kernel with the specified \a name without allocating space for the kernel data. */
  ByteKernel(char *name="") : Kernel< byte >(name) {}

  /*! Creates a kernel of size \a wxh with the specified \a name and type (\a kernel_type) and allocates space for storing the kernel data.
    Currently supported types of kernels are:
    - CROSS_3x3
    - DISK_3x3
    - KERNEL_BYTE_UNKNOWN (unspecified or supplied from a file).
  */
  ByteKernel(BYTE_KERNEL_TYPE kernel_type=CROSS_3x3, char *name="" );

  /*! Performs pixelwise logical negation of the current kernel.*/
  ByteKernel &operator!(void);
};

#endif
