/* Copyright (c) 2001 C. Grigorescu */

#ifndef _CONVOLUTION_H_
#define _CONVOLUTION_H_
#include "Image.h"
#include <typeinfo>

/*! \ingroup sig_alg 
 */
template< class T >
void Convolution(Image< T > &input1, Image< T > &input2, Image< T > &output); 
/*! \fn template< class T > void Convolution(Image< T > &input1, Image< T > &input2, Image< T > &output); 
  Performs the convolution of two images (\a input1 and \a input2) and stores the result in a third image (\a output). Note that if the operands are of type \aT = \afloat (floating point image or floating point kernel), or of the derived types "FloatImage" and/or "FloatKernel", the convolution operation is performed as multiplication in Fourier space (for speed-up reasons). 
*/

/** \example test_convol.cpp */

#endif

