/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef DOWNSAMPLING_H
#define DOWNSAMPLING_H

#include <math.h>
#include "Image.h"

/*! \ingroup sig_alg 
*/

template<class T> void Downsample(Image< T >& input, Image< T >& output);
/*! \fn template< class T > void Downsample(Image< T >& input, Image< T >& output);

  Performs the downsampling of the \a input image and stores the result in the \a output image. 
*/

/*! \ingroup sig_alg 
*/

template<class T> void Downsample(Image< T >& input);
/*! \fn template< class T > void Downsample(Image< T >& input);

  Performs in place the downsampling of the \a input image.
*/

/** \example test_downsampl.cpp */

#endif 

