/* Copyright (c) 2001 C. Grigorescu S.E. Grigorescu */

#ifndef FLOAT_IMAGE_H
#define FLOAT_IMAGE_H

#include "Image.h"

/**
    Implements data structures and functions for manipulating images whose gray levels are represented as floating point values.
 */

class FloatImage : public Image< float > 
{
 public:
  /*! Creates an image with the specified \a name without allocating space for the image data. */
  FloatImage(char *name="") : Image< float >(name) {} 

  /*! Creates an image of size \a wxh with the specified \a name and allocates space for storing the image data. */
  FloatImage(int w, int h, char *name="") : Image< float >(w,h,name) {} 

  /*! \ingroup conv
    Copy operator that allows conversion between \link Image Image< float >\endlink and \link #FloatImage FloatImage\endlink. */
  FloatImage &operator=(Image< float > &img); 
};

#endif

