/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef REFLECTION_H
#define REFLECTION_H

#include "Image.h"
#include <string>

/** \ingroup geom_alg 
*/                                                                
template<class T> void Reflect(Image< T >& input, string axis, Image< T >& output);
/*! \fn template< class T > void Reflect(Image< T >& input, string axe, Image< T >& output);

  Performs the reflection across the indicated axis of the input image and stores the result in the output image. For a reflection across the horizontal axis, the parameter \a axis should be "horizontal"; while for a reflection across the vertical axis, the parameter \a axis should be "vertical".
*/

/** \ingroup geom_alg 
*/                                                                
template<class T> void Reflect(Image< T >& input, string axis);
/*! \fn template< class T > void Reflect(Image< T >& input, string);

  Performs in place the reflection across the indicated axis of the input image. For a reflection across the horizontal axis, the parameter \a axis should be "horizontal"; while for a reflection across the vertical axis, the parameter \a axis should be "vertical".
*/

/** \example test_reflect.cpp */

#endif
