/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef ROTATION_H
#define ROTATION_H

#include <math.h>
#include "Image.h"

/** \ingroup geom_alg 
*/                                                                
template<class T> void Rotate(Image< T >& input, float angle, Image< T >& output);
/*! \fn template< class T > void Rotate(Image< T >& input, float angle, Image< T >& output);

  Performs the CCW rotation of the input image using the given \a angle (in degrees) and stores the result in the output image. 
*/

/** \ingroup geom_alg 
*/                                                                
template<class T> void Rotate(Image< T >& input, float angle);
/*! \fn template< class T > void Rotate(Image< T >& input, float angle);

  Performs the CCW rotation of the input image in place using the given \a angle (in degrees).
*/

/** \example test_rotate.cpp */

#endif
