/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef THRESHOLD_H
#define THRESHOLD_H

#include "ByteImage.h"
#include "Image.h"

/** \ingroup point_alg 
*/                                                                
template<class T> void Threshold(Image< T >& input, float th_level, ByteImage& output);
/*! \fn template< class T > void Threshold(Image< T >& input, float th_level, ByteImage& output);

  Performs the thresholding of the input image using the given threshold level. This means that all those pixels in the output image corresponding to pixels in the input image whose values are smaller than \a th_level are set to 0, while the other pixels in the output image are set to 255.
*/

/** \example test_thresh.cpp */
#endif
