/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef TRANSLATION_H
#define TRANSLATION_H

#include <math.h>
#include "Image.h"

/** \ingroup geom_alg 
*/                                                                
template<class T> void Translate(Image< T >& input, float x, float y, Image< T >& output);
/*! \fn template< class T > void Translate(Image< T >& input, float x, float y, Image< T >& output);

  Performs the translation of the input image along the x- and y-axes and stores the result in the output image. A positive value for \a x means a translation to the right. A positive value for \a y means a translation downwards.
*/

/** \ingroup geom_alg 
*/                                                                
template<class T> void Translate(Image< T >& input, float x, float y);
/*! \fn template< class T > void Translate(Image< T >& input, float x, float y);

  Performs in place the translation of the input image along the x- and y-axes. A positive value for \a x means a translation to the right. A positive value for \a y means a translation downwards.
*/

/** \example test_translate.cpp */

#endif

