/* Copyright (c) 2001 S.E. Grigorescu */

#ifndef UPSAMPLING_H
#define UPSAMPLING_H

#include "Image.h"

/** \ingroup sig_alg
*/                                                                
template<class T> void Upsample(Image< T >& input, Image< T >& output);
/*! \fn template< class T > void Upsample(Image< T >& input, Image< T >& output);

  Performs the upsampling of the \a input image and stores the result in the \a output image. 
*/

/** \ingroup sig_alg
*/                                                                
template<class T> void Upsample(Image< T >& input);
/*! \fn template< class T > void Upsample(Image< T >& input);

  Performs the upsampling of the \a input image in place.
*/

/** \example test_upsampl.cpp */

#endif
