/* Copyright (c) 2001 A. Jalba */

#ifndef WATERSHED_H
#define WATERSHED_H

#include "misc.h"
#include "ByteImage.h"
#include "IntImage.h"

/*! \ingroup morph_alg
 */
void Watershed(ByteImage &im, CONN_TYPE connect, IntImage &out);
/*! \fn void Watershed(ByteImage &im,  CONN_TYPE connect, IntImage &out);

  Performs the watershed transform of the input image using the connectivity type indicated by \a connect and stores the result in the \a output image. The connectivity can be:
  - FOUR: four-connectivity, in which case only top, bottom, left and right pixels are taken as neighbors;
  - EIGHT: eight-connectivity, in which case also the diagonal pixels are considered as neighbors.

The current implementation is based on the article of Luc Vincent, Pierre Soille, "Watersheds in Digital Spaces: An Efficient Algorithm Based on Immersion Simulations", IEEE Transactions on Pattern Analysis and Machine Intelligence, vol. 13, no. 6, June 1991.
*/

/** \example test_watershed.cpp */

#endif

