/* Copyright (c) 2001 C. Grigorescu */

#ifndef _FFTWLIB_H_
#define _FFTWLIB_H_
 
/* Functions for 2D Fourier transformation and convolution
   in single precision floating point 
*/

void _convolve(float *input_image_1, float *input_image_2,
              int size_x, int size_y, float *convolved_image);
 
void _fft2d(float *real_input_image, float *imag_input_image,
           int size_x, int size_y,
           float *fourier_real_part, float *fourier_imag_part);
 
void _ifft2d(float *fourier_real_image, float *fourier_imag_image,
           int size_x, int size_y,
           float *real_image, float *imag_image);
 
#define half_shift(A,size_x,size_y) \
   { float temp; \
     int i,j; \
     for (j=0; j<(size_y)/2; j++)  \
       for (i=0; i<(size_x)/2; i++)  \
         { temp = A[(size_x)*j+i]; \
           A[(size_x)*j+i] = A[(size_x)*(j+((size_y)/2))+i+(size_x)/2]; \
           A[(size_x)*(j+((size_y)/2))+i+(size_x)/2] = temp;} \
     for (j=size_y/2; j<(size_y); j++)  \
       for (i=0; i<(size_x)/2; i++)  \
         { temp = A[(size_x)*j+i]; \
           A[(size_x)*j+i] = A[(size_x)*(j-((size_y)/2))+i+(size_x)/2]; \
           A[(size_x)*(j-((size_y)/2))+i+(size_x)/2] = temp;} \
   }

#endif
