#include "config.h"

#ifdef HAVE_LIBPLOTTER

typedef struct GrapherStruct Grapher;

extern Grapher* new_grapher ____P((const char *display_type, FILE *out_file, const char *bg_color,
                                   const char *bitmap_size, const char *emulate_color,
                                   const char *max_line_length, const char *meta_portable,
                                   const char *page_size, const char *rotation_angle,
                                   bool save_screen));
 
extern void delete_grapher ____P((Grapher *multigrapher));
 
extern void begin_graph ____P((Grapher *multigrapher, double scale, double trans_x, 
			       double trans_y));
 
extern void end_graph ____P((Grapher *multigrapher));
 
extern void set_graph_parameters ____P((Grapher *multigrapher, double frame_line_width,
                                        const char *frame_color, const char *title,
                                        const char *title_font_name, double title_font_size,
                                        double tick_size, grid_type grid_spec, double x_min,
                                        double x_max, double x_spacing, double y_min, double y_max,
                                        double y_spacing, bool spec_x_spacing, bool spec_y_spacing,
                                        double width, double height, double up, double right,
                                        const char *x_font_name, double x_font_size,
                                        const char *x_label, const char *y_font_name,
                                        double y_font_size, const char *y_label,
                                        bool no_rotate_y_label, int log_axis,
                                        int round_to_next_tick, int switch_axis_end,
                                        int omit_labels, int clip_mode, double blankout_fraction,
                                        bool transpose_axes));
 
extern void draw_frame_of_graph ____P((Grapher *multigrapher, bool draw_canvas));
 
extern void plot_point ____P((Grapher *multigrapher, const Point *point));
 
extern void plot_point_array ____P((Grapher *multigrapher, const Point *p, int length));
 
extern void end_polyline_and_flush ____P((Grapher *multigrapher)); 

#endif
