/* Copyright (c) 2001 S.E. Grigorescu */

#include "Downsampling.h"

template void Downsample< int >(Image< int >&, Image< int >&);
template void Downsample< byte >(Image< byte >&, Image< byte >&);
template void Downsample< float >(Image< float >&, Image< float >&);
template void Downsample< int >(Image< int >&);
template void Downsample< byte >(Image< byte >&);
template void Downsample< float >(Image< float >&);
 
template< class T > void Downsample(Image< T >& input, Image< T >& output)
{
  Image< T > res(floor((input.getWidth()+1.0)/2.0), 
		 floor((input.getHeight()+1.0)/2.0), output.getName());

  for (int i = 0; i < input.getHeight(); i += 2)
    for (int j = 0; j < input.getWidth(); j += 2)
      res[i/2][j/2] = input[i][j];
  output = res;
}

template< class T > void Downsample(Image< T >& input)
{
  Downsample(input, input);
}
