/* Copyright (c) 2001 S.E. Grigorescu */

#include "Noise.h"

template void Noise< int >(Image< int >&, string, float, float,  int);
template void Noise< byte >(Image< byte >&, string, float, float,  int);
template void Noise< float >(Image< float >&, string, float, float,  int);
template void Noise< int >(Image< int >&,  int);
template void Noise< byte >(Image< byte >&,  int);
template void Noise< float >(Image< float >&,  int);
template void Noise< int >(Image< int >&, float, float,  int);
template void Noise< byte >(Image< byte >&, float, float,  int);
template void Noise< float >(Image< float >&, float, float,  int);
template void Noise< int >(Image< int >&, string,  int);
template void Noise< byte >(Image< byte >&, string,  int);
template void Noise< float >(Image< float >&, string,  int);
 
template< class T > void Noise(Image< T >& input, string noise_type, 
			       float a, float b,  int seed = 1)
{
  SetGenRand(seed);
  if (noise_type.substr(0, 1) == "u" || noise_type.substr(0, 1) == "U")
    for (int i = 0; i < input.getHeight(); i++)
      for (int j = 0; j < input.getWidth(); j++)
        input[i][j] += (T)GenRand(a, b);
  if (noise_type.substr(0, 1) == "n" || noise_type.substr(0, 1) == "N")
    for (int i = 0; i < input.getHeight(); i++)
      for (int j = 0; j < input.getWidth(); j++)
        input[i][j] += (T)GaussRand(a, b);
  if (noise_type.substr(0, 1) == "s" || noise_type.substr(0, 1) == "S") {
    int i, j, amt;
    a = (a < 0) ? 0:a;
    a = (a > 100) ? 100:a;
    amt = (int)rint(input.getHeight()*input.getWidth()*a/100.0);
    for (int k = 0; k < amt; k++) {
      j = (int)rint(GenRand(0, input.getWidth()-1));
      i = (int)rint(GenRand(0, input.getHeight()-1));
      input[i][j] = (T)(255*rint(GenRand()));
    }
  }
}

template< class T > void Noise(Image< T >& input,  int seed = 1)
{
  Noise(input, "n", 0, 1, seed);
}

template< class T > void Noise(Image< T >& input, float a, float b,  int seed = 1)
{
  Noise(input, "n", a, b, seed);
}

template< class T > void Noise(Image< T >& input, string noise_type,  int seed = 1)
{
  if (noise_type.substr(0, 1) == "u" || noise_type.substr(0, 1) == "U" || 
      noise_type.substr(0, 1) == "n" || noise_type.substr(0, 1) == "N")
    Noise(input, noise_type, 0, 1, seed);
  if (noise_type.substr(0, 1) == "s" || noise_type.substr(0, 1) == "S") {
    SetGenRand(seed);
    int amt;
    amt = (int)rint(GenRand(0, 100));
    Noise(input, noise_type, amt, 1, seed);
  }
}












