/* Copyright (c) 2001 S.E. Grigorescu */

#include "Reflection.h"

template void Reflect< int >(Image< int >&, string, Image< int >&);
template void Reflect< byte >(Image< byte >&, string, Image< byte >&);
template void Reflect< float >(Image< float >&, string, Image< float >&);
template void Reflect< int >(Image< int >&, string);
template void Reflect< byte >(Image< byte >&, string);
template void Reflect< float >(Image< float >&, string);
 
template< class T > void Reflect(Image< T >& input, string axis, Image< T >& output)
{
  Image< T > res;
  res = input;

  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++) {
      if (axis.substr(0, 1) == "v" || axis.substr(0, 1) == "V")
	res[i][j] = input[i][input.getWidth()-1-j];
      if (axis.substr(0, 1) == "h" || axis.substr(0, 1) == "H")
	res[i][j] = input[input.getHeight()-1-i][j];
    }
  output = res;
}

template< class T > void Reflect(Image< T >& input, string axis)
{
  Reflect(input, axis, input);
}
