/* Copyright (c) 2001 S.E. Grigorescu */

#include "Rotation.h"

template void Rotate< int >(Image< int >&, float, Image< int >&);
template void Rotate< byte >(Image< byte >&, float, Image< byte >&);
template void Rotate< float >(Image< float >&, float, Image< float >&);
template void Rotate< int >(Image< int >&, float);
template void Rotate< byte >(Image< byte >&, float);
template void Rotate< float >(Image< float >&, float);
 
template< class T > void Rotate(Image< T >& input, float angle, Image< T >& output)
{
  double xc, yc, xn, yn, xo, yo, theta;
  double alfa, beta;
  int ir, jr;
  Image< T > res;
  res = input;
  res = 0;
  theta = -angle*acos(-1)/180;
  xc = ((double)(input.getWidth()-1))/2;
  yc = ((double)(input.getHeight()-1))/2;
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++){
      xn = j - xc; yn = i - yc; 
      xo = xn*cos(theta) + yn*sin(theta);
      yo = yn*cos(theta) - xn*sin(theta);
      xo += xc; yo += yc; 
//        jr = (int)rint(xo); ir = (int)rint(yo);
//        if (jr >= 0 && jr < input.getWidth() && ir >= 0 && ir < input.getHeight())
//  	res[i][j] = input[ir][jr];
      alfa = xo - floor(xo);
      beta = yo - floor(yo);
      jr = (int)floor(xo); ir = (int)floor(yo);
      if (jr >= 0 && jr < input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*(1-beta)*input[ir][jr] + alfa*(1-beta)*input[ir][jr+1] + 
	  (1-alfa)*beta*input[ir+1][jr] + alfa*beta*input[ir+1][jr+1]);      
      if (jr == -1 && jr < input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-beta)*input[ir][jr+1] + beta*input[ir+1][jr+1]);      
      if (jr >= 0 && jr == input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-beta)*input[ir][jr] + beta*input[ir+1][jr]);      
      if (jr >= 0 && jr < input.getWidth()-1 && ir == -1 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*input[ir+1][jr] + alfa*input[ir+1][jr+1]);      
      if (jr >= 0 && jr < input.getWidth()-1 && ir >= 0 && ir == input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*input[ir][jr] + alfa*input[ir][jr+1]);
    }
  output = res;
}

template< class T > void Rotate(Image< T >& input, float angle)
{
  Rotate(input, angle, input);
}
