/* Copyright (c) 2001 S.E. Grigorescu */

#include "Threshold.h"

template void Threshold< int >(Image< int >&, float, ByteImage&);
template void Threshold< byte >(Image< byte >&, float, ByteImage&);
template void Threshold< float >(Image< float >&, float, ByteImage&);
 
template< class T > void Threshold(Image< T >& input, float th_level, ByteImage& output)
{
  ByteImage res(input.getWidth(), input.getHeight(), output.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      res[i][j] = (input[i][j] < th_level) ? 0 : 255;
  output = res;
}
