/* Copyright (c) 2001 S.E. Grigorescu */

#include "Translation.h"

template void Translate< int >(Image< int >&, float, float, Image< int >&);
template void Translate< byte >(Image< byte >&, float, float, Image< byte >&);
template void Translate< float >(Image< float >&, float, float, Image< float >&);
template void Translate< int >(Image< int >&, float, float);
template void Translate< byte >(Image< byte >&, float, float);
template void Translate< float >(Image< float >&, float, float);
 
template< class T > void Translate(Image< T >& input, float x, float y, Image< T >& output)
{
  double xo, yo, alfa, beta;
  int ir, jr;
  Image< T > res;
  res = input;
  res = 0;
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++){
      xo = j - x; yo = i - y; 
      alfa = xo - floor(xo);
      beta = yo - floor(yo);
      jr = (int)floor(xo); ir = (int)floor(yo);
      if (jr >= 0 && jr < input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*(1-beta)*input[ir][jr] + alfa*(1-beta)*input[ir][jr+1] + 
	  (1-alfa)*beta*input[ir+1][jr] + alfa*beta*input[ir+1][jr+1]);      
      if (jr == -1 && jr < input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-beta)*input[ir][jr+1] + beta*input[ir+1][jr+1]);      
      if (jr >= 0 && jr == input.getWidth()-1 && ir >= 0 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-beta)*input[ir][jr] + beta*input[ir+1][jr]);      
      if (jr >= 0 && jr < input.getWidth()-1 && ir == -1 && ir < input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*input[ir+1][jr] + alfa*input[ir+1][jr+1]);      
      if (jr >= 0 && jr < input.getWidth()-1 && ir >= 0 && ir == input.getHeight()-1)
	res[i][j] = (T)((1-alfa)*input[ir][jr] + alfa*input[ir][jr+1]);
    }
  output = res;
}

template< class T > void Translate(Image< T >& input, float x, float y)
{
  Translate(input, x, y, input);
}




