/* Copyright (c) 2001 S.E. Grigorescu */

#include "Upsampling.h"

template void Upsample< int >(Image< int >&, Image< int >&);
template void Upsample< byte >(Image< byte >&, Image< byte >&);
template void Upsample< float >(Image< float >&, Image< float >&);
template void Upsample< int >(Image< int >&);
template void Upsample< byte >(Image< byte >&);
template void Upsample< float >(Image< float >&);
 
template< class T > void Upsample(Image< T >& input, Image< T >& output)
{
  Image< T > res(2*input.getWidth(), 2*input.getHeight(), output.getName());
  res = 0;

  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      res[2*i][2*j] = input[i][j];
  output = res;
}

template< class T > void Upsample(Image< T >& input)
{
  Upsample(input, input);
}
