/* Copyright (c) 2001 S.E. Grigorescu */

#include "Conversion.h"

void byte2int(Image< byte >& input, Image< int >& output)
{
  Image< int > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (int)input[i][j];
  output = tmp_img;
}

void byte2int(ByteImage& input, IntImage& output) 
{
  IntImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (int)input[i][j];
  output = tmp_img;
}

void byte2float(Image< byte >& input, Image< float >& output) 
{
  Image< float > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (float)input[i][j];
  output = tmp_img;
}

void byte2float(ByteImage& input, FloatImage& output) 
{
  FloatImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (float)input[i][j];
  output = tmp_img;
}

void int2byte(Image< int >& input, Image< byte >& output) 
{
  Image< byte > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = input[i][j] == 0 ? 0 : 255;
  output = tmp_img;
}

void int2byte(IntImage& input, ByteImage& output) 
{
  ByteImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = input[i][j] == 0 ? 0 : 255;
  output = tmp_img;
}

void int2float(Image< int >& input, Image< float >& output) 
{
  Image< float > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (float)input[i][j];
  output = tmp_img;
}

void int2float(IntImage& input, FloatImage& output) 
{
  FloatImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (float)input[i][j];
  output = tmp_img;
}

void float2byte(Image< float >& input, Image< byte >& output) 
{
  Image< byte > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = fabs(input[i][j]) < 10e-6 ? 0 : 255;
  output = tmp_img;
}

void float2byte(FloatImage& input, ByteImage& output) 
{
  ByteImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = fabs(input[i][j]) < 10e-6 ? 0 : 255;
  output = tmp_img;
}

void float2int(Image< float >& input, Image< int >& output) 
{
  Image< int > tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (int)rint(input[i][j]);
  output = tmp_img;
}

void float2int(FloatImage& input, IntImage& output) 
{
  IntImage tmp_img(input.getWidth(), input.getHeight(), 
		       input.getName());
  for (int i = 0; i < input.getHeight(); i++)
    for (int j = 0; j < input.getWidth(); j++)
      tmp_img[i][j] = (int)rint(input[i][j]);
  output = tmp_img;
}







