/* Copyright (c) 2001 C. Grigorescu S.E. Grigorescu */

#include "IntImage.h"

IntImage &IntImage::operator&=(const IntImage &img)
{
  if((width!=img.width) || (height!=img.height)) { 
    ERROR("The images have different sizes"); 
  }
    
  try { 
    Assert<Fatal_error>(img.pixels); 
  }
  catch(Fatal_error e) {e.print("Invalid data");}

  for(int i=0;i<getSize();i++)
    pixels[0][i] = pixels[0][i] & img.pixels[0][i];

  return *this;
}

IntImage &IntImage::operator|=(const IntImage &img)
{
  if((width!=img.width) || (height!=img.height)) { 
    ERROR("The images have different sizes"); 
  }
    
  try { 
    Assert<Fatal_error>(img.pixels); 
  }
  catch(Fatal_error e) {e.print("Invalid data");}

  for(int i=0;i<getSize();i++)
    pixels[0][i] = pixels[0][i] | img.pixels[0][i];

  return *this;
}

IntImage &IntImage::operator=(Image< int >& img)
{
  width = img.getWidth();
  height = img.getHeight();
  setName(img.getName());
  if (img.getWidth()*img.getHeight() != 0)
    setPixels(img.getWidth(), img.getHeight(), img.getPixels());
  else
    pixels = NULL;
  return *this;
}
