/* Copyright (c) 2001 C. Grigorescu */

#include "imlib_io.h"
#include "IntKernel.h"

static int L_1[9] = { 0, -1,  0, -1,  4, -1,  0, -1,  0};
static int L_2[9] = {-1, -1, -1, -1,  8, -1, -1, -1, -1};
static int S_H[9] = {-1, -2, -1,  0,  0,  0,  1,  2,  1};
static int S_V[9] = {-1,  0,  1, -2,  0,  2, -1,  0,  1};
static int P_H[9] = {-1, -1, -1,  0,  0,  0,  1,  1,  1};
static int P_V[9] = { 1,  0, -1,  1,  0, -1,  1,  0, -1};
static int K_1[9] = { 5,  5,  5, -3,  0, -3, -3, -3, -3};
static int K_2[9] = {-3,  5,  5, -3,  0,  5, -3, -3, -3};
static int K_3[9] = {-3, -3,  5, -3,  0,  5, -3, -3,  5};
static int K_4[9] = {-3, -3, -3, -3,  0,  5, -3,  5,  5};
static int K_5[9] = {-3, -3, -3, -3,  0, -3,  5,  5,  5};
static int K_6[9] = {-3, -3, -3,  5,  0, -3,  5,  5, -3};
static int K_7[9] = { 5, -3, -3,  5,  0, -3,  5, -3, -3};
static int K_8[9] = { 5,  5, -3,  5,  0, -3, -3, -3, -3};


IntKernel::IntKernel(INT_KERNEL_TYPE _kernel_type=LAPLACIAN_1, char *name="") :
 Kernel< int >(name) 
{
  kernel_type = _kernel_type;
  switch(kernel_type) {
   case LAPLACIAN_1:
     setPixels(3,3,L_1);
     break;
   case LAPLACIAN_2:
     setPixels(3,3,L_2);
     break;
  case SOBEL_H:
    setPixels(3,3,S_H);
    break;
  case SOBEL_V:
    setPixels(3,3,S_V);
    break;
  case PREWITT_H:
    setPixels(3,3,P_H);
    break;
  case PREWITT_V:
    setPixels(3,3,P_V);
    break;
  case KIRSCH_1:
    setPixels(3,3,K_1);
    break;
  case KIRSCH_2:
    setPixels(3,3,K_2);
    break;
  case KIRSCH_3:
    setPixels(3,3,K_3);
    break;
  case KIRSCH_4:
    setPixels(3,3,K_4);
    break;
  case KIRSCH_5:
    setPixels(3,3,K_5);
    break;
  case KIRSCH_6:
    setPixels(3,3,K_6);
    break;
  case KIRSCH_7:
    setPixels(3,3,K_7);
    break;
  case KIRSCH_8:
    setPixels(3,3,K_8);
    break;
  default: 
    kernel_type = KERNEL_INT_UNKNOWN;
   }     
}  

IntKernel &IntKernel::operator^(IntKernel &kernel)
{
  for (int i=0;i<getSize();i++)
    pixels[0][i] = -pixels[0][i];
  return (*this);
}



