#ifndef _defaultfactory_h_
#define _defaultfactory_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        defaultfactory.h
 * Description: factory, that generates a pipe of the libraries 
 *              original implementation  
 * Created:     2001-08-06
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 *
 * ------------------------ Revision History --------------------------
 * $Log: defaultfactory.h,v $
 * Revision 1.3  2001/08/10 14:11:57  slange
 * working on the next build
 *
 * Revision 1.2  2001/08/07 12:40:14  slange
 * - still refactoring
 * - initial checkin of defaultfactory.cpp, objectlist.h region.h
 *
 * Revision 1.1  2001/08/06 15:59:47  slange
 * - started refactoring of the library
 * - first commit of cvtk.h cvtkfacade.h defaultfacade.cpp
 *   defaultfacade.h defaultfactory.h
 *
 * --------------------------------------------------------------------
 */

#include <string>
#include "cvtkfacade.h"

namespace cvtk {

  /* the factory constructs and returns a whole pipe on demand
   */  
  class CDefaultFactory : public CCVTKFacadeFactory {
  public:
    CDefaultFactory(string,        // filename of the lookuptable
		    string,        // filename of the object templates
		    int=3,         // minimum Size of Regions
		    int=3);        // depth of history
    virtual CCVTKFacade* getCVTKFacade();
  private:
    string lutFile;
    string tmplFile;
    int minRegionSize, historyDepth;
  };

}

#endif      /* _defaultfactory_h_ */


