/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        fileis.cpp
 * Description: Implementation of the image sources using files.
 * Created:     2001-06-20
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * ------------------------- Revision History -------------------------
 * $Log: fileis.cpp,v $
 * Revision 1.4  2001/08/13 15:36:40  slange
 * - build successfully
 * - initial checkin of objectlist.cpp
 * - removed graphics.h (now rgbmap.h) and ppm.cpp
 *
 * Revision 1.3  2001/08/10 14:11:57  slange
 * working on the next build
 *
 * Revision 1.2  2001/06/21 00:11:45  slange
 * - use single image in main for testing and profiling
 *
 * Revision 1.1  2001/06/20 12:27:47  slange
 * Initial check in of fileis.h and fileis.cpp
 *
 * --------------------------------------------------------------------
 */

#include "fileis.h"
#include <unistd.h>
#include <cstdio>
#include <fstream>

cvtk::CSingleImage::CSingleImage(string filename)
  : CImageSource()
{
  std::ifstream in (filename.c_str());
  if (!in) {
    cerr << "Cannot open image file " << filename << endl;
    exit(1);
  }
  CPPM dummy;
  in >> dummy;
  image = dummy;
}
cvtk::CSingleImage::CSingleImage(CRGBMap image)
  : image(image)
{
}
cvtk::CSingleImage::~CSingleImage()
{
}

cvtk::CRGBMap cvtk::CSingleImage::getImage()
{ 
  return image;
}

cvtk::CRGBMap& cvtk::CSingleImage::getImage(CRGBMap& rgbMap)
{
  return (rgbMap = image);
}










