#ifndef _fileis_h_
#define _fileis_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        fileis.h
 * Description: ImageSources reading imagefiles
 * Created:     2001-06-20
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 *
 * ------------------------- Revision History -------------------------
 * $Log: fileis.h,v $
 * Revision 1.3  2001/08/13 15:36:40  slange
 * - build successfully
 * - initial checkin of objectlist.cpp
 * - removed graphics.h (now rgbmap.h) and ppm.cpp
 *
 * Revision 1.2  2001/08/10 14:11:57  slange
 * working on the next build
 *
 * Revision 1.1  2001/06/20 12:27:47  slange
 * Initial check in of fileis.h and fileis.cpp
 *
 * -------------------------------------------------------------------
 */

#include "imagesource.h"
#include <string>

namespace cvtk {

  class CSingleImage : public CImageSource {
  public:
    CSingleImage(string filename);
    CSingleImage(CRGBMap image);
    virtual ~CSingleImage();
    virtual CRGBMap& getImage(CRGBMap& rgbMap);
    virtual CRGBMap getImage();
    virtual int getWidth() const { return image.getWidth(); }
    virtual int getHeight() const { return image.getHeight(); }
  private:
    CRGBMap image;
  };

}

#endif











