/**********************************************************************
 * FISHERTECHNIK COMPUTING INTERFACE Nr. 30402                        *
 *                                                                    *
 * LAST EDIT: 01-02-21       (c) S.Lange                              *
 *                                                                    *
 * PRGOGRAMMER:        S. Lange                                       *
 *                                                                    *
 * POSTAL ADRESS:      Fa. SL-EDV Beratung                            *
 *                     Wacholderweg 19                                *
 *                     49740 Haseluenne                               *
 *                     Germany                                        *
 *                                                                    *
 * TELEPHONE:          ++ 49 5961-4437                                *
 * E-MAIL:             salange@uos.de                                 *
 * HOMEPAGE:           www-lehre.inf.uos.de/~slange                   *
 **********************************************************************
 * This program is free software; you can redistribute it and/or      *
 * modify it under the terms of the GNU General Public License        *
 * as published by the Free Software Foundation; either version 2     *
 * of the License, or (at your option) any later version.             *
 *                                                                    *
 * This program is distributed in the hope that it will be useful,    *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 * GNU General Public License for more details.                       *
 *                                                                    *
 * You should have received a copy of the GNU General Public License  *
 * along with this program; if not, write to the Free Software        *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA          *
 * 02111-1307, USA.                                                   *
 *********************************************************************/

#ifndef _ft_interface_h_
#define _ft_interface_h_

typedef enum {STOP, LEFT, RIGHT} motor_direction;
typedef enum {VERYFAST=1, FAST=2, NORMAL=4, SLOW=8, 
	      VERYSLOW=16, SAME=0} motor_speed;

typedef struct {
  motor_direction motor[4];
  int digi[8];
} interface_status;

typedef void* ftHandle;

ftHandle openInterface(char * device);   // connects to the specified
                                         // interface

void closeInterface(ftHandle ft);        // closes the interface

interface_status getInterfaceStatus(ftHandle ft); // returns the status
void setInterfaceStatus(ftHandle ft, interface_status setTo); 
                                         // set the motors

void setMotor(ftHandle ft, int num, motor_direction dir,
              motor_speed speed);        // set one motor
int isDigiOn(ftHandle ft, int num);      // tests one digi

#endif
















