#ifndef _imagesource_h_
#define _imagesource_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        imagesource.h
 * Description: Interface declaration for an image-source.
 * Created:     2001-03-28
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://www.cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 *-------------------------- Revision History -------------------------
 * $Log: imagesource.h,v $
 * Revision 1.4  2001/08/13 15:36:40  slange
 * - build successfully
 * - initial checkin of objectlist.cpp
 * - removed graphics.h (now rgbmap.h) and ppm.cpp
 *
 * Revision 1.3  2001/08/06 15:59:47  slange
 * - started refactoring of the library
 * - first commit of cvtk.h cvtkfacade.h defaultfacade.cpp
 *   defaultfacade.h defaultfactory.h
 *
 * Revision 1.2  2001/04/23 18:42:52  slange
 * added copyright notice to all source files
 *
 * --------------------------------------------------------------------
 */

#include "rgbmap.h"

namespace cvtk {

  /* interface to the image source
   */
  class CImageSource {
  public:
    virtual CRGBMap& getImage(CRGBMap&) =0; 
    virtual CRGBMap getImage() =0;          
    virtual int getWidth() const =0;        // width and height
    virtual int getHeight() const =0;       // of the aquired  images
    virtual ~CImageSource() {};
  };

}

#endif
  








