/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        lookable.cpp
 * Description: Implementation of the lockable.
 * Created:     2001-03-22
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://www.cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * ------------------------------- Revision History --------------------------
 * $Log: lockable.cpp,v $
 * Revision 1.2  2001/04/23 18:42:52  slange
 * added copyright notice to all source files
 *
 * ---------------------------------------------------------------------------
 */

#include "lockable.h"

CLockable::CLockable() 
{};

void CLockable::lock() const 
{ 
  key=mutex.hold();
};
bool CLockable::isLocked() const 
{ 
  return mutex.isLocked(); 
};
bool CLockable::unlock() const
{ 
  if (!isLocked()) return false;      // exception
  return mutex.release(key);
};













