#ifndef _monitors_h_
#define _monitors_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        monitors.h
 * Description: methods to monitor cvtk's analyzing steps
 * Created:     2001-08-31
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 *
 * ------------------------ Revision History --------------------------
 * $Log: monitors.h,v $
 * Revision 1.3  2001/09/02 17:39:07  slange
 * cvs error!
 *
 * Revision 1.2  2001/09/01 17:40:09  slange
 * - working on monitor
 * - moved template calibration into namespace "cvtk"
 *
 * Revision 1.1  2001/09/01 13:28:41  slange
 * - working on monitor functions
 *
 * --------------------------------------------------------------------
 */

#include "cvtk.h"

namespace cvtk {

  class Monitors {
  public:
    static void visualizeRegionMap(const CRegionMap& segments,
				   CRGBMap& visual, 
				   bool clearBG=false);    
    static void visualizeRegionList(const CRegionList& rlist,
				    CRGBMap& visual);
    static void visualizeObjectList(const CObjectList& objs,
				    CRGBMap& visual);
  protected:
    static void drawLine(CRGBMap& visual, int x1, int y1, 
			 int x2, int y2, RGBValue color);
  };
}

#endif
