/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        objecthistory.cpp
 * Description: object history
 * Created:     2001-07-17
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 *
 * ------------------------ Revision History --------------------------
 * $Log: objecthistory.cpp,v $
 * Revision 1.11  2001/09/02 17:39:07  slange
 * cvs error!
 *
 * Revision 1.10  2001/08/28 13:16:48  slange
 * - traced down a bug: historylist to small!
 *
 * Revision 1.9  2001/08/10 00:57:05  slange
 * - moved search into namespace cvtk
 * - restructured historymatching and objecthistory
 *
 * Revision 1.8  2001/08/09 17:00:54  slange
 * - reorganized colorsegmentation and the lookuptable
 * - some other corrections
 *
 * Revision 1.7  2001/08/02 18:46:32  slange
 * - initial checkin of templatewidget.[h/cpp]
 * - working on velocity
 *
 * Revision 1.6  2001/08/02 17:19:56  slange
 * - first checkin of output.[h/cpp]
 *
 * Revision 1.5  2001/07/29 10:27:30  slange
 * - finished object history matching!
 *
 * Revision 1.4  2001/07/28 22:22:43  slange
 * - found and traced down a bug
 *
 * Revision 1.3  2001/07/28 21:51:15  slange
 * - finished search algorithm
 *
 * Revision 1.2  2001/07/16 20:02:34  slange
 * - working on the history matching
 *
 * Revision 1.1  2001/07/16 14:35:26  slange
 * - initial check in of objecthistory.[h/cpp]
 * - working on pendular demonstration and history
 *
 * --------------------------------------------------------------------
 */


#include "objecthistory.h"
#include "searchmatch.h"

cvtk::CObjectHistory::CObjectHistory(int templNumber,
				     int objectID,
				     unsigned int sizeOfHistory) 
  : objectClass(objectClass), uid(objectID), nTicksNotSeen(0),
    sizeOfHistory(sizeOfHistory)
{};

void cvtk::CObjectHistory::insert(CObject& obj)
{
  history.push_front(obj);
  history.front().uid=uid;
  if (history.size() > sizeOfHistory)
    history.pop_back();
}







