#ifndef _output_h_
#define _output_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        output.h
 * Description: basic implementation of the output layer
 * Created:     2001-08-10
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 *
 * ------------------------ Revision History --------------------------
 * $Log: output.h,v $
 * Revision 1.3  2001/10/30 11:07:29  slange
 * introduced time resolution to output.h, to calculate the velocity
 * and direction
 *
 * Revision 1.2  2001/08/10 01:23:45  slange
 * finished first pass over
 *
 * --------------------------------------------------------------------
 */

#include <vector>
#include "cvtk.h"

namespace cvtk {

  class CDefaultOutput : public COutput {
  public:
    CDefaultOutput(int timeUnit=1, unsigned int tRes=1);
    virtual CObjectHistoryList* setTimeStamp(CObjectHistoryList*, int);
    virtual CObjectHistoryList* calcMovement(CObjectHistoryList*);
    virtual CObjectList* getOutput(const CObjectHistoryList*);
    virtual CObjectList* getOutput(const CObjectHistoryList*,
				   CObjectList*);
  private:
    int timeUnit;
    unsigned int tRes;              // resolution of the velocity
  };

}

#endif    /* _output_h_ */













