/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        rgbhistogram.cpp
 * Description: histogram in an rgb color-space 
 * Created:     2001-05-03
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * ------------------------- Revision History -------------------------
 * $Log: rgbhistogram.cpp,v $
 * Revision 1.3  2001/08/30 13:24:30  slange
 * - added sliders to effect the specificity of the kmsegmentation
 *
 * Revision 1.2  2001/05/03 15:04:09  slange
 * - added lookup table data for orange/yellow/blue on green/black/white
 *   background to rsc
 * - fixes
 *
 * Revision 1.1  2001/05/03 01:19:18  slange
 * - Initial revision of CRGBHistogram
 * - added template class CHistogram3Dim
 *
 * --------------------------------------------------------------------
 */

#ifndef EXPORT_NOT_IMPLEMENTED
#include "rgbhistogram.h"
#endif

#ifndef EXPORT_NOT_IMPLEMENTED
export
#endif
template<int maxValue>
cvtk::CRGBHistogram<maxValue>::CRGBHistogram() 
  : CHistogram3Dim<maxValue>()
{};





