/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        uvhistogram.h
 * Description: histogram in an (H)UV color-space approximation working
 *              with RGBs.
 * Created:     2001-04-28
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * ------------------------------- Revision History --------------------------
 * $Log: uvhistogram.cpp,v $
 * Revision 1.2  2001/09/02 17:39:07  slange
 * cvs error!
 *
 * Revision 1.1  2001/04/27 23:15:42  slange
 * - added an UV - Histogram (histogram in an approximation of the HUV space)
 * - changed the Calibrate::CController
 *   - to work with histograms
 *   - to keep a vector of examples in memory
 *   - output file dropped
 *   - to tread the background as a (special) object
 * - fixes
 *
 * ---------------------------------------------------------------------------
 */

#include "uvhistogram.h"

cvtk::CUVHistogram::CUVHistogram() : CHistogram2Dim<512>()
{};
