#ifndef _webcam_h_
#define _webcam_h_

/*
 * Package:     cvtk - Computer Vision Tool Kit
 * File:        webcam.h
 * Description: ImageSource using a video4linux device. Tested with cpia-type
 *              webcam
 * Created:     2001-03-28
 * Author:      Sascha Lange
 * Mail:        Sascha.Lange@Uni-Osnabrueck.De
 *
 * Web:         http://www.cvtk.sourceforge.net
 *
 * Copyright (C) 2001 Sascha Lange
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 *
 * ------------------------- Revision History -------------------------
 * $Log: webcam.h,v $
 * Revision 1.3  2001/08/10 14:11:57  slange
 * working on the next build
 *
 * Revision 1.2  2001/04/23 18:42:52  slange
 * added copyright notice to all source files
 *
 * --------------------------------------------------------------------
 */

#include "imagesource.h"
#include "cvtk.h"
#include <string>

namespace cvtk {
  
  class CWebCam : public CImageSource {
  public:
    CWebCam(int width=0, int height=0, string videoDev="/dev/video0");
    virtual ~CWebCam();
    virtual CRGBMap& getImage(CRGBMap& rgbMap);
    virtual CRGBMap getImage();
    virtual int getWidth() const { return width; }
    virtual int getHeight() const { return height; }
  private:
    int width, height;
    int fileDesc;
  };

}

#endif











