//draws the output graph
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.geom.Rectangle2D;
              

class drawGraph extends JPanel{
	ArrayList input;
	int graphHieght = 300;
	int graphWidth = 400;
	int heighest = 0;
	int barWidth;
	int[] freqs;
	int[] hieghts;
	String fileName = "";
	//the constructor
	public drawGraph(ArrayList data, String f){
		fileName = f;
		input = data;
		//first get the data
		freqs = new int[(input.size()-2)];
		for(int i = 0; i < (input.size()-2); i++){
			String s = (String) input.get(i);
			Integer I = new Integer(s);
			int value = I.intValue();
			freqs[i] = value;
		}
		//find the hieghest value
		for(int j = 0; j < freqs.length; j++){
			int num = freqs[j];
			if(num > heighest){
				heighest = num;
			}
		}
		//find the width of each bar
		barWidth = graphWidth / freqs.length;
		//find the height of the bars, so that they all fit in the window
		hieghts = new int[(input.size()-2)];
		float h = heighest;
		for(int k = 0; k < hieghts.length; k++){
			float num = freqs[k];
			float adjusted = num / h;
			adjusted = graphHieght * adjusted;
			int value = Math.round(adjusted);
			hieghts[k] = value;
		}
		
		 
	}
	public void paint(Graphics g){
		Graphics2D g2 = (Graphics2D) g;
		
		int border = 40;
		g2.setColor(Color.white);
		g2.fillRect(0, 0, 480, 380);
		int x = border;
		g2.setColor(Color.black);
		g2.drawLine(40, 20, 40, graphHieght + border + 11);
		g2.drawString("Results from input file: "+fileName, 3, 10);
		//draw the y axis label
		g2.drawString(""+ heighest, 3, border);
		g2.drawString("0", 3, graphHieght+border);
		g2.drawString("F", 15, (graphHieght/2) -20);
		g2.drawString("r", 15, (graphHieght/2) -10);
		g2.drawString("e", 15, graphHieght/2);
		g2.drawString("q", 15, (graphHieght/2) +10);
		g2.drawLine(35, graphHieght + border, graphWidth+45, graphHieght + border);
		g2.drawString("Class No.", ((graphWidth +border)/2) - 24, graphHieght+border + 30);
		for(int i = 0; i < input.size()-2; i++){
			//don't forget that the coord system has an inverted y axis
			int y = graphHieght + border - (hieghts[i]);
			g2.setColor(Color.red);
			//draw a bar
			//add some fancy shading
			//g2.setPaint(new GradientPaint(x, y, Color.lightGray, x+barWidth, y+hieghts[i], Color.blue, false));
			g2.setPaint(new GradientPaint(border, border, Color.red, border, graphHieght+border, Color.blue, false));
			
			g2.fill(new Rectangle2D.Double(x, y, barWidth, hieghts[i]));
			//draw the outline
			g2.setColor(Color.darkGray);
			g2.draw(new Rectangle2D.Double(x, y, barWidth, hieghts[i]));
			//g2.fill3DRect( x, y, barWidth, hieghts[i], true);
			g2.setColor(Color.black);
			//add a label on top
			g2.drawString(""+freqs[i], x+1, y-1);
			g2.drawString(""+ i, x +3, graphHieght +border + 13); 
			x = x + barWidth;
		}
	}
}		
	