/***************************************************************************
* Filename: ipxPluginInterface.h 
* Copyright (C) 2000-2001 Daniel X. Pape. 
* 
* This file contains declarations for the public functions that
* localOperator expects each specific plugin to implement.
* 
***************************************************************************
* Revision History: 
* Thursday, January 13, 2000 - Original 
***************************************************************************
* This program is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2 of the License, or 
* (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software 
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
***************************************************************************/


#ifndef _IPXPLUGININTERFACE_H_
#define _IPXPLUGININTERFACE_H_

#include "libgimp/gimp.h"


/* globals from localOperator.c */
extern gint windowSize, halfWindowSize, numPixelsInWindow;

/* functions the plugins need to implement */
void query(void);
void run(char *name, int nparams, GimpParam *param, int *nreturn_vals,
         GimpParam **return_vals);

/* functions the plugins may implement */
void initOperator(void);
void cleanupOperator(void);

void preProcessWindowPass(GimpPixelRgn *srcPR, gint currentPassNumber);
guchar processWindow(guchar **w, gint currentPassNumber);
void postProcessWindowPass(GimpPixelRgn *srcPR, gint currentPassNumber);

void preProcessPointPass(GimpPixelRgn *srcPR, gint currentPassNumber);
guchar processPoint(guchar point, gint currentPassNumber);
void postProcessPointPass(GimpPixelRgn *srcPR, gint currentPassNumber);


#endif
