/***************************************************************************
* Filename: ipxUtils.h 
* Copyright (C) 2000-2001 Daniel X. Pape. 
* 
* This file contains some simple utilities for the plugins to use, such
* as min/max calculation and sorting routines.
* 
***************************************************************************
* Revision History: 
* Thursday, July 23, 1998 - Original 
***************************************************************************
* This program is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2 of the License, or 
* (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software 
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
***************************************************************************/

#ifndef _IPXUTILS_H_
#define _IPXUTILS_H_

#include "libgimp/gimp.h"


void minmax_char(guchar *a, gint len, gint *result);
void minmax_int(gint *a, gint len, gint *result);
gint adjust(double q);
void bubblesort_int(gint *l, gint n);
void bubblesort_char(guchar *l, gint n);
guchar select_char(guchar *L, gint n, gint k);
gint select_int(gint *L, gint n, gint k);


#define RMS(a,b) (sqrt (pow ((a),2) + pow ((b), 2)))
#define ROUND_TO_INT(val) ((val) + 0.5)

#ifndef MAX
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#endif


#endif
