/***************************************************************************
* Filename: localOperatorP.h
* Copyright (C) 2000-2001 Daniel X. Pape. 
* 
* This file contains declarations for some of localOperator's private
* functions. This is because a few of the "complicated" plugins need
* them.
* 
***************************************************************************
* Revision History: 
* Thursday, January 13, 2000 - Original 
***************************************************************************
* This program is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 2 of the License, or 
* (at your option) any later version. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software 
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
***************************************************************************/


#include "libgimp/gimp.h"

/* localOperator's private functions */

void prepare_row (GimpPixelRgn *pixel_rgn, guchar *data, int x, int y, int w);
guchar ** initRowBuffers(void);
guchar ** initWindowBuffer(void);
void initPixelRegions(GimpDrawable *drawable, GimpPixelRgn *srcPR, GimpPixelRgn *tmpPR,
                      GimpPixelRgn *dstPR, int numPasses);
gint fillRowBuffers(guchar **rows, GimpPixelRgn *currentSrcPR);
gint updateRowBuffers(guchar **rows, GimpPixelRgn *currentSrcPR,
                      gint last_row_retrieved);
void getWindowFromRows(gint col, guchar **window, guchar **rows);

