.ds Vn 2.1
.TH Vplain 5Vi "17 February 1994" "Vista Version \*(Vn"
.SH NAME
Vplain \- Vista plain file format for images
.SH SYNOPSIS
\fIfile\fP ::= \fIheader\fP \fIpixel-values\fP
.PP
\fIheader\fP ::= \fIpixel-repn\fP \fInbands\fP \fInrows\fP \fIncolumns\fP
.PP
\fIpixel-repn\fP ::= \fBbit\fP | \fBubyte\fP | \fBsbyte\fP | \fBshort\fP |
\fBlong\fP | \fBfloat\fP | \fBdouble\fP
.PP
\fIpixel-values\fP ::= \fIpixel0 pixel1\fP ...
.SH DESCRIPTION
The Vista plain file format allows a small image to be created entirely 
using a text editor. The format represents a single image in a file 
containing only ASCII characters. Any numbers, such as pixel values, are 
represented in the file with ASCII decimal digits. 
.PP
A file conforming to the plain file format contains the following entries 
in sequence: 
.RS 2n
.IP \(bu 2n
a keyword specifying the image's pixel representation. It must be one of 
\fBbit\fP, \fBubyte\fP, \fBsbyte\fP, \fBshort\fP, \fBlong\fP, \fBfloat\fP, 
or \fBdouble\fP. 
.IP \(bu
the number of bands in the image, \fInbands\fP
.IP \(bu
the number of rows in the image, \fInrows\fP
.IP \(bu
the number of columns in the image, \fIncolumns\fP
.IP \(bu
\fInbands\fP * \fInrows\fP * \fPncolumns\fP pixel values ordered by band, 
row, and column. All pixel values of band 0 are first, followed by all 
those of band 1, etc. Within each band, all pixel values of row 0 are 
first, followed by all those of row 1, etc. Within each row, the pixel 
value for column 0 is first, followed by that for column 1, etc. 
.RE
.PP
These entries are separated by whitespace (i.e., any combination of one or 
more of the following characters: tab, carriage return, newline, vertical 
tab, form feed, or blank). Characters between a ``\fB#\fP'' character and a 
newline are treated as a comment, and ignored by software.
.PP
By convention, plain-file-format files have names ending in ``\fB.pv\fP''.
.SH EXAMPLE
Here is an image represented in plain file format: 
.PP
.nf
.ft B
.RS
# cube.pv - an image of a wire-frame cube
bit   # pixel representation 
1  8  8   # nbands, nrows, and ncolumns
# data begins
0 0 0 0 0 0 0 0
0 0 0 1 1 1 1 0
0 0 1 0 0 1 1 0
0 1 1 1 1 0 1 0
0 1 0 0 1 0 1 0
0 1 0 0 1 1 0 0
0 1 1 1 1 0 0 0
0 0 0 0 0 0 0 0
# end of file
.RE
.SH "SEE ALSO"
.BR plaintov (1Vi),
.BR VReadPlain (3Vi),
.BR Vlib (7Vi)
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
