.ds Vn 2.1
.ds BD /usr/bin/vista
.TH Vindex 7Vi "23 April 1994" "Vista Version \*(Vn"
.SH NAME
Vindex \- index of Vista programs
.SH DESCRIPTION
.SS Programs
The following is a list of Vista programs currently available. Each is 
documented by a section 1Vi manual page named after it. 
.PP
For viewing the contents of Vista data files under X Windows:
.RS 2n
.IP \fBvxview\fP 15n
general-purpose viewer
.IP \fBvxviewe\fP
viewer optimized for displaying only edge sets and images
.IP \fBvxviewi\fP
viewer optimized for displaying only images
.RE
.PP
For basic image processing:
.RS 2n
.IP \fBvadjust\fP 15n
adjusts an image's brightness and/or contrast
.IP \fBvconvert\fP
converts an image's pixel representation
.IP \fBvcrop\fP
extracts a rectangular region from an image
.IP \fBvflip\fP
flips an image horizontally and/or vertically
.IP \fBvinvert\fP
inverts an image, swapping black and white
.IP \fBvistat\fP
reports image statistics
.IP \fBvnegate\fP
negates an image
.IP \fBvop\fP
performs arithmetic and logical operations on image pixels
.IP \fBvrgbtogray\fP
converts a RGB image into a gray-scale image
.IP \fBvrotate\fP
rotates an image by any angle
.IP \fBvscale\fP
scales an image in size
.IP \fBvsynth\fP
synthesize an image with a pattern or random noise
.IP \fBvtranspose\fP
tranposes the rows and columns of an image
.IP \fBvxadjust\fP
interactively adjust image brightness and/or contrast
.IP \fBvxcrop\fP
interactively crop an image
.IP \fBvzeroc\fP
marks the zero crossings in an image
.RE
.PP
For filtering images:
.RS 2n
.IP \fBvblur\fP 15n
blur an image and add noise to it
.IP \fBvconvolve\fP
convolves an image with a mask
.IP \fBvgauss\fP
convolve an image with a Gaussian or its derivative
.IP \fBvgrad\fP
estimates intensity gradient at each image pixel
.RE
.PP
For Fourier analysis of images:
.RS 2n
.IP \fBvcomplex\fP 15n
builds a complex image from real and imaginary components
.IP \fBvfft\fP
computes forward or inverse Fourier transform of an image
.IP \fBvmag\fP
computes magnitude of a complex image
.IP \fBvphase\fP
computes phase of a complex image
.RE
.PP
For detecting and processing intensity edges:
.RS 2n
.IP \fBvcanny\fP 15n
Canny's edge detector
.IP \fBvlink\fP
link connected non-zero image points into edges
.IP \fBvsegedges\fP
segments edges into straight lines
.RE
.PP
For manipulating Vista data files:
.RS 2n
.IP \fBvcat\fP 15n
concatenates Vista data files
.IP \fBvcatbands\fP
combines multiple images into a single, multi-band image
.IP \fBvselbands\fP
selects specified bands from an image
.IP \fBvselect\fP
selects specified objects from a Vista data file
.RE
.PP
For converting to and from other formats:
.RS 2n
.IP \fBplaintov\fP 15n
converts an image from Vista plain file format to the standard Vista format
.IP \fBpnmtov\fP
converts a Portable Anymap (PNM) to a Vista image
.IP \fBv1to2\fP
converts Vista data file from version 1 format to version 2
.IP \fBvtopgm\fP
converts Vista images to Portable Graymap (PGM) format
.RE
.PP
For outputting Vista data objects in PostScript:
.RS 2n
.IP \fBvlayout\fP 15n
arranges multiple PostScript figures on a single page
.IP \fBvtops\fP 
outputs Vista images and edge sets in PostScript
.RE
.PP
Miscellaneous:
.RS 2n
.IP \fBvcalsyn\fP 15n
for generating synthetic camera calibration data
.IP \fBvcamcal\fP
for calibrating and evaluating a camera model
.IP \fBvflow\fP
for computing optical flow from a motion sequence
.RE
.SS "Other Manual Pages"
Vista file formats are defined by these manual pages:
.RS 2n
.IP "\fBVfile\fP(5Vi)" 15n
defines the general format of Vista data files
.IP "\fBVCamera\fP(3Vi)"
defines the format of camera models in Vista data files
.IP "\fBVEdges\fP(3Vi)"
defines the format of edge sets in Vista data files
.IP "\fBVImage\fP(3Vi)"
defines the format of images in Vista data files
.IP "\fBVplain\fP(5Vi)"
defines a text file format for images
.RE
.SH FILES
Include \fB\*(BD\fP in your \fBPATH\fP environment variable in order
to access these programs. 
.SH "SEE ALSO"
.BR Vista (7Vi)
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
