.ds Vn 2.1
.TH VConvolveImageSep 3Vi "4 June 1994" "Vista Version \*(Vn"
.SH NAME
VConvolveImageSep \- convolve an image with a separable filter
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.fi
.HP 10n
.na
.nh
.ft B
VImage VConvolveImageSep (VImage\ \fIsrc\fP, VImage\ \fIdest\fP,
VBand\ \fIband\fP, VImage\ \fImasks\fP[3], 
VConvolvePadMethod\ \fIpad_methods\fP[3],
int\ \fIshifts\fP[3]);
.ft
.hy
.ad
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies one of the two images to be convolved (the source).
.IP \fIdest\fP
Specifies a destination image, or is
.SB NULL
to indicate that a new destination image should be created.
.IP \fIband\fP
Specifies a particular band of the source image to be convolved, or is
\fBVAllBands\fP to indicate that all bands should be convolved.
.IP \fImasks\fP
Specifies separate masks for the band, row, and columns dimensions.
.IP \fIpad_methods\fP
Specifies the method for handling border pixels when convolving along band,
row, and column dimensions.
.IP \fIshifts\fP
Specifies an amount by which to right-shift each destination pixel value
when convolving along band, row, and column dimensions.
.SH DESCRIPTION
\fBVConvolveImage\fP convolves a source image with up to three separate
mask images to produce a destination image. These convolutions are
performed by invocations of \fBVConvolveImage\fP(3Vi). See that man page
for an explanation of the values to be supplied by the \fIpad_methods\fP
and \fIshifts\fP arguments, and for a description of the type of
destination image produced.
.PP
Consecutive elements of the \fImasks\fP, \fIpad_methods\fP, and
\fIshifts\fP arrays specify consecutive one-dimensional convolutions along
the band, row, and column dimensions of \fIsrc\fP. If a particular element
of \fImasks\fP is non-\c
.SB NULL\c
, it is used along with the corresponding values from \fIpad_methods\fP and
\fIshifts\fP in a call to \fBVConvolveImage\fP. If, on the other hand, an
element of \fImasks\fP is
.SB NULL\c
, no convolution is performed along that dimension.
.PP
If \fIband\fP specifies a particular band (rather than \fBVAllBands\fP),
then the destination image has a single band whose pixel values are
computed by centering the band-wise mask on the specified band of the
source image.
.SH "RETURN VALUES"
\fBVConvolveImageSep\fP returns the destination image if it is successful and
.SB NULL
otherwise.
.SH "SEE ALSO"
.na
.nh
.BR VConvolveImage (3Vi),
.BR VGaussianConvolveImage (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``No mask specified.''"
All elements of \fImasks\fP are
.SB NULL\c
; at least one should be non-\c
.SB NULL.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
