.ds Vn 2.1
.TH VCopyBand 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VCopyBand \- copy image pixel values
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.B VBoolean VCopyBand (\fIsrc\fP, \fIsrc_band\fP, \fIdest\fP, \fIdest_band\fP)
.RS
.B VImage \fIsrc\fP, \fIdest\fP;
.B VBand \fIsrc_band\fP, \fIdest_band\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the image to copy from (the source image).
.IP \fIsrc_band\fP
May specify a particular band of the source image to copy from,
or may be \fBVAllBands\fP to indicate that all bands of the source
image should be copied.
.IP \fIdest\fP
Specifies the image to copy to (the destination image). 
.IP \fIdest_band\fP
Specifies the first band of the destination image to receive
pixel values from the source image.
.SH DESCRIPTION
\fBVCopyBand\fP copies pixel values from a source image, \fIsrc\fP,
to a destination image, \fIdest\fP. The two images must have the
same pixel representation, number of rows, and number of columns.
.PP
If \fIsrc_band\fP is the constant \fBVAllBands\fP, all of the source 
image's bands
of pixel values are copied to the destination image beginning at
the destination band \fIdest_band\fP. The destination image must have
at least \fIdest_band\fP\ +\ \fBVImageNBands\fP\ (\fIsrc\fP)\ -\ 1 bands.
.PP
Otherwise, \fIsrc_band\fP specifies a single band of the source image.
That band is copied to a single band, \fIdest_band\fP, of the destination
image. The destination image must have at least \fIdest_band\fP\ +\ 1
bands.
.PP
Unlike most Vista image processing routines, this one does not copy the
source image's attributes to the destination image.
.SH "RETURN VALUES"
\fBVCopyImage\fP returns 
.SB TRUE
if it is successful
and 
.SB FALSE
otherwise.
.SH "SEE ALSO"
.na
.nh
.BR VCopyImage (3Vi),
.BR VCombineBands (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``No destination specified.''"
The destination image, \fIdest\fP must be supplied.
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIsrc_band\fP (\fIdest_band\fP) argument is outside the range of
source (destination) image band numbers.
.IP "``Destination image has \fIdest_nbands\fP bands; \fInbands\fP expected.''"
The destination image has too few bands.
.IP "``Destination image has \fIdest_prop\fP \fIproperty\fP; \fIsrc_prop\fP expected.''"
\fIProperty\fP is one of ``pixels'', ``rows'', or ``columns''. The
destination image does not have the same pixel representation, number of
rows, and number of columns as the source image.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
