.ds Vn 2.1
.TH VCreateImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VCreateImage, VCreateImageLike \- allocate memory for an image
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
VImage VCreateImage (\fInbands\fP, \fInrows\fP, \fIncolumns\fP, \
\fIpixel_repn\fP)
.RS
int \fInbands\fP, \fInrows\fP, \fIncolumns\fP;
VRepnKind \fIpixel_repn\fP;
.RE
.fi
.PP
.B VImage VCreateImageLike (\fIsrc\fP)
.RS
.B VImage \fIsrc\fP;
.RE
.SH ARGUMENTS
.IP \fInbands\fP 10n
Specifies the number of bands in the new image.
.IP \fInrows\fP
Specifies the number of rows in the new image.
.IP \fIncolumns\fP
Specifies the number of columns in the new image.
.IP \fIpixel_repn\fP
Specifies the representation of pixels in the new image.
It must be one of \fBVBitRepn\fP, \fBVUByteRepn\fP, \fBVSByteRepn\fP,
\fBVShortRepn\fP, \fBVLongRepn\fP, \fBVFloatRepn\fP, or \fBVDoubleRepn\fP.
.IP \fIsrc\fP
Specifies an image having the properties desired of the new image.
.SH DESCRIPTION
\fBVCreateImage\fP allocates memory for a new image with the specified
properties. Fields of the new image structure are initialized, as are the
image's row and band indices. Its pixel values, however, are not
initialized.  The new image is given an empty attribute list. The size of
its frame band interpretation dimension (\fBnframes\fP) is set to
\fInbands\fP; its other band interpretation dimensions (\fBnviewpoints\fP,
\fBncolors\fP, and \fBncomponents\fP) are set to 1.
.PP
\fBVCreateImageLike\fP allocates memory for a new image with the same
properties as \fIsrc\fP (same pixel representation, and same numbers of
bands, rows, and columns).  Fields of the new image structure are
initialized, as are the image's row and band indices. Its pixel values,
however, are not initialized.  The new image is given a copy of \fIsrc\fP's
attribute list, and the sizes of its band interpretation dimensions
(\fBnframes\fP, ..., \fBncomponents\fP) are set identical to those of
\fIsrc\fP.
.SH "RETURN VALUES"
If successful, these routines return a pointer to the newly-allocated image
structure. Otherwise, ther return
.SB \fBNULL\c
.
.SH "SEE ALSO"
.BR VDestroyImage (3Vi),
.BR VImage (3Vi)
.SH DIAGNOSTICS
.IP "``Invalid number of \fIdimension\fP: \fIvalue\fP.''"
\fIDimension \fP is ``bands'', ``rows'', or ``columns''. 
An inappropriate value, \fIvalue\fP, was specified for that dimension.
.IP "``Invalid pixel representation: \fIrepn\fP.''"
The representation kind specified is not one of the valid pixel
representations.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
