.ds Vn 2.1
.TH VCropImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VCropImage \- crop an image
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
VImage VCropImage (\fIsrc\fP, \fIdest\fP, \fIband\fP, \fItop\fP, \
\fIleft\fP, \fIheight\fP, \fIwidth\fP)
.RS
VImage \fIsrc\fP, \fIdest\fP;
VBand \fIband\fP;
int \fItop\fP, \fIleft\fP, \fIheight\fP, \fIwidth\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the image to crop (the source image).
.IP \fIdest\fP
May specify a destination image, or may be
.SB NULL
to indicate that a new destination image should be created.
.IP \fIband\fP
May specify a particular band of the source image to be cropped, or may be 
the constant \fBVAllBands\fP to indicate that all bands of the source image 
should be cropped. 
.IP "\fItop\fP, \fIleft\fP, \fIheight\fP, \fIwidth\fP"
Specify the rectangle region to be extracted from the source image.
.SH DESCRIPTION
\fBVImageCrop\fP fills a destination image with a rectangular region of a 
source image. The rectangular region extends from row \fItop\fP for 
\fIheight\fP rows, and from column \fIleft\fP for \fIwidth\fP columns. The 
region may extend beyond the source image, in which case destination pixels 
obtained from outside the source image are set to zero.
.PP
The numbers of rows and columns of the destination image are determined by 
the size of the cropping rectangle, and the destination image has the same pixel 
representation as the source image. Also, it has either the same number of 
bands as the source image (if \fIband\fP is \fBVAllBands\fP), or a single 
band (otherwise). 
.SH "RETURN VALUES"
\fBVCropImage\fP returns the destination image if it is successful
and 
.SB NULL
otherwise.
.SH "SEE ALSO"
.na
.nh
.BR VScaleImage (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``Cropped dimensions are negative.''"
Either \fIheight\fP or \fIwidth\fP is negative.
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.IP "``Destination image has \fIdest_nbands\fP bands; \fIsrc_nbands\fP expected.''"
A destination image was specified but it has the wrong number of bands.
.IP "``Destination image has \fIdest_prop\fP \fIproperty\fP; \fIsrc_prop\fP expected.''"
\fIProperty\fP is one of ``pixels'', ``rows'', or ``columns''.
A destination image was specified but it does not have the same
pixel representation as the source image or number of rows and number
of columns as the the cropping box.
.SH AUTHOR
Ralph Horstmann <horstman@cs.ubc.ca>
