.ds Vn 2.1
.TH VEdgesToPS 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VEdgesToPS \- render an edge set using PostScript
.SH SYNOPSIS
.nf
.ft B
#include <vista/VEdges.h>
#include <vista/postscript.h>
.PP
.ft B
VBoolean VEdgesToPS (\fIf\fP, \fIedges\fP, \fIdraw_endpoints\fP)
.RS
FILE *\fIf\fP;
VEdges \fIedges\fP;
VBoolean \fIdraw_endpoints\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIf\fP 10n
Specifies the output stream to which PostScript code is to be written. 
.IP \fIedges\fP
Specifies the edge set to be rendered in PostScript.
.IP \fIdraw_endpoints\fP
If
.SB TRUE\c
, then edge endpoints will be drawn as small circles.
.SH DESCRIPTION
\fBVEdgesToPS\fP renders \fIedges\fP in PostScript, writing the PostScript 
code to the output stream \fIf\fP. It assumes that an appropriate 
coordinate system, large enough to accommodate the resulting PostScript 
drawing, has already been created by \fBVBeginVPSPage\fP (described by the 
\fBVpostscript\fP(3Vi) manual page). 
.SH "RETURN VALUES"
\fBVEdgesToPS\fP returns
.SB TRUE
if it is successful and 
.SB FALSE
otherwise.
.SH "SEE ALSO"
.BR Vpostscript (3Vi),
.BR Vlib (7Vi)
.PP
.I PostScript Language Reference Manual, Second Edition
.SH NOTES
If you want the edge set to be drawn overtop an image, draw the image 
first using \fBVImageBandToPS\fP(3Vi) or \fBVRGBImageToPS\fP(3Vi).
.PP
If you want the edge set to be drawn with a particular color and line 
width, output some PostScript code like the following before calling 
\fBVEdgesToPS\fP:
.PP
.RS
.B \fIred green blue\fP setrgbcolor \fIwidth\fP setlinewidth
.RE
.SH AUTHORS
Daniel Ko <ko@cs.ubc.ca>,
Art Pope <pope@cs.ubc.ca>
