.ds Vn 2.1
.TH VFillImage 3Vi "27 January 1994" "Vista Version \*(Vn"
.SH NAME
VFillImage \- fill an image with a constant pixel value
.SH SYNOPSIS
.nf
.B "#include <vista/VImage.h>"
.PP
.B "VBoolean VFillImage (\fIimage\fP, \fIband\fP, \fIvalue\fP)
.RS
.B "VImage \fIimage\fP;"
.B "VBand \fIband\fP;"
.B "VDouble \fIvalue\fP;"
.RE
.fi
.SH ARGUMENTS
.IP \fIimage\fP 10n
Specifies the image to be filled.
.IP \fIband\fP
May specify a particular image band to be filled, or may be the
constant \fBVAllBands\fP to indicate that all bands should be filled.
.IP \fIvalue\fP
Specifies the pixel value that the image is to be filled with.
.SH DESCRIPTION
\fBVFillImage\fP sets to \fIvalue\fP pixels of the specified image band(s).
Any other bands of the image are left unchanged.
.SH "RETURN VALUES"
\fBVFillImage\fP returns 
.SB TRUE
if successful, and 
.SB FALSE
otherwise.
.SH "SEE ALSO"
.na
.nh
.BR VImage (3Vi),
.BR VSetPixel (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
