.ds Vn 2.1
.TH VForkImageDisplay 3Vi "2 June 1994" "Vista Version \*(Vn"
.SH NAME
VForkImageDisplay \- fork a process displaying an image
.SH SYNOPSIS
.nf
.B #include <std/types.h>
.B #include <vista/VImage.h>
.fi
.HP 10n
.na
.nh
.ft B
pid_t VForkImageDisplay (VImage\ \fIimage\fP, VStringConst\ \fIprogram\fP,
VStringConst\ \fItitle\fP);
.ft
.hy
.ad
.SH ARGUMENTS
.IP \fIimage\fP 10n
Specifies the image to be displayed.
.IP \fIprogram\fP
Specifies the program to use for displaying the image. Since it is passed
to \fBexeclp\fP(2) it can be either a full pathname (e.g.,
\fB"/usr/bin/vxviewi"\fP), or just a program name (e.g., \fB"vxviewi"\fP)
to be interpreted according to the
.SB PATH
environment variable.
.IP \fItitle\fP
Specifies a title for the image display program's window.
.SH DESCRIPTION
\fBVForkImageDisplay\fP saves an image in a temporary file and spawns a
program to display it. It's primary purpose is to display intermediate
images during debugging.
.SH "RETURN VALUES"
If successful, \fBVForkImageDisplay\fP returns the process id of the new
process. Otherwise it returns 0.
.SH "SEE ALSO"
.BR VImage (3Vi),
.BR VImageView (3Vi),
.BR Vlib (7Vi)
.SH NOTES
The program used to display the image must accept \fB-in\fP and
\fB-title\fP options, as do the Vista programs \fBvxview\fP, \fBvxviewe\fP,
and \fBvxviewi\fP.
.PP
The temporary files are left lying around wherever \fBtmpnam\fP(3) places them
\(em there is no attempt made to remove them automatically.
.SH DIAGNOSTICS
.IP "``Couldn't open tmp file \fIfilename\fP.''"
A temporary file to contain the image couldn't be created. Perhaps you
don't have write access to the directory where tmpnam(3) locates temporary
files.
.IP "``Couldn't execute \fIprogram\fP.''"
The specified program couldn't be found, or it was not executable.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
