.ds Vn 2.1
.TH VImageStats 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VImageStats \- measure image statistics
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
VBoolean VImageStats (\fIsrc\fP, \fIband\fP, \fIpmin\fP, \fIpmax\fP, \
\fIpmean\fP, \fIpvar\fP)
.RS
VImage \fIsrc\fP;
VBand \fIband\fP;
VDouble *\fIpmin\fP, *\fIpmax\fP, *\fIpmean\fP, *\fIpvar\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the image to be measured.
.IP \fIband\fP
May specify a particular band of the image to be measured
or may be the constant \fBVAllBands\fP to indicate that all bands 
of the image should be measured.
.IP "\fIpmin\fP, \fIpmax\fP, \fIpmean\fP, \fIpvar\fP"
Return the minimum, maximum, mean, and variance of the image's pixel values.
Any of these pointers may be 
.SB NULL
to indicate that the corresponding value need not be returned.
.SH DESCRIPTION
\fBVImageStats\fP computes and returns statistics of the image's pixel 
values.
.SH "RETURN VALUES"
If successful, \fBVImageStats\fP returns
.SB TRUE
and stores its measurements at \fIpmin\fP, \fIpmax\fP, \fIpmean\fP, and
\fIpvar\fP. On failure, \fBVImageStats\fP returns
.SB FALSE\c
.
.SH "SEE ALSO"
.BR VImage (3Vi),
.BR Vlib (7Vi)
.SH DIAGNOSTICS
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
