.ds Vn 2.1
.TH VImageToPS 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VImageBandToPS, VRGBImageToPS \- render image using PostScript
.SH SYNOPSIS
.nf
.ft B
#include <vista/VImage.h>
#include <vista/postscript.h>
.PP
.ft B
VBoolean VImageBandToPS (\fIf\fP, \fIimage\fP, \fIband\fP)
.RS
FILE *\fIf\fP;
VImage \fIimage\fP;
VBand \fIband\fP;
.RE
.PP
.ft B
VBoolean VRGBImageToPS (\fIf\fP, \fIimage\fP, \fIband\fP)
.RS
FILE *\fIf\fP;
VImage \fIimage\fP;
VBand \fIband\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIf\fP 10n
Specifies the output stream to which PostScript code is to be written.
.IP \fIimage\fP
Specifies the image to be rendered in PostScript.
.IP \fIband\fP
Specifies the image band(s) to be rendered.
.SH DESCRIPTION
\fBVImageBandToPS\fP and \fBVRGBImageToPS\fP render \fIimage\fP in 
PostScript, writing the PostScript code to the output stream \fIf\fP. Both 
routines assume that an appropriate coordinate system, large enough to 
accommodate the resulting PostScript image, has already been created by 
\fBVBeginVPSPage\fP (described by \fBVpostscript\fP(3Vi)). 
.PP
\fBVImageBandToPS\fP renders band \fIband\fP of the image as a gray-scale
PostScript image.
.PP
\fBVRGBImageToPS\fP renders three consecutive bands of \fIimage\fP 
beginning at \fIband\fP as a color PostScript image. The band 
interpretation attributes of \fIimage\fP must describe it as a standard RGB 
color image (\fBncolors: 1\fP and \fBcolor_interp: rgb\fP) with a single 
component dimension (\fBncomponents: 1\fP). 
.PP
The PostScript images produced by these routines have pixels in the range 
[0,255]. The routines accept any type of Vista image; if necessary, 
\fIimage\fP is first converted to an image with \fBVUByte\fP pixels using 
\fBVConvertImageRange\fP(3Vi). 
.SH "RETURN VALUES"
\fBVImageBandToPS\fP and \fBVRGBImageToPS\fP both return
.SB TRUE
if it is successful and 
.SB FALSE
otherwise.
.SH "SEE ALSO"
.BR Vpostscript (3Vi),
.BR Vlib (7Vi)
.PP
.I PostScript Language Reference Manual, Second Edition
.SH DIAGNOSTICS
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIimage\fP.
.IP "``Image isn't single-component RGB''"
An image supplied to \fBVRGBImageToPS\fP isn't a standard RGB color image
with a single component dimension.
.SH AUTHORS
Daniel Ko <ko@cs.ubc.ca>,
Art Pope <pope@cs.ubc.ca>
