.ds Vn 2.1
.TH VImageWindowSize 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VImageWindowSize \- size a window for display of an image
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
void VImageWindowSize (\fIimage\fP, \fImax_width\fP, \fImax_height\fP, \
\fIwidth\fP, \fIheight\fP)
.RS
VImage \fIimage\fP;
int \fImax_width\fP, \fImax_height\fP, *\fIwidth\fP, *\fIheight\fP;
.fi
.SH ARGUMENTS
.IP \fIimage\fP 10n
Specifies the image to be displayed.
.IP "\fImax_width\fP, \fImax_height\fP
Specify the maximum dimensions of a window used to display the image.
.IP "\fIwidth\fP, \fIheight\fP"
Return the appropriate dimensions of a window sized to display the image.
.SH DESCRIPTION
\fBVImageWindowSize\fP computes the dimensions of a window that is sized to
display a particular image. It considers the size of the image (in rows and
columns), and the image's pixel aspect ratio (if the image includes an
attribute defining that ratio). It computes the maximum dimensions that are
correctly proportioned, and do not exceed \fImax_width\fP and 
\fImax_height\fP.
.SH "RETURN VALUES"
The window dimensions computed by \fBVImageWindowSize\fP are returned via
\fIwidth\fP and \fIheight\fP.
.SH "SEE ALSO"
.BR VImageView (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
