.ds Vn 2.1
.TH VLinkImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VLinkImage \- link connected non-zero pixels to form edges
.SH SYNOPSIS
.PP
.nf
.ft B
#include <vista/VImage.h>
#include <vista/VEdges.h>
.PP
.ft B
VEdges VLinkImage (\fIsrc\fP, \fIlow\fP, \fIhigh\fP, \fIminlength\fP)
.RS
VImage \fIsrc\fP;
int \fIlow\fP, \fIhigh\fP, \fIminlength\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the source image. Warning: This image is modified as a
side-effect of the linking.
.IP \fIlow\fP
The low threshold value for Canny's hysteresis thresholding.
.IP \fIhigh\fP
The high threshold value for Canny's hysteresis thresholding.
.IP \fIminlength\fP
All edges with a length in pixels less than this number will be
discarded.
.SH DESCRIPTION
\fBVLinkImage\fP joins up connected non-zero pixels in an image to form a 
set of edges represented as a \fBVEdges(3Vi)\fP object. The program 
discards any edges that have a length less than \fIminlength\fP pixels.
.PP
Most edge detection methods used to produce the input image
will mark each pixel with a gradient or
strength measure, such that only pixels with high values are likely to
correspond to true edges rather than noise.  Rather than using just a
single threshold on this gradient value to select edge pixels, 
\fBVLinkImage\fP performs Canny's hysteresis thresholding, which uses both
high and low threshold values.  This method prevents breaking an edge
into many disconnected pieces by only starting an edge when a pixel is
above the high threshold and keeping all pixels above the low threshold
in intervals bounded by pixels above the high threshold.  
.SH "RETURN VALUES"
\fBVLinkImage\fP returns the set of linked edges. The edge points in these 
edges each have three fields, giving the x,y location and gradient value of 
each point. 
.SH "SEE ALSO"
.na
.nh
.BR VCanny (3Vi),
.BR VImage (3Vi),
.BR VEdges (3Vi),
.BR Vlib (7Vi)
.hy
.ad
.SH LIMITATIONS
The source image must have \fBVUByte\fP pixels. Only its first band is
examined.
.SH AUTHOR
David Lowe <lowe@cs.ubc.ca>
