.ds Vn 2.1
.TH VNegateImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VNegateImage \- negate image pixel values
.SH SYNOPSIS
.PP
.nf
.B #include <vista/VImage.h>
.fi
.PP
.nf
.B VImage VNegateImage (\fIsrc\fP, \fIdest\fP, \fIband\fP)
.RS
.ft B
VImage \fIsrc\fP, \fIdest\fP;
VBand \fIband\fP;
.ft
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the image to negate (the source image).
.IP \fIdest\fP
May specify a destination image, or may be
.SB NULL
to indicate that a new destination image should be created.
.IP \fIband\fP
May specify a particular band of the source image to be negated,
or may be the constant \fBVAllBands\fP to indicate that all bands 
of the source image should be negated.
.SH DESCRIPTION
\fBVNegateImage\fP negates each source pixel value to produce the
corresponding destination pixel value:
.PP
.RS
\fIdest-pixel\fP = - \fIsrc-pixel\fP
.RE
.PP
It only accepts a source image having a signed pixel representation
(i.e., not \fBVBit\fP or \fBVUByte\fP).
.PP
The destination image has the same number of rows and columns, and the
same pixel representation, as the source image. Also, it has either the same
number of bands as the source image (if \fIband\fP is \fBVAllBands\fP), or
a single band (otherwise).
.SH "RETURN VALUES"
\fBVNegateImage\fP returns the destination image if it is successful
and 
.SB NULL
otherwise.
.SH "SEE ALSO"
.BR VInvertImage (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.SH DIAGNOSTICS
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.IP "``Destination image has \fIdest_nbands\fP bands; \fIsrc_nbands\fP expected.''"
A destination image was specified but it has the wrong number of bands.
.IP "``Destination image has \fIdest_prop\fP \fIproperty\fP; \fIsrc_prop\fP expected.''"
\fIProperty\fP is one of ``pixels'', ``rows'', or ``columns''.
A destination image was specified but it does not have the same
pixel representation, number of rows, and number of columns as the
source image.
.IP "``Source image must have signed pixels.''"
\fISrc\fP cannot have \fBVBit\fP or \fBVUByte\fP pixels.
.IP "``Source pixel(s) out of range.''"
One or more source pixels, when negated, exceeded the range of
representable pixel values; they were clipped.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
