.ds Vn 2.1
.TH VNew 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VNew \- allocate storage for an instance of a data type
.SH SYNOPSIS
.PP
.ft B
.nf
#include <vista/mu.h>
.ft
.fi
.PP
.ft B
.nf
\fItype\fP *VNew (\fItype\fP)
.ft
.RS
.B \fItype\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fItype\fP 10n
Specifies a previously declared data type.
.SH DESCRIPTION
\fBVNew\fP allocates storage for one instance of a data type. It is 
a convenience macro that calls \fBVMalloc\fP(3Vi) with the following
arguments specified:
.PP
.RS
.nf
.B ((\fItype\fP *) VMalloc (sizeof (\fItype\fP))
.fi
.RE
.SH "RETURN VALUES"
\fBVNew\fP returns a pointer to the allocated storage.
.SH "SEE ALSO"
.na
.nh
.BR VMalloc (3Vi),
.BR VNewString (3Vi),
.BR VError (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
If there is insufficient memory to allocate the new block, \fBVNew\fP
terminates by calling \fBVError\fP(3Vi) with the message ``Out of memory''.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
.SH ACKNOWLEDGMENT
This macro and this manual page are based on similar ones
included in the X Toolkit Intrinsics, which is 
Copyright 1985, 1986, 1987, 1988
Massachusetts Institute of Technology, Cambridge, Massachusetts,
and Digital Equipment Corporation, Maynard, Massachusetts.
