.ds Vn 2.1
.TH VNoiseImage 3Vi "1 April 1994" "Vista Version \*(Vn"
.SH NAME
VNoiseImage \- fill an image with a random pattern
.SH SYNOPSIS
.B "#include <vista/VImage.h>"
.HP 10n
.na
.nh
.ft B
VBoolean VBinomialNoiseImage (VImage\ \fIimage\fP, VBand\ \fIband\fP,
VDouble\ \fIv0\fP, VDouble\ \fIv1\fP, double\ \fIp\fP);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
VBoolean VNormalNoiseImage (VImage\ \fIimage\fP, VBand\ \fIband\fP,
double\ \fImean\fP[2], double\ \fIstd_dev\fP);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
VBoolean VUniformNoiseImage (VImage\ \fIimage\fP, VBand\ \fIband\fP, 
VDouble\ \fImin_value\fP, VDouble\ \fImax_value\fP);
.ft
.hy
.ad
.SH ARGUMENTS
.IP \fIimage\fP 10n
Specifies the image to be filled.
.IP \fIband\fP
May specify a particular image band to be filled with noise, or may be the
constant \fBVAllBands\fP to indicate that each band should be filled.
.IP "\fIv0\fP, \fIv1\fP"
Specify the two pixel values used to define a binomial distribution.
.IP \fIp\fP
Specifies the probability that a pixel will be assigned value \fIv0\fP.
.IP "\fImean\fP, \fIstd_dev\fP"
Specify the mean and standard deviation of a normal distribution.
.IP "\fImin_value\fP, \fImax_value\fP"
Specify the bounds of a uniform distribution.
.SH DESCRIPTION
Each routine fills one or more bands of \fIimage\fP with a random intensity 
pattern.  If \fIband\fP is \fBVAllBands\fP, each band of the image is 
filled independently; otherwise, only the specified band is filled and 
other bands are left unchanged.
.PP
\fBVBinomialNoiseImage\fP draws pixel values at random from a binomial 
distribution. A pixel is given the value \fIv0\fP with 
probability\ \fIp\fP, and the value \fIv1\fP with probability\ 1-\fIp\fP.
.PP
\fBVNormalNoiseImage\fP draws pixel values at random from a normal 
(Gaussian) distribution with mean \fImean\fP and standard deviation
\fIstd_dev\fP.
.PP
\fBVUniformNoiseImage\fP draws pixel values at random from 
[\fImin_value\fP,\fImax_value\fP] according to a uniform distribution.
.SH "RETURN VALUES"
These routines return
.SB TRUE
if successful, and 
.SB FALSE
otherwise.
.SH "SEE ALSO"
.na
.nh
.BR VFillImage (3Vi),
.BR VPatternImage (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``Band \fIband\fP referenced in image of \fInbands\fP band(s).''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
