.ds Vn 2.1
.ds Un inches
.TH VParsePSDistance 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VParsePSDistance \- parse a page layout distance measure
.SH SYNOPSIS
.nf
.B "#include <vista/postscript.h>"
.PP
.ft B
VBoolean VParsePSDistance (\fIstr\fP, \fIkeyword\fP, \fIvalue\fP)
.RS
VStringConst *\fIstr\fP, *\fIkeyword\fP;
float *\fIvalue\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIstr\fP 10n
Specifies the string to be parsed.
.IP \fIkeyword\fP
Specifies a command option keyword for inclusion in error messages.
.IP \fIvalue\fP
Returns the distance parsed, in PostScript units of 1/72 inch.
.SH DESCRIPTION
\fBVParsePSDistance\fP parses a string specifying a distance measured in
any of several page layout units. The string should be a decimal number
optionally followed by one of these suffixes adopted from TeX: pt (points),
pc (picas), in (inches), bp (big points, of 1/72 in), cm (centimeters), mm
(millimeters), dd (didot points), cc (ciceros), sp (scaled points, of
1/65536 pt). If no units are specified, \*(Un are assumed.
.SH "RETURN VALUES"
If successful, \fBVParsePSDistance\fP returns 
.SB TRUE
and sets *\fIvalue\fP to the parsed distance.
.SH "SEE ALSO"
.BR VParsePSOptions (3Vi),
.BR Vlib (7Vi)
.SH DIAGNOSTICS
\fBVParsePSDistance\fP reports errors directly to the standard error stream.
.IP "``Option -\fIkeyword\fP has incorrect value \fIstr\fP.''"
The \fIstr\fP argument was not a valid distance specification.
.IP "``Option -\fIkeyword\fP units (\fIxx\fP) not recognized.''"
The letter pair \fIxx\fP is not a valid unit abbreviation, such as ``in''.
.IP "``Option -\fIkeyword\fP value too long.''"
The argument following -\fIkeyword\fP must have less than 100 characters.
.SH AUTHORS
Art Pope <pope@cs.ubc.ca>
