.ds Vn 2.1
.TH VReadPlain 3Vi "17 February 1994" "Vista Version \*(Vn"
.SH NAME
VReadPlain \- read an image in Vista plain file format
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
VImage VReadPlain (\fIfile\fP)
.RS
FILE *\fIfile\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIfile\fP 10n
Specifies an input stream containing the image as a Vista plain format file.
.SH DESCRIPTION
\fBVReadPlain\fP reads an image from a file represented in Vista plain format,
which is a file format for describing images in human-readable form
(see \fBVplain\fP(5Vi)).
.SH "RETURN VALUES"
If successful, \fBVReadPlain\fP returns the image read while advancing the 
stream \fIfile\fP to the end of the file; otherwise, it returns 
.SB NULL\c
\& while leaving \fIfile\fP at an unspecified position.
.SH "SEE ALSO"
.na
.nh
.BR VImage (3Vi),
.BR Vplain (5Vi),
.BR Vlib (7Vi)
.hy
.ad
.SH DIAGNOSTICS
.IP "``Error in Vista plain format file near line \fIn\fP.''"
The file was not in the expected format.
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
