.ds Vn 2.1
.TH VReadPnm 3Vi "18 February 1994" "Vista Version \*(Vn"
.SH NAME
VReadPnm \- read an image from a portable anymap (PNM) file
.SH SYNOPSIS
.nf
.B #include <vista/VImage.h>
.PP
.ft B
VImage VReadPnm (\fIfile\fP)
.RS
FILE *\fIfile\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIfile\fP 10n
Specifies an input stream containing the PNM file to be read.
.SH DESCRIPTION
\fBVReadPnm\fP reads an image from a portable anymap (PNM) file.
The following types of portable anymap may be read:
.RS 2n
.IP \(bu 2n
Portable bitmap (PBM) and its ``rawbits'' variant. A PBM image is returned
as a single-band Vista image with \fBVBit\fP pixels. Pixel values 0 and 1
are swapped since, for PBM images, 0 denotes white and 1 denotes black.
.IP \(bu
Portable graymap (PGM) and its ``rawbits'' variant. A PGM image is returned
as a single-band Vista image with \fBVUByte\fP pixels. The full range of
PGM pixel values is mapped to [0,255] in the returned image.
.IP \(bu
Portable pixmap (PPM) and its ``rawbits'' variant. A PPM image is returned
as an RGB color image \fB(nbands:\ 3\fP, \fBncolors:\ 3\fP,
\fBcolor_interp: rgb\fP) with \fBVUByte\fP pixels. The full range of PPM
pixel values is mapped to [0,255] in the returned image.
.PP
.RE
A wide range of filters are available for converting other image
formats to PNM.
.SH "RETURN VALUES"
If successful, \fBVReadPnm\fP returns the image read while advancing the 
stream \fIfile\fP to the end of file; otherwise, it returns 
.SB NULL\c
\& while leaving \fIfile\fP at an unspecified position.
.SH "SEE ALSO"
.BR VImage (3Vi),
.BR Vlib (7Vi),
.br
.BR pnm (5), 
.BR pbm (5), 
.BR pgm (5), 
.BR ppm (5)
.SH DIAGNOSTICS
.IP "``Error in PNM file near line \fIn\fP.''"
The file was not in the expected format.
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
