.ds Vn 2.1
.TH VReportUsage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VReportUsage, VReportValidOptions \- report valid command line arguments
.SH SYNOPSIS
.nf
.B "#include <vista/option.h>"
.PP
.ft B
void VReportUsage (\fIprogram\fP, \fInoptions\fP, \fIoptions\fP, \
\fIother_args\fP)
.RS
VStringConst \fIprogram\fP, \fIother_args\fP;
int \fInoptions\fP;
VOptionDescRec \fIoptions\fP[\fInoptions\fP];
.RE
.PP
.ft B
void VReportValidOptions (\fInoptions\fP, \fIoptions\fP)
.RS
int \fInoptions\fP;
VOptionDescRec \fIoptions\fP[\fInoptions\fP];
.RE
.fi
.SH ARGUMENTS
.IP \fIprogram\fP 10n
Specifies the program's name. Usually \fBargv[0]\fP is passed.
.IP \fInoptions\fP 10n
Specifies the number of entries in the table of option descriptors.
.IP \fIoptions\fP
Specifies the location of the table of option descriptors.
.IP \fIother_args\fP
May specify a string describing any options the program accepts other than
those described in the options table, or it may be
.SB NULL\c
.
.SH DESCRIPTION
\fBVReportUsage\fP prints, to the standard error stream, information about how
to use a program. It first prints a line of the form:
.PP
.RS
\fBUsage: \fIprogram\fB <options> \fIother_args\fB, where <options> includes:
.RE
.PP
The \fIprogram\fP argument supplies the \fIprogram\fP component of this 
line, and the \fIother_args\fP argument supplies the \fIother_args\fP 
component. If the program accepts no options other than those described in 
the options table, \fIother_args\fP should be 
.SB NULL\c
\&.
.PP
\fBVReportUsage\fP then calls \fBVReportValidOptions\fP to print a
summary of the options described by \fInoptions\fP and \fIoptions\fP.
.PP
\fBVReportValidOptions\fP prints a description of each option in a table of
option descriptors. The description is intended to advise a program user.
It indicates what keyword signals the option's presence in the command
line, whether it is optional, how many values must follow it, what type
those values should have, what keywords may be used as values for the
option, and what default value(s) the option has.  The description will
also include any ``blurb'' string of help information that is found in the
option's table entry. The information is printed to the standard error
stream.
.SH "SEE ALSO"
.na
.nh
.BR VParseCommand (3Vi),
.BR VReportBadArgs (3Vi),
.BR Voption (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
