.ds Vn 2.1
.TH VSetProgramName 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VSetProgramName \- register a program name for error messages
.SH SYNOPSIS
.nf
.ft B
void VSetProgramName (\fIname\fP)
.RS
VStringConst \fIname\fP
.RE
.fi
.SH ARGUMENTS
.IP \fIname\fP 10n
Specifies the program's name as a null-terminated string, or is 
.SB NULL
to indicate that no program name should be registered.
.SH DESCRIPTION
\fBVSetProgramName\fP determines what, if any, program name will be
included in subsequent error messages composed by \fBVError\fP (3Vi),
\fBVSystemError\fP(3Vi), \fBVWarning\fP(3Vi), and \fBVSystemWarning\fP(3Vi).
.PP
Initially, no program name is registered. If \fBVSetProgramName\fP
is called with a string, that string is registered as the program name. 
If \fBVSetProgramName\fP is called with an argument of 
.SM NULL\c
, any previously-registered name is forgotten.
.SH EXAMPLES
.RS
.nf
.ft B
int main (argc, argv)
int argc;
char *argv[];
{
	\fR...\fP
	VSetProgramName (argv[0]);
	\fR...\fP
}
.fi
.RE
.SH "SEE ALSO"
.na
.nh
.BR VError (3Vi),
.BR VWarning (3Vi),
.BR VSetErrorHandler (3Vi),
.BR VSetWarningHandler (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH NOTES
\fBVSetProgramName\fP does not make its own copy of the string it is passed.
Consequently, storage used for the string must be maintained by the caller.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
