.ds Vn 2.1
.TH VTransposeImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VTransposeImage \- transpose the rows and columns of
an image
.SH SYNOPSIS
.nf
.ft B
#include <vista/VImage.h>
.PP
.ft B
VImage VTransposeImage (\fIsrc\fP, \fIdest\fP, \fIband\fP)
.RS
VImage \fIsrc\fP, \fIdest\fP;
VBand \fIband\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIsrc\fP 10n
Specifies the image to be transposed.
.IP \fIdest\fP
May specify a destination image, or may be
.SB NULL
to indicate that a new destination image should be created.
.IP \fIband\fP
May specify a particular band of the source image to be transposed,
or may be the constant \fBVAllBands\fP to indicate that all bands 
of the source image should be transposed.
.SH DESCRIPTION
\fBVTransposeImage\fP transposes the rows and columns of an image such that 
row \fIi\fP of the original image becomes column \fIi\fP of the transposed 
image. 
.PP
If a destination image is provided by the caller then it must have the 
same number of rows as the source image has columns, the same number of 
columns as the source image has rows, and the same pixel representation 
as the source image; and it must have either the same number of bands as 
the source image (when \fIband\fP is \fBVAllBands\fP) or a single band 
(otherwise). If no destination is image is provided, one with these 
properties will be created and returned.
.SH "RETURN VALUES"
\fBVTransposeImage\fP returns the destination image if successful and 
.SB NULL
otherwise.
.SH "SEE ALSO"
.BR VFlipImage (3Vi),
.BR VImage (3Vi),
.BR Vlib (7Vi)
.SH DIAGNOSTICS
.IP "``Band \fIband\fP does not exist.''"
The \fIband\fP argument is invalid given the number of bands in \fIsrc\fP.
.IP "``Destination image has \fIdest_nbands\fP bands; \fIsrc_nbands\fP expected.''"
A destination image was specified but it has the wrong number of bands.
If \fIband\fP is \fBVAllBands\fP, the destination image must have the same
number of bands as the source image. Otherwise, it must have a single
band.
.IP "``Destination image has \fIdest_prop\fP \fIproperty\fP; \fIsrc_prop\fP expected.''"
\fIProperty\fP is one of ``pixels'', ``rows'', or ``columns''.
A destination image was specified but it does not have the 
appropriate properties.
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
