.ds Vn 2.1
.TH v1to2 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
v1to2 \- convert Vista data files from V1 to V2
.SH SYNOPSIS
\fBv1to2\fP [\fI-option\fP...] [\fIinfile\fP] [\fIoutfile\fP]
.SH DESCRIPTION
\fBv1to2\fP convert a Vista data file from version 1 format to version 2.
.PP
Whereas an object such as an image is represented in a V1 file by something
of the form:
.PP
.RS
.nf
image: {
	nrows: 256
	ncolumns: 256
	\fR...\fP
	data: \fIoffset\fP
}
.fi
.RE
.PP
in a V2 file, it is represented by:
.PP
.RS
.nf
\fIname\fP: image {
	nrows: 256
	ncolumns: 256
	\fR...\fP
	data: \fIoffset\fP
	length: \fIlength\fP
}
.fi
.RE
.PP
Wherever it finds a \fBdata\fP attribute, \fBv1to2\fP inserts a
\fBlength\fP attribute with an appropriate value. For \fIname\fP, it uses
the object's type (e.g., \fBimage\fP).
.SH "COMMAND LINE OPTIONS"
\fBv1to2\fP accepts the following options:
.IP \fB-help\fP 15n
Causes \fBv1to2\fP to print out a message describing its options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file to be converted.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies the file to receive the converted stuff.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH NOTES
The version of a Vista data file is reported on its first line.
.PP
The method of computing values for \fBlength\fP attributes will be defeated
if the file contains spurious binary data (blocks of data not referenced by
\fBdata\fP attributes) or padding between binary data blocks.
.SH DIAGNOSTICS
.IP "``Deleted trailing newline.''"
This warning message is issued if \fBv1to2\fP finds a
.SB NEWLINE
at the end of the binary data section of the input file. On the assumption
that an editor appended it (gemacs, say, with \fBrequire-final-newline\fP
set to \fBt\fP) the 
.SB NEWLINE
is deleted.
.IP "``File contains multi-band image(s) -- check their attributes.''"
One or more multi-band images were present in the file. You will have to
edit them by hand to remove any \fBband_interp\fP attribute and add the
appropriate combination of \fBnframe\fP, \fBframe_interp\fP,
\fBnviewpoints\fP, \fBviewpoint_interp\fP, \fBncolors\fP,
\fBcolor_interp\fP, \fBncomponents\fP, and \fBcomponent_interp\fP
attributes. See the ``Band Interpretation''P section of \fBVImage\fP(3Vi).
.IP "``File isn't in V1 format.''"
It may already be a V2 file, in which case it passes through unmolested.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
