.ds Vn 2.1
.TH vadjust 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
vadjust \- adjust image brightness and contrast
.SH SYNOPSIS
\fBvadjust\fR [\fB-bri \fIb\fR] [\fB-con \fIc\fR] [\fB-\fIoption\fR ...] \
[\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvadjust\fP adjusts the brightness and/or contrast of each input image 
to produce a corresponding output image.
.PP
Brightness is adjusted by a transformation analogous to gamma correction.
Contrast is adjusted by a linear scaling of pixel values, with clipping of
pixel values that consequently exceed the range permitted by the image's
pixel representation. See \fBVAdjustImage\fP(3Vi) for a more complete
description of these transformations.
.SH "COMMAND LINE OPTIONS"
\fBvadjust\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the input images.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the output images as a Vista data file.
.IP "\fB-brightness\fP \fIb\fP"
Specifies a brightness adjustment. Positive values increase brightness;
negative ones decrease it; 0 causes no change in brightness. Default: 0.
.IP "\fB-contrast\fP \fIc\fP"
Specifies a contrast adjustment. Positive values increase contrast;
negative ones decrease it; 0 causes no change in contrast. Default: 0.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.na
.nh
.BR vconvert (1Vi),
.BR vop (1Vi),
.BR vxadjust (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.ad
.hy
.SH AUTHOR
Ralph Horstmann <horstman@cs.ubc.ca>
