.ds Vn 2.1
.TH vcomplex 1Vi "3 March 1994" "Vista Version \*(Vn"
.SH NAME
vcomplex \- build a complex image from real and imaginary components
.SH SYNOPSIS
\fBvcomplex\fR [\fB-real \fIfile1\fR] [\fB-imag \fIfile2\fR] \
[\fB-\fIoption\fR ...] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvcomplex\fP builds a complex image from an image of real pixel
components and/or one of imaginary pixel components.
.PP
The complex image will be given appropriate band interpretation attributes 
(\fBncomponents:\ 2\fP and \fBcomponent_interp: complex\fP). 
.SH "COMMAND LINE OPTIONS"
\fBvcomplex\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-real\fP \fIfile1\fP"
Specifies a Vista data file containing an image of real pixel components.
.IP "\fB-imaginary\fP \fIfile2\fP"
Specifies a Vista data file containing an image of imaginary pixel components.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the complex image as a Vista data file.
.IP "\fB-repn\fP \fBfloat\fP | \fBdouble\fP"
Specifies the pixel representation that the complex image is to have. If
omitted, it defaults to \fBfloat\fP.
.IP "\fB-name\fP \fIname\fP"
Specifies the name to be given the created image. Default: ``image''.
.PP
At least one of \fB-real\fP or \fB-imaginary\fP must be specified, and if
they are both provided they must have the same numbers of rows and columns.
If either it omitted, the corresponding components are set to zero.
.PP
If an input filename is specified as ``\fB-\fP'', the file is read from the 
standard input stream. The output file can be specified on the command line or 
allowed to default to the standard output stream. 
.SH "SEE ALSO"
.BR Vista (7Vi)
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
