.ds Vn 2.1
.TH vfft 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
vfft \- compute the Fourier transform of an image
.SH SYNOPSIS
\fBvfft\fR [\fB-inverse\fR] [\fB-\fIoption\fR ...] \
[\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvfft\fP computes the Fourier transform, or inverse Fourier transform, of
one or more images using the Fast Fourier Transform algorithm.
.PP
Each image found in the input file is transformed separately. If the image 
has a single band, it is considered to be purely real; if it has two bands, 
they are taken to be the real and imaginary components of the image. The 
number of rows and the number of columns of the image must both be powers 
of two (not necessarily identical). 
.PP
Once the transform is computed, each pixel of the result is divided by the 
constant \fInorm\fP, which may be specified by a command line option. 
Typically, \fInorm\fP's value is based on the number of rows (\fInrows\fP) 
and columns (\fIncolumns\fP) of the image. Common choices are:
.RS 2n
.IP \(bu 2n
1.0 for the forward transform, and \fInrows\fP*\fIncolumns\fP for the 
inverse transform; 
.IP \(bu
\fIsqrt\fP\ (\fInrows\fP*\fIncolumns\fP) for both the forward and inverse 
transforms.
.RE
.PP
If \fInorm\fP is not specified on the command line, it defaults to 
\fIsqrt\fP\ (\fInrows\fP*\fIncolumns\fP).
.PP
In the transformed image, frequencies are arranged in wrap-around order,
independently in each dimension. The rows correspond to frequencies in the
vertical direction. For example:
.RS 2n
.IP \(bu 2n
row 0 represents 0 cycles per image
.IP \(bu
row 1 represents 1/\fInrows\fP cycles per image
.IP \(bu
row \fInrows\fP/2 represents both +1/2 and \-1/2 cycles per image
.IP \(bu
row \fInrows\fP\-1 represents \-1/\fInrows\fP cycles per image
.RE
.PP
Similarly, the columns correspond to frequencies in the horizontal 
direction. 
.SH "COMMAND LINE OPTIONS"
\fBvfft\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the images to be transformed.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the transformed images as a Vista data file.
.IP \fB-inverse\fP
Specifies that the inverse Fourier transform is to be computed. Default: 
the forward transform is computed. 
.IP "\fB-norm\fP \fInorm\fP"
Specifies the normalizing constant by which each pixel of a transformed 
image is to be divided.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.BR VImageFFT (3Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
