.ds Vi Vista
.ds Vn 2.1
.TH vgauss 1Vi "11 April 1994" "\*(Vi Version \*(Vn"
.SH NAME
vgauss \- convolve an image with a Gaussian filter or its derivative
.SH SYNOPSIS
\fBvgauss\fR [\fB-sigma \fIsigma\fR] [\fB-\fIoption\fR ...] \
[\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvgauss\fP convolves an image with a Gaussian filter or a filter that is 
the partial derivative of a Gaussian. Each input image is filtered to 
produce a corresponding output image. The 2D filter is implemented as two 
1D filters to minimize computation. 
.PP
Three types of filtering operations are supported:
.RS 2n
.IP \fBsmooth\fP 10n
This convolves the input image with a 1D Gaussian filter in both the x 
and y directions.
.IP \fBxgrad\fP
This convolves the input image with a 1D Gaussian filter in the y 
direction, and a 1D derivative-of-Gaussian filter in the x direction. 
.IP \fBygrad\fP
This convolves the input image with a 1D Gaussian filter in the x
direction, and a 1D derivative-of-Gaussian filter in the y direction.
.RE
.PP
Note that the x direction is the direction of increasing column index, and 
the y direction is the direction of decreasing row index. When 
computing pixel values near an image border, the region outside of the 
input image is padded with border pixel values. 
.PP
The input images can have pixel values of any type. In general, the output 
images are created with pixel values of the same type as the input images. 
However, if an input image has unsigned pixels (i.e., \fBbit\fP or 
\fBubyte\fP pixels) and convolution with the partial derivation of a 
Gaussian is required, then the input image will be converted (by 
\fBVConvertImageRange\fP(3Vi)) to an image with \fBsbyte\fP pixels before 
convolution, and the output image will also have \fBsbyte\fP pixels. 
.SH COMMAND LINE OPTIONS
\fBvgauss\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies the Vista data file containing the input images.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the output images as a Vista data file.
.IP "\fB-sigma\fP \fIsigma\fP"
Specifies the standard deviation of the Gaussian on which the 
filter is based (in pixels).
Default: 1.0.
.IP "\fB-size\fP \fIn\fP"
Specifies the finite diameter at which the filter is truncated (in pixels).
Default: 6*\fIsigma\fP+1.
.IP "\fB-type\fP \fBsmooth\fP | \fBxgrad\fP | \fBygrad\fP"
Specifies the filtering operation. Default: \fBsmooth\fP.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.na
.nh
.BR vconvolve (1Vi),
.BR VGaussianConvolveImage (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.hy
.ad
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
