.ds Vn 2.1
.TH vgrad 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
vgrad \- estimate image gradient components
.SH SYNOPSIS
\fBvgrad\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvgrad\fP estimates the horizontal and vertical components of the
intensity gradient at each pixel of an image.
.PP
For an input pixel \fIs\fP with vertical neighbours \fIa\fP and \fIb\fP, 
and horizontal neighbours \fIc\fP and \fId\fP: 
.PP
.nf
.ta 20n 25n 30n
		\fIa\fP
	\fIc\fP	\fIs\fP	\fId\fP
		\fIb\fP
.DT
.fi
.PP
the horizontal component of the gradient is estimated as
 (\fId\fP\ \-\ \fIc\fP)\ /\ 2
and the vertical component is estimated as 
(\fIa\fP\ \-\ \fIb\fP)\ /\ 2. Both components of the gradient are 
taken to be zero at border pixels.
.PP
Each image found in the input file is processed separately to produce a 
corresponding output image. An input image must each have a single 
component (\fBncomponents\fP is 1); it may have any size and pixel 
representation. 
.PP
Each output image has twice as many bands as the corresponding input image.
A pair of bands in the output image is produced from one band in the
input image. The first band of the pair contains the gradient's horizontal
component, and the second contains its vertical component.
.PP
An output image has the same numbers of rows and columns as its 
corresponding input image. If the input image has \fBbit\fP or \fBubyte\fP 
pixels, the output image has \fBsbyte\fP pixels; otherwise the output image 
has the same pixel representation as the input image. 
.SH "COMMAND LINE OPTIONS"
\fBvgrad\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the input images.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the output images as a Vista data file.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.na
.nh
.BR vmag (1Vi),
.BR vphase (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.hy
.ad
.SH NOTES
\fBvmag\fP(1Vi) and \fBvphase\fP(1Vi) can be used to compute the magnitude 
and direction of the intensity gradient from the output of \fBvgrad\fP. 
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
