.ds Vn 2.1
.ds Un inches
.TH vlayout 1Vi "24 March 1994" "Vista Version \*(Vn"
.SH NAME
vlayout \- arrange several Encapsulated PostScript documents on a page
.SH SYNOPSIS
\fBvlayout\fR [\fB-\fIoption\fR ...] [\fIinfile\fR ...] [\fB> \fIoutfile\fR]
.SH DESCRIPTION
\fBvlayout\fP arranges one or more Encapsulated PostScript documents
in rows and columns on a single page. The output of \fBvlayout\fP
can be sent directly to a PostScript printer, or included as a figure in
another document.
.PP
The input documents are arranged in row-major order. For example, if the 
user specified that there should be two columns per row, then the first 
document will occupy the first column of the first row, the second one will 
occupy the second column of the first row, the third one will occupy the 
first column of the second row, and so on. All but the last row will be 
filled. 
.SH "COMMAND LINE OPTIONS"
\fBvlayout\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP ..."
Each \fIinfile\fP contains one Encapsulated PostScript document to be 
included on the page.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the PostScript output.
.IP \fB-eps\fP
Normally \fBvlayout\fP produces a single-page PostScript document that is
suitable for printing. Specifying \fB-eps\fP causes it to instead produce
an Encapsulated PostScript document that is suitable for inclusion in
other documents.
.IP "\fB-gutter\fP \fIdistance\fP"
Specifies the minimum space between adjacent rows and columns. Default: 
0.5in.
.IP "\fB-ncolumns\fP \fIncolumns\fP"
Specifies the number of columns on the page. Default: 2.
.IP \fB-landscape\fP
Gives the generated page a landscape orientation. If omitted, the
page has a portrait orientation.
.IP "\fB-width\fP \fIdistance\fP"
Specifies the width of the physical page. Default: 8.5in.
.IP "\fB-height\fP \fIdistance\fP"
Specifies the height of the physical page. Default: 11in.
.PP
.nf
\fB-left\fP \fIdistance\fP
\fB-right\fP \fIdistance\fP
\fB-top\fP \fIdistance\fP
.fi
.ns
.IP "\fB-bottom\fP \fIdistance\fP" 15n
Specify the width of the page margins. All default to 1in.
.IP "\fB-frame\fP \fIdistance\fP"
If specified, a frame is drawn around the entire page. The frame has width
\fIdistance\fP, which may be 0 to produce a hairline. Default: no frame.
.IP "\fB-caption\fP \fIcaption\fP"
Specifies the text of a caption to be drawn at the bottom of the page.
Default: no caption is drawn.
.IP "\fB-capheight\fP \fIdistance\fP"
Specifies the height of the font used to draw the caption. Default: 14pt.
.PP
Input files can be specified on the command line or allowed to default to 
the standard input stream. The output file can be specified by the \fB-out\fP 
option or allowed to default to the standard output stream. 
.PP
Distances can be specified in any of several units using these suffixes
adopted from TeX: pt (points), pc (picas), in (inches), bp (big points, of
1/72 in), cm (centimeters), mm (millimeters), dd (didot points), cc
(ciceros), sp (scaled points, of 1/65536 pt). If no units are specified,
\*(Un are assumed.
.SH "SEE ALSO"
.BR vtops (1Vi),
.BR Vista (7Vi)
.SH NOTES
\fBvlayout\fP relies on finding \fB%%BoundingBox\fP comments in the 
documents it arranges. 
.PP
Any %%EOF, %%Page: and %%Pages: directives are removed from the included
PostScript documents.
.PP
For more elaborate layout tasks, use TeX in conjunction with
\fBdvips\fP(1).
.SH AUTHORS
Daniel Ko <ko@cs.ubc.ca>,
Art Pope <pope@cs.ubc.ca>
