.ds Vn 2.1
.TH vphase 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
vphase \- compute the phase of a complex image
.SH SYNOPSIS
\fBvphase\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvphase\fP computes the phase of a complex image.
.PP
Each image found in the input file is processed separately to produce a 
corresponding output image. An input image must have two components 
(\fBncomponents\fP is 2); it may have any pixel representation and any 
numbers of rows and columns. The corresponding output image will have half 
as many components, half as many bands, and the same numbers of rows and 
columns. If the input image has \fBdouble\fP pixels then so will the output 
image; otherwise, the output image will have \fBfloat\fP pixels. 
.PP
If an input pixel's two components are \fIa\fP and \fIb\fP, the 
corresponding output pixel receives the value 
\fIatan2\fP\ (\fIb\fP, \fIa\fP). (If \fIa\fP and \fIb\fP are both zero 
then the output pixel is set to zero.)
.SH "COMMAND LINE OPTIONS"
\fBvphase\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the input images.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the output images as a Vista data file.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.na
.nh
.BR vcomplex (1Vi),
.BR vgrad (1Vi),
.BR vmag (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.hy
.ad
.SH NOTES
This program will serve to compute gradient magnitude from a 
two-component gradient image.
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
