.ds Vn 2.1
.TH vscale 1Vi "20 April 1994" "Vista Version \*(Vn"
.SH NAME
vscale \- scale the dimensions of image and edge sets
.SH SYNOPSIS
\fBvscale\fR [\fB-scale \fIfactor\fR] [\fB-\fIoption\fR ...] \
[\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvscale\fP scales each input object, which may be an image or an edge
set, to produce a corresponding output object. The row and column
dimensions can be scaled together or independently.
.PP
A variety of different scaling methods are selectable by command line
options. If no method is specified, the default action is to reduce by a
factor of two by averaging blocks of pixels.
.SH "COMMAND LINE OPTIONS"
\fBvscale\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the input images.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the results as a Vista data file.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.PP
In addition, one of the following may be used to specify the scaling: 
.IP "\fB-reduce\fP \fIfactor\fP" 15n
Reduces each dimension by \fIfactor\fP by averaging blocks of pixels.
\fIfactor\fP must be a positive integer. 
.IP "\fB-sample\fP \fIfactor\fP" 15n
Reduces each dimension by \fIfactor\fP by sampling pixels.
\fIfactor\fP must be a positive integer. 
.IP "\fB-expand\fP \fIfactor\fP"
Expands each dimension by \fIfactor\fP by replicating pixels.
\fIfactor\fP must be a positive integer.
.IP "\fB-scale\fP \fIfactor\fP"
Scales both dimensions by \fIfactor\fP, which can be any positive, floating
point number. A value less than 1 shrinks; one greater than 1 expands.
Bilinear interpolation is used to scale an image.  However, if
\fIfactor\fP is no more than 0.5, the image is first reduced by an integer
factor by averaging blocks of pixels.
.IP "\fB-rscale\fP \fIfactor\fP and/or \fB-cscale\fP \fIfactor\fP"
Scale the row and column dimensions independently using the same technique 
as \fB-scale\fP. If one is specified but not the other, the missing 
\fIfactor\fP defaults to 1.
.IP "\fB-aspect\fP
Scale either the row or column dimension to undo the effect of non-square
pixels. Each image's \fBpixel_aspect_ratio\fP attribute is examined to
determine a scaling that will produce square pixels. If pixels are wider
than they are tall then the image is scaled up horizontally; if they're
taller than they are wide, it is scaled up vertically.  The scaling method
used is that described under \fB-scale\fP, above. Any
\fBpixel_aspect_ratio\fB attributes found are deleted.
.SH "SEE ALSO"
.BR VEdges (3Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
