.ds Vn 2.1
.TH vselbands 1Vi "20 April 1994" "Vista Version \*(Vn"
.SH NAME
vselbands \- select bands from an image
.SH SYNOPSIS
\fBvselbands\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvselbands\fP copies selected bands from its input images to produce a
corresponding set of output images.
.PP
Command line options specify which bands are to be copied. Bands may be
selected either by band number, or by some combination of frame, viewpoint,
color, and/or component number.
.PP
If an input image contains none of the bands that have been specified for
copying, that image isn't included in the output file.
.SH "COMMAND LINE OPTIONS"
The bands to be selected may be specified by band number:
.IP "\fB-band\fP \fIb1 b2\fP ..." 15n
Select bands \fIb1\fP, \fIb2\fP, etc. from each input image.
.PP
Or they may be selected by some combination of the following four options:
.PP
.nf
\fB-frame\fP \fIf1 f2\fP ...
\fB-viewpoint\fP \fIv1 v2\fP ...
\fB-color\fP \fIc1 c2\fP ...
.fi
.ns
.IP "\fB-component\fP \fIe1 e2\fP ..." 15n
Select bands corresponding to the specified frames, viewpoints, colors, and
or components.
.PP
Some keywords are available for specifying indices: ``\fBleft\fP'' and
``\fBright\fP'' can be used to specify viewpoints; ``\fBred\fP'',
``\fBgreen\fP'', and ``\fBblue\fP'' can be used to specify colors;
``\fBreal\fP'', ``\fBimaginary\fP'', ``\fBx\fP'', ``\fBy\fP'', and
``\fBz\fP'' can be used to specify components.
.PP
The keyword ``\fBto\fP'' can be used to specify a range of indices, as in
``\fB-band\ \fIb1\fP\ \fBto\fP\ \fIb2\fP"''.
.PP
\fBvselbands\fP also accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP \fB-in\fP
Specifies a Vista data file containing the input images.
.IP \fB-out\fP
Specifies where to write the output images as a Vista data file.
.PP
The input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH EXAMPLES
To select band 0 of an image:
.IP
.B "vselbands -band 0 < infile > outfile"
.PP
To select frames 0 through 5 of an image:
.IP
.B "vselbands -frame 0 to 5 < infile > outfile"
.PP
To select the red and green components of an RGB color image:
.IP
.B "vselbands -color red green < infile > outfile"
.PP
To select the real component of the left image of a stereo pair:
.IP 
.B "vselbands -viewpoint left -component real < infile > outfile"
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
