.ds Vn 2.1
.ds GL /usr/lib
.ds XD /usr/lib/X11/app-defaults
.TH vxview 1Vi "8 February 1994" "Vista Version \*(Vn"
.SH NAME
vxview \- display Vista data files
.SH SYNOPSIS
\fBvxview\fR [\fB-\fIoption\fR ...] [\fIfile\fR ...]
.SH DESCRIPTION
The \fBvxview\fP program displays the contents of Vista data files under the 
X Window System. It provides one or more \fIview\fP windows, each showing 
the objects in a single file. 
.PP
Each view window has its own menu bar with commands for opening files, opening 
and closing windows, adjusting certain characteristics of the view, and 
displaying on-line help information. In the left half of the window is a 
list of the objects in the currently opened file. Selecting an object from 
this list causes it to be displayed in the rightmost half of the window. 
.PP
Using your window manager, you can resize, move, and iconify view windows 
and most other windows produced by the program.
.SH "COMMAND LINE OPTIONS"
The \fBvxview\fP program accepts all of the standard X Toolkit command line
options (see \fBX\fP(1)) along with the additional options listed below.
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIfile\fP ..."
May be used to specify one or more Vista data files that are to be read and 
displayed, each in its own window, on startup. 
.IP "\fB-object\fP \fInumber\fP"
Specifies which object to display initially from a file opened on startup. 
Default: 0 (the first object). 
.IP "\fB-band\fP \fInumber\fP"
Specifies which band to display initially from an image displayed on
startup. Default: 0 (the first band).
.IP "\fB-palette\fP \fBany\fP | \fBdefault\fP | \fBbest\fP | \fBgray\fP | \fBgrey\fP"
Normally \fBvxview\fP tries to use a palette of colors that gives it the
best chance of coexisting well with other X clients. This is called the
default palette. However, because it is designed to be shared, the default
palette often does not allow images to be displayed with the greatest
possible fidelity.  Specifying \fB-palette best\fP causes \fBvxview\fP to
instead use a palette optimized for displaying the most complete range of
common RGB colors (mostly reds and greens). Specifying \fB-palette gray\fP
(or \fBgrey\fP) causes it to use a palette optimized for displaying grey
shades. (When you choose \fBbest\fP, \fBgray\fP, or \fBgrey\fP, you may
find that \fBvxview\fP uses a different colormap than that used by other
windows on your screen, and you will then have to move the pointer into a
window for it to display correctly.) The default, \fBany\fP, means try for
the default palette, otherwise the best palette, otherwise the gray palette.
.IP "\fB-size\fP \fInumber\fP"
Specifies the window size initially used by \fBvxview\fP. Default: 256. You 
may use your window manager to resize windows at any time. 
.PP
Input files can be specified on the command line or allowed to default to 
the standard input stream.
.SH "USER INTERFACE"
The program follows the OSF/Motif user interface guidelines. For details on 
its use of standard interaction techniques (such as file selection and 
keyboard shortcuts) see the \fIOSF/Motif User's Manual\fP. 
.SS "View Window"
To control what portion of an image is displayed and at what 
magnification, use these mouse commands on the image:
.RS 2n
.IP "Middle Button" 15n
Zoom in by a factor of two, centering on the pointer.
.IP "Right Button"
Zoom out by a factor of two, centering on the pointer.
.IP "Ctrl Middle Button"
Shift the image to center the pixel under the pointer.
.RE
.PP
If the displayed image contains multiple bands, the view window
includes a slider that allows you to select a band for viewing. You
can move this slider by dragging with the left button, or clicking
with the middle one.
.PP
When the mouse pointer is positioned over the displayed image, the
arrow keys move the pointer up, down, left, or right by as little as
a single pixel (depending on the level of zoom magnification).
.PP
To display information about an edge and/or edge point, select it by
either clicking the left mouse button or pressing the 
.SM SPACE
key. Successive clicks cycle among alternate selections at the same 
location. 
.PP
If you click on an image pixel using Ctrl Left Button, the location and 
value of that pixel are written to the standard output stream. 
.PP
If the image has floating-point (\fBfloat\fP or \fBdouble\fP) pixel values, 
then pixel values are clipped to the range [-1,+1] before being mapped to 
grey-scale intensities. 
.SS Menus
Each view window's menu bar contains File, View, and Help menus.
The File menu includes these commands:
.RS 2n
.IP "New View..." 15n
Create a new view window, and prompt for a file to be displayed in
that window.
.IP "Remove View"
Remove the current window, quitting the program if it was the last
open window.
.IP "Open File..."
Prompt for the name of a file to view in the current window.
.IP "Reread File"
Re-read and re-display the file shown in the current window.
.IP Quit
Quit the program.
.RE
.PP
The View menu includes these commands: 
.RS 2n
.IP "Attributes..." 15n
Pop up a dialog box listing the attributes found in the current file.
.IP "Display Prefs..."
Pop up a dialog box for controlling how images and edge sets are displayed
in the current view window. (See the ``Display Preferences'' section,
below.)
.IP "Edge Data..."
Pop up a dialog box showing information about the currently selected
edge and edge point.
.RE
.PP
The Help menu includes these commands:
.RS 2n
.IP "Index..." 15n
Display a list of help topics. You may click on a topic with the left mouse 
button to see information on that topic. 
.IP "On Version..."
Display the program's version number and compilation date.
.RE
.SS "Display Preferences"
The Display Preferences dialog box allows you to determine how objects are
displayed in the current view window. It contains these controls for
determining how an image is displayed:
.RS 2n
.IP Brightness 15n
adjusts the brightness of the image. At 0.00, no adjustment is made.
.IP Contrast
adjusts the contrast of the image. At 0.00, no adjustment is made.
.IP "Show Bands Individually"
If set, an image's band interpretation attribute will be ignored. This
allows, for example, the red, green, and blue bands of a color image to be
viewed as individual gray-scale images.
.IP Intensity
controls how shades of grey are chosen for pixel values. When set to
``Absolute Pixel Value'' a pixel's absolute value determines its shade
and 0 pixels are displayed as black. When set to ``Signed Pixel Value''
a pixel's signed value determines its shade and 0 pixels are displayed as
medium grey.
.RE
.PP
These controls determine how edge sets are displayed:
.RS 2n
.IP "Show Points" 15n
causes edge points to be individually plotted.
.IP "Show Lines" 15n
causes lines joining successive edge points to be plotted.
.IP "Show Edge Endpoints" 15n
causes the first and last point of each edge to be highlighted.
.RE
.SH RESOURCES
The program obtains resource values under the class name \fBVxview\fP from
its application defaults file (see the \fBFILES\fP section). Among the
resources it consults are:
.RS 2n
.IP "\fBcolor0\fP ... \fBcolor7\fP (Class: \fBEdgeColor\fP)"
A repertoire of colors used to display edges. 
Default:\ \fBgreen\fP, \fBblue\fP, \fByellow\fP, \fBcyan\fP, \fBmagenta\fP,
\fBpurple\fP, \fBorange\fP, \fBtomato4\fP.
.IP "\fBhilite\fP (Class: \fBForeground\fP)"
The color used to display a selected edge or edge point. 
Default:\ \fBred\fP.
.IP "\fBselectRange\fP (Class: \fBRange\fP)"
The pointer must be within this distance of an edge point for
the edge point to be selected when the left button is clicked. The distance
is measured in screen pixels. Default:\ 2.
.IP "\fBsize\fP (Class: \fBSize\fP)"
The dimension of a window used to initially display an object. This resource
may be overridden by a \fB-size\fP command line option. Default:\ 256.
.RE
.PP
See \fBX\fP(1) for instructions on how to supply values overriding these
defaults.
.PP
The \fBvxview\fP program implements the editres protocol, which means that
the \fBeditres\fP(1) program may be used to examine the widget hierarchy
and to set resource values determining appearance.
.PP
Actions associated with mouse and keyboard input to the image display
widget are determined by a translation table associated with that widget.
The translations can be customized, using the example in the application
defaults file as a starting point.
.SH FILES
.IP /tmp
\fBvxview\fP creates a temporary file in /tmp when displaying the attributes
of a file or object.
.IP \*(XD/Vxview
the application defaults file containing resources required by \fBvxview\fP.
.IP \*(GL/vxview.help
contains on-line help information.
.SH "SEE ALSO"
.na
.nh
.BR vxviewe (1Vi),
.BR vxviewi (1Vi),
.BR Vfile (5Vi),
.BR Vista (7Vi),
.br
.I OSF/Motif Users Guide
.ad
.hy
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
