.ds Vn 2.1
.TH vxviewi 1Vi "4 March 1994" "Vista Version \*(Vn"
.SH NAME
vxviewi \- viewer for Vista images
.SH SYNOPSIS
\fBvxviewi\fR [\fB-\fIoption\fR ...] [\fIfile\fR ...]
.SH DESCRIPTION
\fBvxviewi\fP allows you to quickly view the images in one or more
Vista data files.
.PP
On the command line you list one or more files, each containing any number 
of images. When \fBvxviewi\fP starts up it displays the first band of the 
first image of the first file. You then use mouse buttons and keystrokes to 
operate the program:
.RS 2n
.IP "Left Button" 23n
Report, to the standard output stream, the pixel value under the pointer.
.IP "Middle Button"
Zoom in by a factor of two, centering on the pointer.
.IP "Right Button"
Zoom out by a factor of two, centering on the pointer.
.IP "Ctrl Middle Button"
Shift the image to center the pixel under the pointer.
.IP "A or Ctrl-A"
Show the first frame of the current image.
.IP "B or Ctrl-B"
Show the current image as a movie, backwards.
.IP "E or Ctrl-E"
Show the last frame of the current image.
.IP "F or Ctrl-F"
Show the current image as a movie, forward.
.IP "N or Ctrl-N"
Show the next displayable image (the next band of the current image, the 
next image of the current file, or the first image of the next file).
.IP "P or Ctrl-P"
Show the previous displayable image.
.IP "Q or Ctrl-Q"
Quit the program.
.IP "R or Ctrl-R"
Reread the input files and then re-display the first image. (This command 
is only available if images are read from named files rather than the 
standard input stream.)
.IP "S or Ctrl-S"
Stop a movie display.
.IP "? or Ctrl-?"
Display help information.
.RE
.PP
By default, \fBvxviewi\fP displays intensity according to absolute pixel
value. It shows pixel value 0 as black, and both positive and negative
pixel values as lighter shades of grey. This is normally what you'd like
when viewing images since their pixel values generally range from 0 up,
with 0 representing black. When viewing signed data such as a convolution
kernel however, you may wish to specify the \fB-signed\fP switch, which is
described below.
.SH "COMMAND LINE OPTIONS"
\fBvxviewi\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIfile\fP ..."
May be used to specify the Vista data files containing the images you wish 
to see.
.IP "\fB-delay\fP \fIn\fP"
Specifies the delay between consecutive frames of a movie, in milliseconds.
Default: 100.
.IP "\fB-depth\fP"
Specifies the depth of the visual to be used by \fBvxviewi\fP for its
windows. If not specified, it defaults to something appropriate for the
type of palette requested with \fB-palette\fP.
.IP "\fB-noresize\fB"
Normally the window proportions are automatically adjusted to match those
of the image currently displayed. Specifying \fB-noresize\fP leaves them,
instead, entirely up to the user and his/her window manager.
.IP "\fB-palette\fP \fBany\fP | \fBdefault\fP | \fBbest\fP | \fBgray\fP | \fBgrey\fP"
Normally \fBvxviewi\fP tries to use a palette of colors that gives it the
best chance of coexisting well with other X clients. This is called the
default palette. However, because it is designed to be shared, the default
palette often does not allow images to be displayed with the greatest
possible fidelity.  Specifying \fB-palette best\fP causes \fBvxviewi\fP to
instead use a palette optimized for displaying the most complete range of
common RGB colors (mostly reds and greens). Specifying \fB-palette gray\fP
(or \fBgrey\fP) causes it to use a palette optimized for displaying grey
shades. (When you choose \fBbest\fP, \fBgray\fP, or \fBgrey\fP, you may
find that \fBvxviewi\fP uses a different colormap than that used by other
windows on your screen, and you will then have to move the pointer into a
window for it to display correctly.) The default, \fBany\fP, means try for
the default palette, otherwise the best palette, otherwise the gray palette.
.IP "\fB-signed\fP"
Specifies that 0 is to be shown as medium gray, negative values as
darker shades, and positive values as lighter shades. If omitted, 
intensity corresponds to absolute pixel values with 0 shown as black.
.IP "\fB-size\fP \fIn\fP"
Specifies the maximum dimension of the window \fBvxviewi\fP should use to 
display images. Default: 256. You may resize the window at any time, 
effectively establishing a new maximum dimension that \fBvxviewi\fP will use 
thereafter.
.PP 
Input files can be specified on the command line or allowed to default to 
the standard input stream.
.SH "SEE ALSO"
.na
.nh
.BR vxview (1Vi),
.BR vxviewe (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.ad
.hy
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
