'\" t
.ds Vn 2.1
.TH vzeroc 1Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
vzeroc \- mark zero crossings in an image
.SH SYNOPSIS
\fBvzeroc\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH "IMAGE TYPE RESTRICTIONS"
Input images must have signed pixels (not \fBbit\fP or \fBubyte\fP).
.SH DESCRIPTION
\fBvzeroc\fP marks the zero crossings in each input image to produce a 
corresponding output image.
.PP
Each output image pixel is set according to whether a zero crossing occurs 
at the corresponding input image pixel. If an output pixel does not 
correspond to a zero crossing, it is set to zero. If it does, it is set to 
the gradient of the zero crossing. The gradient is simply computed as the 
magnitude of the difference between input pixels on each side of the zero 
crossing.
.PP
Each output image is smaller than its source image by one row and one 
column. It has the same number of bands as the input image, and its pixel 
representation depends on that of the input image as defined by the 
following table: 
.PP
.TS
center ;
c c .
Input Representation	Output Representation
_
\fBbit\fP	\fInot supported\fP
\fBubyte\fP	\fInot supported\fP
\fBsbyte\fP	\fBubyte\fP
\fBshort\fP	\fBlong\fP
\fBlong\fP	\fBlong\fP
\fBfloat\fP	\fBfloat\fP
\fBdouble\fP	\fBdouble\fP
.TE
.SH "COMMAND LINE OPTIONS"
\fBvzeroc\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing the input images.
.IP "\fB-out\fP \fIinfile\fP"
Specifies where to write the output images as a Vista data file.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.BR vconvolve (1Vi)
.BR vlink (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.SH AUTHORS
David Lowe <lowe@cs.ubc.ca>, Art Pope <pope@cs.ubc.ca>
