.ds Vn 2.1
.TH VCameraCoord 3Vi "1 June 1994" "Vista Version \*(Vn"
.SH NAME
VCameraCoord \- convert among camera model coordinate systems
.SH SYNOPSIS
.B "#include <vista/VCamera.h>"
.HP 10n
.na
.nh
.ft B
VBoolean VWorldToCameraCoords (VCamera \fIc\fP,
VDouble\ \fIpw\fP[3], VDouble\ \fIpc\fP[3]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
VBoolean VCameraToWorld (VCamera \fIc\fP,
VDouble\ \fIpc\fP[3], VDouble\ \fIpw\fP[3]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
VBoolean VWorldToImageCoords (VCamera \fIc\fP,
VDouble\ \fIpw\fP[3], VDouble\ \fIpid\fP[2]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
VBoolean VImageToWorldCoords (VCamera \fIc\fP,
VDouble\ \fIpid\fP[2], VDouble\ \fIpw\fP[3], VDouble\ \fIpwz\fP);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
void VDistortedToUndistortedImageCoords (VCamera \fIc\fP,
VDouble\ \fIpid\fP[2], VDouble\ \fIpiu\fP[2]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
void VUndistortedToDistortedImageCoords (VCamera \fIc\fP,
VDouble\ \fIpiu\fP[2], VDouble\ \fIpid\fP[2]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
void VDistortedToUndistortedSensorCoords (VCamera \fIc\fP,
VDouble\ \fIpsd\fP[2], VDouble\ \fIpsu\fP[2]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
void VUndistortedToDistortedSensorCoords (VCamera \fIc\fP,
VDouble\ \fIpsu\fP[2], VDouble\ \fIpsd\fP[2]);
.ft
.hy
.ad
.HP 10n
.na
.nh
.ft B
void VImageToUndistortedSensorCoords (VCamera \fIc\fP,
VDouble\ \fIpid\fP[2], VDouble\ \fIpsu\fP[2]);
.ft
.hy
.ad
.SH ARGUMENTS
.IP \fIc\fP 10n
Specifies the camera model describing the mapping among coordinate systems.
.IP \fIpc\fP
Specifies or returns the location of a point in camera coordinates.
.IP \fIpid\fP
Specifies or returns the location of a point in distorted image coordinates
(i.e., the location at which the point is actually detected by the camera
and frame grabber, as subject to various distortions).
.IP \fIpiu\fP
Specifies or returns the location of a point in undistorted image
coordinates (i.e., the location the point would have if the camera were
free of distortion).
.IP \fIpsd\fP
Specifies or returns the location of the point in distorted sensor
coordinates.
.IP \fIpsu\fP
Specifies or returns the location of the point in undistorted sensor
coordinates.
.IP \fIpw\fP
Specifies or returns the location of a point in world coordinates.
.IP \fIpwz\fP
Specifies the world Z coordinate of a point being mapped from 2D
coordinates to 3D world coordinates.
.SH DESCRIPTION
Each routine maps a point from one coordinate system to another according
to the camera model \fIc\fP.
.PP
Most routines can be understood readily from their names. Generally, the
second argument specifies the known location of the point in one coordinate
system, and the third argument returns the mapped location in the other
coordinate system.
.PP
\fBVImageToWorldCoords\fP, because it maps from a 2D coordinate system to a
3D one, takes an additional argument, \fIpwz\fP, specifying the world
Z coordinate.
.SH "RETURN VALUES"
\fBVWorldToCameraCoords\fP and \fBVCameraToWorldCoords\fP require the
camera model's extrinsic parameters to be defined.
\fBVWorldToImageCoords\fP and \fBVImageToWorldCoords\fP require both
extrinsic parameters and focal length to be defined. These routines return
.SB TRUE
if successful, and 
.SB FALSE
if a needed parameter is undefined.
.SH "SEE ALSO"
.na
.nh
.BR VCamera (3Vi),
.BR Vlib (7Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``Extrinsic parameters undefined.''"
See the comment under RETURN VALUES, above.
.IP "``Focal length undefined.''"
See the comment under RETURN VALUES, above.
.SH AUTHORS
Original implementation by Reg Willson <rgw@cs.cmu.edu>.
Improvements by Frederic Devernay <Frederic.Devernay@sophia.inria.fr>.
Vista implementation by Art Pope <pope@cs.ubc.ca>.
