.ds Vn 2.1
.TH vcalsyn 1Vi "1 June 1994" "Vista Version \*(Vn"
.SH NAME
vcalsyn \- generate synthetic camera calibration data
.SH SYNOPSIS
\fBvcalsyn\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
\fBvcalsyn\fP uses a camera model to generate a set of data points for use
in testing camera calibration procedures.
.PP
The points are placed in a two- or three-dimensional array of world
positions. From there, their image coordinates are computed according to
the camera model. To simulate measurement and feature localization noise,
the world and image coordinates of the points are then randomly perturbed
by a specified amount of additive Gaussian noise.
.SH "COMMAND LINE OPTIONS"
\fBvcalsyn\fP accepts the following options:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP ..."
Specifies a Vista data file containing the calibrated camera model.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the set of data points as a Vista data file.
.IP "\fB-name\fP \fIname\fP"
Specifies a name for the object in \fIoutfile\fP whose value will be an
attribute list of data point coordinates. Default: \fBpoints\fP.
.IP "\fB-coplanar true\fP | \fBfalse\fP"
Specifies whether the data points should be coplanar. Default: \fBfalse\fP.
.IP "\fB-count\fP \fInx ny nz\fP"
Specifies the number of points in each dimension of the world coordinate
system. Default: 10 10 3.
.IP "\fB-origin \fIox oy oz\fP"
Specifies the origin of the first point in world coordinates. Default: 10
10 0.
.IP "\fB-spacing \fIdx dy dz\fP"
Specifies the spacing between points in world coordinates. Default: 20 20
20.
.IP "\fB-world_stddev\fP \fIsw\fP"
Specifies the standard deviation of world coordinate measurement noise.
Default: 0.04.
.IP "\fB-image_stddev\fP \fIsi\fP
Specifies the standard deviation of image coordinate measurement noise. 
Default: 0.02.
.IP "\fB-report true\fP | \fBfalse\fP"
Specifies whether error measures are to be reported. These are statistics
of the normalized calibration error and object space calibration error
described by \fBVCameraError\fP(3Vi). They are computed using the
synthesized data points and the calibrated camera model.  Default:
\fBtrue\fP.
.IP "\fB-seed\fP \fIs\fP"
Specifies a seed for initializing the random number generator. Default: a
random number.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "SEE ALSO"
.BR VCamera (3Vi),
.BR VCameraError (3Vi),
.BR vcamcal (1Vi),
.BR Vista (7Vi)
.SH NOTES
This program can be used to test \fBvcamcal\fP(1Vi) as follows.  By hand,
create a Vista data file containing a camera model with extrinsic and
intrinsic parameters fully specified. Use \fBvcalsyn\fP to generate a set
of data points consistent with this camera model. Then delete the camera
model's parameters, and supply it to \fBvcamcal\fP along with the data
points; \fBvcamcal\fP should come close to replicating the camera model's
original parameters.
.SH AUTHORS
Original implementation by Reg Willson <rgw@cs.cmu.edu>.
Vista implementation by Art Pope <pope@cs.ubc.ca>.
