.ds Vn 2.1
.TH VXDisplayMessage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXDisplayMessage \- display text in the main window's message area
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
void VXDisplayMessage (\fIoverwrite\fP, \fIformat\fR [\fB, \fIarg\fR ...]\fB)
.RS
VBoolean \fIoverwrite\fP;
VStringConst \fIformat\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIoverwrite\fP 10n
Specifies whether to overwrite existing messages:
.SB TRUE
indicates that the new text should overwrite them;
.SB FALSE
indicates that the new text should be appended to the end of them.
.IP \fIformat\fP
Specifies the format of the text to be displayed.
.IP \fIarg\fP
Specifies a value to be included in the formatted message.
.SH DESCRIPTION
\fBVXDisplayMessage\fP displays text in the message area of a main window
managed by the VX library.
.PP
The syntax and meaning of the \fIformat\fP and \fIarg\fP arguments are 
equivalent to those of \fBprintf\fP(3), except that \fBVXDisplayMessage\fP 
displays the formatted text in the message area rather instead of 
printing it.
.SH SEE ALSO
.na
.nh
.BR printf (3V),
.BR VXShowMessageArea (3Vi),
.BR VXHideMessageArea (3Vi),
.BR VX (3Vi)
.hy
.ad
.SH DIAGNOSTICS
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
