.ds Vn 2.1
.TH VXDrawLine 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXDrawLine, VXDrawEdges, VXClearLines \- draw lines overtop a displayed image
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
VBoolean VXDrawLine (\fIr1\fP, \fIc1\fP, \fIr2\fP, \fIc2\fP)
.RS
double \fIr1\fP, \fIc1\fP, \fIr2\fP, \fIc2\fP;
.RE
.PP
.ft B
VBoolean VXDrawEdges (\fIedges\fP)
.RS
VEdges \fIedges\fP;
.RE
.PP
.B void VXClearLines (void)
.fi
.SH ARGUMENTS
.IP "\fIr1\fP, \fIc1\fP, \fIr2\fP, \fIc2\fP" 10n
Specify the row (\fIr\fP) and column (\fIc\fP) coordinates of the line 
segment's two endpoints.
.IP \fIedges\fP
Specifies a set of edges to be drawn.
.SH DESCRIPTION
These routines draw overtop an image in the drawing area of a main window 
managed by the VX library. 
.PP
\fBVXDrawLine\fP draws a line segment from (\fIr1\fP,\fIc1\fP) to 
(\fIr2\fP,\fIc2\fP) using the current line color and width. Any portion 
lying outside the zoomed image will be clipped. 
.PP
\fBVXDrawEdges\fP draws a set of edges using the current line color and 
width. Each edge is interpreted as a set of line segments and drawn as 
though by a series of calls to \fBVXDrawLine\fP. Since edge points are 
located in a different coordinate system than image pixels (the origins of 
the two systems are in different places), however, an appropriate 
transformation is made to edge point coordinates.
.PP
\fBVXClearLines\fP clears all existing lines, including clipped portions 
of lines. It doesn't affect the current line color and width.
.SH "RETURN VALUES"
\fBVXDrawLine\fP and \fBVXDrawEdges\fP return 
.SB TRUE
if it is successful, and
.SB FALSE
otherwise.
.SH SEE ALSO
.na
.nh
.BR VXSetLineColor (3Vi),
.BR VXSetLineWidth (3Vi),
.BR VX (3Vi)
.hy
.ad
.SH NOTES
An integer-valued coordinate (\fIr\fP,\fIc\fP) refers to the top-left 
corner of the image pixel at row \fIr\fP and column \fIc\fP. In order to 
make an endpoint appear to be at the center of an image pixel, a value of 
0.5 has to be added to each member of an integer-valued coordinate. 
.PP
Lines drawn will \fInot\fP be cleared by a subsequent call to 
\fBVXSetImage\fP(3Vi); however, the coordinates of the lines will then be 
interpreted in terms of the new image's coordinate system. 
.SH DIAGNOSTICS
.IP "``Cannot draw on NULL image.''"
No image is currently managed by VX. A line cannot be drawn on nothing. 
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
