.ds Vn 2.1
.TH VXDrawText 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXDrawText, VXClearText \- draw text overtop a displayed image
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
VBoolean VXDrawText (\fItext\fP, \fIr\fP, \fIc\fP)
.RS
VStringConst \fItext\fP;
double \fIr\fP, \fIc\fP;
.RE
.PP
.B void VXClearTexts (void)
.fi
.SH ARGUMENTS
.IP \fItext\fP 10n
Specifies the text string to be drawn.
.IP "\fIr\fP, \fIc\fP"
Specify the row (\fIr\fP) and column (\fIc\fP) coordinates of the lower 
left-hand corner of the text string. 
.SH DESCRIPTION
These routines draw overtop an image in the drawing area of a main window 
managed by the VX library.
.PP
\fBVXDrawText\fP draws a text string using the current text color and font. 
The lower left-hand corner of the text is located at (\fIr\fP,\fIc\fP). Any 
portion lying outside the zoomed image will be clipped. 
.PP
\fBVClearTexts\fP clears all existing text strings from the image, 
including their clipped portions. It doesn't affect the current text
color and width.
.SH "RETURN VALUES"
\fBVXDrawText\fP returns
.SB TRUE
if it is successful, and
.SB FALSE
otherwise.
.SH SEE ALSO
.na
.nh
.BR VXSetTextColor (3Vi),
.BR VXSetTextWidth (3Vi),
.BR VX (3Vi)
.hy
.ad
.SH NOTES
Text drawn will \fInot\fP be cleared by a subsequent call to 
\fBVXSetImage\fP(3Vi); however, the coordinates of the text will then be 
interpreted in terms of the new image's coordinate system. 
.SH DIAGNOSTICS
.IP "``Cannot draw on NULL image.''"
No image is currently managed by VX. Text cannot be drawn on nothing. 
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
