.ds Vn 2.1
.TH VXGetWidget 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXGetApplicationShell, VXGetImageViewWidget \- obtain VX widget IDs
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.B Widget VXGetApplicationShell (void)
.PP
.B Widget VXGetImageViewWidget (void)
.fi
.SH DESCRIPTION
These routines return the widget IDs of widgets created by the VX library.
.PP
\fBVXGetApplicationShell\fP returns the widget ID of the top level 
application shell, which is the ancestor of all other widgets created by 
VX. Given the widget ID of the application shell, one can use the X Toolkit 
function \fBXtNameToWidget\fP(3Xt) to find the widget ID of any widget 
created by VX provided that the name of the widget is known. 
.PP
\fBVXGetImageViewWidget\fP returns the ID of the VImageView widget, which 
displays images and serves as VX's drawing area for text, lines, and edges. 
.SH SEE ALSO
.BR XtNameToWidget (3Xt),
.BR VImageView (3Vi),
.BR VX (3Vi)
.SH DIAGNOSTICS
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
