.ds Vn 2.1
.TH VXPopupModeless 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXPopupMessageBox, VXPopupTextBox \- pop up a dialog box for output
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
void VXPopupMessageBox (\fItitle\fP, \fImessage\fP)
.RS
VStringConst \fItitle\fP, \fImessage\fP;
.RE
.PP
.ft B
void VXPopupTextBox (\fInrows\fP, \fIncolumns\fP, \fItitle\fP, \fItext\fP)
.RS
int \fInrows\fP, \fIncolumns\fP;
VStringConst \fItitle\fP, \fItext\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fItitle\fP 10n
Specifies the title of the dialog box.
.IP \fImessage\fP
Specifies the message to be displayed.
.IP "\fInrows\fP, \fIncolumns\fP"
Specifies the initial number of rows and columns in the text box.
.IP \fItext\fP
Specifies the text to be displayed.
.SH DESCRIPTION
These routines, part of the VX library, provide output to the user by
popping up modeless dialog boxes. A modeless dialog box allows the user to
continue interacting with other application windows without first closing
the box. The routines return immediately, without waiting for the user to
dismiss the box.
.PP
\fBVXPopupMessageBox\fP pops up a dialog box displaying the text, 
\fImessage\fP. Clicking the box's single ``OK'' button dismisses it.
.PP
\fBVXPopupTextBox\fP pops up a resizable dialog box displaying the text, 
\fItext\fP, in a non-editable text field with initially \fInrows\fP rows 
and \fIncolumns\fP columns. The field includes vertical and horizontal 
scroll bars. Clicking the box's single ``OK'' button dismisses it. 
.SH SEE ALSO
.na
.nh
.BR VXPopupFileBox (3Vi),
.BR VXPopupInputBox (3Vi),
.BR VXPopupYesNoBox (3Vi),
.BR VX (3Vi)
.ad
.hy
.SH DIAGNOSTICS
.IP "``Main event loop not started.''" 
The main event loop has not been started by a prior call to 
\fBVXAppMainLoop\fP(3Vi). This function must be called inside the main 
event loop by a callback function. 
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
