.ds Vn 2.1
.TH VXReportValidOptions 3Vi "25 February 1994" "Vista Version \*(Vn"
.SH NAME
VXReportValidOptions \- report options recognized by VX
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.B void VXReportValidOptions (void);
.fi
.SH DESCRIPTION
This routine prints a message on the standard error stream describing the
options recognized by \fBVXInit\fP(3Vi). It's intended to be used in
conjunction with \fBVReportUsage\fP(3Vi), as shown by the example below.
.SH EXAMPLE
A typical VX program begins:
.PP
.RS 4n
.nf
.ft B
.ta 4n 8n 12n
int main (int argc, char **argv)
{
	static VOptionDescRec options[] = {
		\fR...\fP
	};

	VXInit (CLASS, RESOURCES, & argc, argv);

	if (! VParseCommand (VNumber (options), options, & argc, argv)) {
		VReportUsage (argv[0], VNumber (options), options, NULL);
		VXReportValidOptions ();
		fprintf (stderr, "    plus X Windows options.\\n\\n");
		exit (EXIT_FAILURE);
	}

	\fR...\fP
}
.DT
.ft
.fi
.RE
.PP
In response to \fB-help\fP or an erroneous command line option, it produces
the following output:
.PP
.RS 4n
.nf
.ft B
.ta 4n 8n 12n
Usage: PROGRAM <options>, where <options> includes:
	-help
		Prints usage information.
	\fR...\fP
	-palette any | default | best | gray | grey
		Color palette to use. Default:  any.
	plus X Windows options.
.DT
.ft
.fi
.RE
.SH SEE ALSO
.na
.nh
.BR VXInit (3Vi),
.BR VX (3Vi),
.BR VReportUsage (3Vi),
.BR Voption (3Vi)
.hy
.ad
.SH AUTHOR
Art Pope <pope@cs.ubc.ca>
