.ds Vn 2.1
.TH VXSetImage 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXSetImage \- display a region of an image
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
VBoolean VXSetImage (\fIimage\fP, \fIband\fP, \fIzoom_level\fP, \
\fIr_center\fP, \fIc_center\fP)
.RS
VImage \fIimage\fP;
VBand \fIband\fP;
double \fIzoom_level\fP;
int \fIr_center\fP, \fIc_center\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIimage\fP 10n
Specifies the image to be displayed.
.IP \fIband\fP
Specifies the image band to be displayed. 
.IP \fIzoom_level\fP
Specifies the zoom level of the region to be displayed. It can be
any number greater than or equal to 1.
.IP "\fIr_center\fP, \fIc_center\fP"
Specify the row and column coordinates of the center of the region to
be displayed.
.SH DESCRIPTION
\fBVXSetImage\fP displays a region of an image in the drawing area of a 
main window managed by the VX library. 
.PP 
The \fIimage\fP and \fIband\fP arguments select a particular image band. 
The \fIr_center\fP and \fIc_center\fP arguments specify the zoom center of 
the band. This zoom center determines the center of the zoomed image. The 
zoomed image centered at that point, unless doing so would force the zoomed 
image to contain regions outside of \fIimage\fP, in which case the zoom 
center will be adjusted to ensure that the zoomed image is completely 
inside of \fIimage\fP. The \fIzoom_level\fP argument specifies the degree 
of zooming. A large \fIzoom_level\fP means only a small portion of the 
image will be displayed. 
.PP
The displayed region of the image also defines the clipping rectangle 
used to clip lines drawn overtop of the image by \fBVXDrawLine\fP(3Vi).
.SH "RETURN VALUES"
\fBVXSetImage\fP returns 
.SB TRUE
if successful, and
.SB FALSE
otherwise.
.SH SEE ALSO
.BR VX (3Vi)
.SH NOTES
Don't destroy the image after giving it to \fBVXSetImage\fP \(em VX needs
it around as long as its being displayed but it doesn't make its own copy.
.SH DIAGNOSTICS
.IP "``Cannot set NULL image.''"
.SB NULL
was supplied for \fIimage\fP.
A non-\c
.SB NULL
value is required.
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.IP "``Zoom level less than 1.''"
The zoom level specified by \fIzoom_level\fP must be at least 1. 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
