.ds Vn 2.1
.TH VXSetLineColor 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXSetLineColor, VXSetLineWidth \- specify the current line color and width
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
VBoolean VXSetLineColor (\fIcolor\fP)
.RS
VStringConst \fIcolor\fP;
.RE
.PP
.ft B
void VXSetLineWidth (\fIwidth\fP)
.RS
double \fIwidth\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIcolor\fP 10n
Specifies the name of the new current line color.
.IP \fIwidth\fP
Specifies the new current line width.
.SH DESCRIPTION
These routines determine the color and width of lines subsequently drawn 
by \fBVXDrawLine\fP(3Vi) and \fBVXDrawEdges\fP(3Vi).
.PP
\fBVXSetLineColor\fP changes the current line color to the value specified 
by \fIcolor\fP. The list of valid color names can be found in the text file 
\fBrgb.txt\fP, which is usually located in \fB/usr/lib/X11\fP. For more 
information on how to specify a color, see \fBX\fP(1).
.PP
\fBVXSetLineWidth\fP changes the current line width to the value specified 
by \fIwidth\fP, which is measured in image pixels (not screen pixels). 
However, when \fIwidth\fP is zero, the current line width is set to one 
screen pixel. 
.PP
Note that calls to \fBVXSetLineColor\fP and \fBVXSetLineWidth\fP do not 
affect the colors and widths of lines already drawn. 
.SH "RETURN VALUES"
\fBVXSetLineColor\fP returns
.SB TRUE
if successful, and
.SB FALSE
otherwise.
.SH FILE
.IP /usr/lib/X11/rgb.txt 10n
contains the database of valid color names
.SH SEE ALSO
.na
.nh
.BR VXDrawLine (3Vi),
.BR VXDrawEdges (3Vi),
.BR VX (3Vi)
.hy
.ad
.SH DIAGNOSTICS
.IP "``Cannot allocate color \fIcolor\fP.''"
Unable to allocate a colortable entry for \fIcolor\fP.
.IP "``Color \fIcolor\fP not recognized.''"
The color wasn't found in the color name database.
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
