.ds Vn 2.1
.TH VXSetTextColor 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME	
VXSetTextColor, VXSetTextFont \- specify the current text color and font
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.ft B
VBoolean VXSetTextColor (\fIcolor\fP)
.RS
VStringConst \fIcolor\fP;
.RE
.PP
.ft B
VBoolean VXSetTextFont (\fIfontname\fP)
.RS
VStringConst \fIfontname\fP;
.RE
.fi
.SH ARGUMENTS
.IP \fIcolor\fP 10n
Specifies the name of the new current text color.
.IP \fIfontname\fP
Specifies the name of the new current text font.
.SH DESCRIPTION
These routines determine the color and font of text subsequently drawn 
by \fBVXDrawText\fP(3Vi).
.PP
\fBVXSetTextColor\fP changes the current text color to the value specified 
by \fIcolor\fP. The list of valid color names can be found in the text file 
\fBrgb.txt\fP, which is usually located in \fB/usr/lib/X11\fP. For more 
information on how to specify a color, see \fBX\fP(1).
.PP
\fBVXSetTextFont\fP changes the current text font to the one specified by 
\fIfontname\fP. A list of valid font names can be obtained from the program 
\fBxlsfonts\fP, which is part of the X11R5 core distribution (see 
\fBxlsfonts\fP(1)). Wildcarding of font names is also supported (see 
\fBX\fP(1)). 
.PP
Note that calls to \fBVXSetTextColor\fP and \fBVXSetTextFont\fP will not 
affect the colors and fonts of text already drawn.
.SH "RETURN VALUES"
\fBVXSetTextColor\fP returns
.SB TRUE
if successful, and
.SB FALSE
otherwise.
.SH FILE
.IP /usr/lib/X11/rgb.txt 10n
contains the database of valid color names
.SH SEE ALSO
.BR VXDrawText (3Vi),
.BR VX (3Vi)
.SH DIAGNOSTICS
.IP "``Cannot allocate color \fIcolor\fP.''"
Unable to allocate the color \fIcolor\fP in the display's color table.
.IP "``Cannot find font \fIfontname\fP.''"
Unable to find the font \fIfontname\fP in the font database. 
.IP "``Cannot allocate color \fIcolor\fP.''"
Unable to allocate a colortable entry for \fIcolor\fP.
.IP "``Color \fIcolor\fP not recognized.''"
The color wasn't found in the color name database.
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
