.ds Vn 2.1
.TH VXShowMessageArea 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXShowMessageArea, VXHideMessageArea \- show/hide the main window's message area
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.B void VXShowMessageArea (void)
.PP
.B void VXHideMessageArea (void)
.fi
.SH DESCRIPTION
These routines show and hide the message area of the main window managed 
by the VX library.
.PP
\fBVXShowMessageArea\fP makes visible the main window's message area, 
lengthening the main window to accommodate it. This function has no effect 
if the message area is already visible. 
.PP
\fBVXHideMessageArea\fP hides the main window's message area, shortening the 
main window accordingly. This function has no effect if the message area is 
already invisible.
.PP
The message area is initially visible if the application resource 
\fBVXNmessageAreaNLines\fP is nonzero.
.PP
Neither routine changes the contents of the message area.
.SH SEE ALSO
.BR VXDisplayMessage (3Vi),
.BR VX (3Vi)
.SH DIAGNOSTICS
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
