.ds Vn 2.1
.TH VXStoreOverlays 3Vi "24 April 1993" "Vista Version \*(Vn"
.SH NAME
VXStoreOverlays, VXRestoreOverlays \- save and restore overlay state
.SH SYNOPSIS
.nf
.B #include <vista/VX.h>
.PP
.B void VXStoreOverlays (void)
.PP
.B void VXRestoreOverlays (void)
.fi
.SH DESCRIPTION
Overlay objects are drawings made by \fBVXDrawLine\fP(3Vi) and 
\fBVXDrawEdges\fP(3Vi) in a window maintained by the VX library.
.PP
\fBVXStoreOverlays\fP saves the current state of all overlay objects. Any 
later changes to the overlay objects, such as their removal by a call to 
\fBVXClearLines\fP(3Vi), will not affect the data maintained by 
\fBVXStoreOverlays\fP. Successive calls to \fBVXStoreOverlays\fP are 
\fInot\fP treated in a nested manner \(em that is, a call to 
\fBVXStoreOverlays\fP will replace all the data maintain by the previous 
call to \fBVXStoreOverlays\fP. 
.PP
\fBVXRestoreOverlays\fP removes all existing overlay objects and 
regenerates all overlay objects stored by \fBVXRestoreOverlays\fP. 
\fBVXRestoreOverlays\fP will not change the data maintained by 
\fBVXStoreOverlays\fP. 
.SH SEE ALSO
.BR VDrawEdges (3Vi),
.BR VDrawLine (3Vi),
.BR VX (3Vi)
.SH DIAGNOSTICS
.IP "``Main event loop not started.''"
The main event loop has not been started with a prior call to 
\fBVXAppMainLoop\fP(3Vi). These routines must be called inside the main 
event loop by a callback function.
.IP "``VX not initialized.''"
The VX library has not been initialized with a prior call to 
\fBVXInit\fP(3Vi). 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
