.ds Vi Vista
.ds Vn 2.1
.TH vxadjust 1Vi "25 February 1994" "\*(Vi Version \*(Vn"
.SH NAME
vxadjust \- adjust image brightness and contrast interactively
.SH SYNOPSIS
\fBvxadjust\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
The \fBvxadjust\fP program adjusts the brightness and/or contrast of a file
of images interactively under the X Window System. 
.PP
It displays two windows on the screen: a main window for displaying images 
and a control panel window for accepting brightness and contrast adjustment 
parameters. The interpretation of these parameters is the same as that in 
\fBvadjust\fP(1Vi) and \fBVAdjustImage\fP(3Vi). See \fBVAdjustImage\fP(3Vi) 
for details.
.PP
Images are adjusted on a per-band basis. \fBvxadjust\fP has the notion of
a \fIcurrent band\fP.  Any changes to the brightness and contrast
parameters will only affect the current band.  On startup, the current band
is set to be the first band of the first image in \fIinfile\fP. A user can
then use the control panel to set the current band to any band of any image
in \fIinfile\fP.  The current band number is always displayed in the
message area of the main window.
.PP
Images are, in general, displayed on a per-band basis in grey scale.
However, a single-component, RGB color image (with \fBncomponents:\ 1\fP,
\fBncolors:\ 3\fP, and \fBcolor_interp: rgb\fP) will be displayed in
color; nevertheless, the color image is adjusted a single band at a time.
.SH "COMMAND LINE OPTIONS"
The \fBvxadjust\fP program accepts the usual X Toolkit options (see
\fBX\fP(1)), plus the following:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file containing images to be adjusted.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the adjusted images as a Vista data file.
.IP "\fB-palette\fP \fBany\fP | \fBdefault\fP | \fBbest\fP | \fBgray\fP | \fBgrey\fP"
Normally \fBvxadjust\fP tries to use a palette of colors that gives it the
best chance of coexisting well with other X clients. This is called the
default palette. However, because it is designed to be shared, the default
palette often does not allow images to be displayed with the greatest
possible fidelity.  Specifying \fB-palette best\fP causes \fBvxadjust\fP to
instead use a palette optimized for displaying the most complete range of
common RGB colors (mostly reds and greens). Specifying \fB-palette gray\fP
(or \fBgrey\fP) causes it to use a palette optimized for displaying grey
shades. (When you choose \fBbest\fP, \fBgray\fP, or \fBgrey\fP, you may
find that \fBvxadjust\fP uses a different colormap than that used by other
windows on your screen, and you will then have to move the pointer into a
window for it to display correctly.) The default, \fBany\fP, means try for
the default palette, otherwise the best palette, otherwise the gray palette.
.IP "\fB-signed\fP"
Specifies that a zero pixel is to be shown as medium grey, negative pixels
as darker shades, and positive pixels as lighter shades.  If omitted,
intensity corresponds to absolute pixel values with zero shown as black.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "USER INTERFACE"
The program's main window has a menu bar with File and Help menus. The 
File meny contains one command:
.RS 2n
.IP "Save and Quit" 15n
Quit the program after writing the adjusted images to \fIoutfile\fP.
.RE
.PP
The main window also shows an image in its current state of adjustment, and 
the identity of the image and band currently being adjusted. The following 
mouse actions can be used on the image: 
.RS 2n
.IP "Left Button" 15n
Display the location and adjusted value of the pixel under the pointer.
.IP "Middle Button"
Zoom in by a factor of two, centering on the pointer.
.IP "Right Button"
Zoom out by a factor of two, centering on the pointer.
.IP "Ctrl Middle Button"
Shift the image to center the pixel under the pointer.
.RE
.PP
The program's second, control panel window contains one scale each for 
adjusting the brightness and contrast of the current band of the displayed 
image. A ``Reset'' button resets both controls to their neutral settings 
(producing no adjustment). Left and right arrow buttons move to the next or 
previous image band and/or image in the input file. 
.SH "SEE ALSO"
.na
.nh
.BR vadjust (1Vi),
.BR vconvert (1Vi),
.BR vop (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi),
.br
.I OSF/Motif User's Guide
.ad
.hy
.SH AUTHORS
Daniel Ko <ko@cs.ubc.ca>,
Art Pope <pope@cs.ubc.ca>
