.ds Vi Vista
.ds Vn 2.1
.TH vxcrop 1Vi "25 February 1994" "\*(Vi Version \*(Vn"
.SH NAME
vxcrop \- crop images interactively
.SH SYNOPSIS
\fBvxcrop\fR [\fB-\fIoption\fR ...] [\fIinfile\fR] [\fIoutfile\fR]
.SH DESCRIPTION
The \fBvxcrop\fP program allows images to be cropped interactively under 
the X Window System. 
.PP
You specify the cropping parameters (i.e. the size and location of the
region to be retained) by drawing an outlining rectangle over each image.
All the pixels inside the rectangle will be retained in the cropped image.
To draw the rectangle press the left mouse button with the pointer at one
corner, drag to the opposite corner, then release the mouse button.
This operation can be repeated if necessary.
.PP
Images are cropped on a per image basis \(em that is, the cropping parameters
of any image apply to all bands of the image.  \fBvxcrop\fP has the notion
of a \fIcurrent image\fP.  Any changes to the cropping parameters will only
affect the current image.  On start-up, the current image is set to be the
first image in \fIinfile\fP. Ctrl-N and Ctrl-P are then used to move to the
next and previous images in \fIinfile\fP. The current image number is
always displayed at the bottom of \fBvxcrop\fP's window.
.PP
If the current image is a single-component, RGB color image (with
\fBncomponents:\ 1\fP, \fBncolors:\ 3\fP, and \fBcolor_interp:
rgb\fP) then it will be displayed in color using information from the
first three bands of the image.  Otherwise, the first band of the current
image will be displayed in gray-scale. Note that in both cases, although
only the first band(s) is/are displayed, the cropping parameters apply to
all bands of the image.
.SH "COMMAND LINE OPTIONS"
The \fBvxcrop\fP program accepts the usual X Toolkit options (see
\fBX\fP(1)), plus the following:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP"
Specifies a Vista data file whose images are to be cropped.
.IP "\fB-out\fP \fIoutfile\fP"
Specifies where to write the cropped images as a Vista data file.
.IP "\fB-color\fP \fIcolor\fP"
Specifies the color of the cropping rectangle. For \fIcolor\fP you may use 
either a color name defined in the X11 color database (e.g., \fBred\fP) or 
a numerical color specification. (See ``COLOR NAMES'' under \fBX\fP(1) for 
details). Default: green. 
.IP "\fB-palette\fP \fBany\fP | \fBdefault\fP | \fBbest\fP | \fBgray\fP | \fBgrey\fP"
Normally \fBvxcrop\fP tries to use a palette of colors that gives it the
best chance of coexisting well with other X clients. This is called the
default palette. However, because it is designed to be shared, the default
palette often does not allow images to be displayed with the greatest
possible fidelity.  Specifying \fB-palette best\fP causes \fBvxcrop\fP to
instead use a palette optimized for displaying the most complete range of
common RGB colors (mostly reds and greens). Specifying \fB-palette gray\fP
(or \fBgrey\fP) causes it to use a palette optimized for displaying grey
shades. (When you choose \fBbest\fP, \fBgray\fP, or \fBgrey\fP, you may
find that \fBvxcrop\fP uses a different colormap than that used by other
windows on your screen, and you will then have to move the pointer into a
window for it to display correctly.) The default, \fBany\fP, means try for
the default palette, otherwise the best palette, otherwise the gray palette.
.IP "\fB-signed\fP"
Specifies that a zero pixel is to be shown as medium grey, negative pixels
as darker shades, and positive pixels as lighter shades.  If omitted,
intensity corresponds to absolute pixel values with zero shown as black.
.PP
Input and output files can be specified on the command line or allowed to
default to the standard input and output streams.
.SH "USER INTERFACE"
The program's window has a menu bar with File and Help menus. The File menu 
contains one command: 
.RS 2n
.IP "Save and Quit" 15n
Quit the program after writing the cropped images to \fIoutfile\fP.
.RE
.PP
The image currently being cropped is displayed below the menu bar. The 
following mouse actions can be used on it: 
.RS 2n
.IP "Left Button" 15n
Define the cropping rectangle (when clicked and dragged).
.IP "Middle Button"
Zoom in by a factor of two, centering on the pointer.
.IP "Right Button"
Zoom out by a factor of two, centering on the pointer.
.IP "Ctrl Middle Button"
Shift the image to center the pixel under the pointer.
.RE
At the bottom of the window the current image number is displayed, as are 
the current cropping parameters in this format: 
.RS
.PP
\fBRegion: [\fIrow\fP, \fIcolumn\fP]; \fIheight\fP x \fIwidth\fP\fR
.RE
.PP
\fIrow\fP and \fIcolumn\fP specify the origin (the upper left-hand
corner) of the cropping box, and \fIheight\fP and \fIwidth\fP specify the
size of the cropping box.
.SH "SEE ALSO"
.nh
.na
.BR vcrop (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi),
.br
.I OSF/Motif User's Guide
.ad
.hy
.SH AUTHORS
Daniel Ko <ko@cs.ubc.ca>,
Art Pope <pope@cs.ubc.ca>
