.ds Vn 2.1
.ds XD /usr/lib/X11/app-defaults
.TH vxviewe 1Vi "25 February 1994" "Vista Version \*(Vn"
.SH NAME
vxviewe \- viewer for Vista edge sets and images
.SH SYNOPSIS
\fBvxviewe\fR [\fB-\fIoption\fR ...] [\fIinfile\fR ...]
.SH DESCRIPTION
The \fBvxviewe\fP program displays Vista images and edge sets under X 
Windows. 
.PP
The Vista data files whose contents are to be displayed can be specified 
either on the command line or through a file selection dialog box. If files 
are specified on the command-line, \fBvxviewe\fP will start up displaying 
the first displayable object from the first file. Subsequent objects are 
presented by menu commands and/or keystrokes (see ``USER INTERFACE'', 
below). Alternatively, you may specify the files one at a time using a file 
selection dialog box while the program is running. Each time you choose a 
file from the dialog box, you will be shown the first displayable object of 
that file. Note that once you have used the dialog box to select a file, 
any unprocessed files left on the command line will be ignored.
.PP
How \fBvxviewe\fP displays an object depends on its type. If it's an 
image, then any objects currently shown will be removed and only the
new image will be displayed. If the object is an edge set, then the edges 
will be drawn overtop of any other objects currently shown. When only 
edge sets are being shown, they're drawn overtop of a black background.
.SH "COMMAND LINE OPTIONS"
The \fBvxviewe\fP program accepts the usual X Toolkit options options (see 
\fBX\fP(1)), plus the following:
.IP \fB-help\fP 15n
Prints a message describing options.
.IP "\fB-in\fP \fIinfile\fP ..."
May be used to specify one or more Vista data files that are to be read 
on startup. The first displayable object from the first file will be 
shown initially.
.IP "\fB-palette\fP \fBany\fP | \fBdefault\fP | \fBbest\fP | \fBgray\fP | \fBgrey\fP"
Normally \fBvxviewe\fP tries to use a palette of colors that gives it the
best chance of coexisting well with other X clients. This is called the
default palette. However, because it is designed to be shared, the default
palette often does not allow images to be displayed with the greatest
possible fidelity.  Specifying \fB-palette best\fP causes \fBvxviewe\fP to
instead use a palette optimized for displaying the most complete range of
common RGB colors (mostly reds and greens). Specifying \fB-palette gray\fP
(or \fBgrey\fP) causes it to use a palette optimized for displaying grey
shades. (When you choose \fBbest\fP, \fBgray\fP, or \fBgrey\fP, you may
find that \fBvxviewe\fP uses a different colormap than that used by other
windows on your screen, and you will then have to move the pointer into a
window for it to display correctly.) The default, \fBany\fP, means try for
the default palette, otherwise the best palette, otherwise the gray palette.
.IP "\fB-colors\fP \fIcolor\fP ..."
Specifies colors to use for drawing edge sets. For each \fIcolor\fP you may 
use either a color name defined in the X11 color database (e.g., \fBred\fP) 
or a numerical color specification. (See ``COLOR NAMES'' under \fBX\fP(1) 
for details). If this option is absent, or if the number of \fIcolor\fP's 
is less than the number of edge sets displayed, then default colors will be 
used.
.IP "\fB-widths\fP \fIwidth\fP ..."
Specifies the line widths used to draw the edge. The width of the first set 
of edges is specified by the first \fIwidth\fP, the second set by the 
second \fIwidth\fP, and so on. Each \fIwidth\fP is measured in image 
pixels; 0 produces a hairline. If this option is absent or the number of 
\fIwidth\fPs is less than the number of edge sets, then those edge sets 
with no corresponding \fIwidth\fP will have the default width of 0. 
.PP
Input files can be specified on the command line or allowed to default to 
the standard input stream.
.SH "USER INTERFACE"
The program follows the OSF/Motif user interface guidelines. For details on 
its use of standard interaction techniques (such as file selection and 
keyboard shortcuts) see the \fIOSF/Motif User's Manual\fP. 
.SS Menus
The progam's menu bar contains File, View, Info, Option and Help menus.
The File menu includes these commands: 
.RS 2n
.IP "Open..." 15n
Open a new data file and show its first displayable object.
.IP "Quit"
Quit the program.
.RE
.PP
The View menu includes these commands: 
.RS 2n
.IP "Next Object" 15n
Show the next displayable object in the current file (or in the current 
list of files if still showing files named on the command line).
.IP "Clear Image"
Clear the current image, leaving edge sets visible.
.IP "Clear Edges"
Clear the last edge set, leaving other objects visible.
.RE
.PP
The Info menu includes these commands:
.RS 2n
.IP "Image" 15n
Display information about the current image.
.IP "Edges"
Display information about the current edges.
.RE
.PP
The Option menu includes this command:
.RS 2n
.IP "Signed/Unsigned" 15n
Toggle between signed and unsigned interpretation of the image. With signed 
interpretation, a pixel value of 0 will be shown as medium grey, negative 
values as darker shades, and positive values as lighter shades. With unsigned 
interpretation, intensity corresponds to absolute pixel values with 0 shown 
as black. 
.RE
Most menu commands have keyboard shortcuts, which are displayed on the 
menus themselves. Ctrl-O, for example, is the shortcut for the Open 
command. 
.SS "Mouse Usage"
The program understands the following mouse button clicks:
.RS 2n
.IP "Left Button" 15n
Selects the image pixel and edge segment (if any) that are closest to the 
pointer. Information about the selected items will be displayed (see 
``Information Display'', below). A selected edge segment is highlighted in 
red. 
.IP "Middle Button"
Zoom in by a factor of two, centering on the pointer.
.IP "Right Button"
Zoom out by a factor of two, centering on the pointer.
.IP "Ctrl Middle Button"
Shift the image to center the pixel under the pointer.
.RE
.SS "File Selection"
Files are selected using the OSF/Motif file selection dialog box, which 
is rather fancy. 
.PP
One way to select a file is to type its name into the Selection field, 
then click OK or press the 
.SM ENTER
key.
.PP
A second way is to choose the file from among those presented in the 
Files list, which displays the files found in a single directory.
You can choose that directory and navigate among directories
using the Directory list.
.PP
The Files list only presents files whose names match the pattern in the 
Filter field. By default, this pattern is \fB*.v\fP, which by convention 
matches Vista data file names. To see other file names, edit the Filter 
field and click the Filter button. 
.SS "Information Display"
Information about selected items will be displayed at the bottom of the 
window in the following format:
.RS
.PP
.nf
\fBImage:\fP \fInrows\fP \fBx\fP \fIncolumns\fP\fB; Type:\fP \fIrepnType\fP; \fBBand:\fP \fIband\fP \fBof\fP \fInbands\fP
.br
\fBPixel:\fP \fIpixelPosition\fP\fB; Value:\fP \fI pixelValue \fP
.br
\fBEdge:\fP \fIedgeIndex\fP\fB; #Points:\fP \fInumPoints\fP\fB;\fP \fIfirstPoint\fP \fB->\fP \fIlastPoint\fP\fB; Fields:\fP \fIedgeFields\fP
.br
\fBPoint:\fP \fIpointIndex\fP\fB;\fP \fIpointPosition\fP\fB; Fields:\fP \fIpointFields\fP
.fi
.RE
.PP
The first two lines are shown only if a pixel is selected; the last two,
only if an edge and edge point are selected. The following table describes
the meaning of each field:
.RS 2n
.IP \fInrows\fP 15n
number of rows in the image
.IP \fIncolumns\fP
number of columns in the image
.IP \fIrepnType\fP
image's pixel representation
.IP \fIband\fP
band number of the band currently being displayed
.IP \fInbands\fP
number of bands in the image
.IP \fIpixelPosition\fP
row and column coordinates of the selected pixel
.IP \fIpixelValue\fP
value of the selected pixel; this value takes the form of a RGB triple if 
the image is a RGB color image 
.IP \fIedgeIndex\fP
index of the selected edge within its set
.IP \fInumPoints\fP
number of points in the selected edge
.IP \fIfirstPoint\fP
row and column coordinates of the selected edge's first point
.IP \fIlastPoint\fP
row and column coordinates of the selected edge's last point
.IP \fIedgeFields\fP
values of the edge fields associated with the selected edge
.IP \fIpointIndex\fP
index of the selected point in the edge containing it
.IP \fIpointPosition\fP
row and column coordinates of the selected point
.IP \fIpointFields\fP
values of the point fields associated with the selected point (except the 
first two fields) 
.RE
.SH FILE
.IP \*(XD/Vxviewe
contains resources required by \fBvxviewe\fP.
.SH "SEE ALSO"
.na
.nh
.BR vxview (1Vi),
.BR vxviewi (1Vi),
.BR VImage (3Vi),
.BR Vista (7Vi)
.hy
.ad
.SH NOTES
Floating point pixel values are clipped to the range [-1,+1] before being 
displayed.
.PP
The \fBvxviewe\fP program implements the editres protocol, which means that 
the \fBeditres\fP(1) may be used to examine the widget hierarchy and to set 
resource values determining appearance. 
.SH AUTHOR
Daniel Ko <ko@cs.ubc.ca>
